unit fer320;  { X86 }

  { reconfigure_stash has a funny list of primes. }
 
  { In bigger_node_total, the 256000 is simply a number big enough to handle the test
    cases I cared about. Nov 2002 }
		
		interface
  
 {$R-} 
 
 {$D-}


 uses  ferm120,  Macros, Types, Constants, Functions, Plheap; 
     {  Memory  ToolUtils, OSUtils}

var

  polygarb: poly;
  polynames, old_polynames, nilpol, 
         pseudo_polynames: polypt;  { nilpol is always nil, pseudo_polynames is 
			                             nil unless there is actually need for poly-
											     mod-out, when it is polynames. ~~~ always?}
  number_polys, mod_method_diff, gcdmass, mod_det_method_cut, gauss_cutoff, suppressor, { Oct 2003 }
       hgcd_cut, emgcd_basic_cut, rat_det_method_cut, poly_cutoff, div_poly_cutoff, siouxcols: longint;
  polyvar: array[1..max_number_polys] of nametype;  {~~~~} 
  laurent, wanthalf_: boolean;  { 30 July 1998 }
 
  number_col, colm_mass: hampath; { for Hamiltonian path. Nov 1996 }
  total_cnt, lowcnt: longint;
  
  sparse_number_col, sparse_mass: sparsedet; { for Sparse Det Minors. Nov 1996 }
  sp_total_cnt, sp_lowcnt, minorprime, minor_memory, minor_count, init_max_stash, init_min_stash,
       minor_total, min_stash_row, max_stash_row, purged_hits: longint;
  minorstash: sparseptr;  { Feb 1997 }
	
	global_list: test_array; { Nov 2001 }
	
	poly_1: poly;  { July 2003 }
	
	xx, yy, zz: gcd_ptr;  { Jan 2004 }
	
	colmar, polyar, quolyar, impar: ptr_array;  { Sep 2004 } 
  

 procedure newpoly(var p: poly);

 procedure newquoly(var q: quoly);

 procedure newpt(var p: polypt); 

 procedure newdummy(var s, pp3: polypt); 

 procedure free_pt(var p: polypt);  

 procedure init_poly_node(var p: poly);

 procedure init_quoly_node(var p: quoly);

 procedure free_poly(var p: poly);
 
 procedure special_free_poly(var p: poly);  { Dec 2002 }
 
 procedure remove_dummy(u: poly);
 
 procedure free_quoly(var q: quoly); 

 procedure poly_inplace(p: poly);
 
 procedure quoly_inplace(p: quoly); 
 
 function lastnum(n: poly): poly;
 
 function lastnode(n: poly): poly;
 
 { function poly_numterms(n: poly): longint;  Aug 2001. remove this declaration, Jul 2003 }
 
 function numterms(n: quoly): longint;   { Oct 1996 }
 
 function f_poly_numterms(n: poly): longint;  { Dec 2003. moved here }
 
 function qpoly_numterms(n: poly; depth: integer): longint;  { Jun 2006 }
 
 function poly_nodes(n: poly): integer;  { Oct 2002 }

 procedure poly_assign(p: poly; var q: poly);
 
 procedure one_var_poly_assign(p: poly; var q: poly);  { Aug 2004 }
 
 procedure spec_poly_assign(p: poly; var q: poly);  { Oct 2002 } 
 
 procedure node_assign(p: poly; var q: poly);  { Dec 1998 }

 procedure quoly_assign(p: quoly; var q: quoly);

 procedure one_var_quoly_assign(p: quoly; var q: quoly);  { Aug 2004 }

 procedure mod_quol_assign(p: quoly; var q: quoly);
 
 procedure add_pad(var r: poly; h: integer);  { moved here Jan 2002 }
 
 procedure quoly_to_poly(q: quoly; var p: poly);

 procedure poly_to_quoly(p: poly; var q: quoly);
 
 procedure p_q_assign(p: poly; var q: quoly);

 procedure polynum_to_quoly(var q: quoly);

 procedure get_char_poly(i, j: integer; var q: quoly);

 procedure dumpatt(messge: bigstring; n: longint; newline, multin, colon: boolean);
 
 procedure decr_dumpitt(n: longint; newline, multin: boolean);  { Sep 1996. Mar 2004 }
 
 procedure findHeight(var n, m: poly; var h: integer; var pt: polypt); 

 procedure max_degree(q: poly; lev: longint; var ans: longint);

 function first_coef_invrtble(q: poly; depth: integer): boolean;

 function invertible_coef(q: poly; pt: polypt): boolean;

 function sizepoly(p: poly): longint;  { Jul 2001 }
 
 procedure garbage(x: nametype);

 procedure restore_from_mod(var fx: fixptr);  {~~~~}

 procedure restore_sparsefix;    { Feb 2004 }

 procedure poly_makeneg(p: poly; var q: poly);
 
 procedure quoly_makeneg(p: quoly; var q: quoly);

 procedure scalar_to_poly(var n: number; var p: poly);
 
 procedure scalar_to_quoly(var n: number; var p: quoly);
 
 procedure spec_scalar_quoly(var n: number; var p: quoly);  { Oct 2000 }
 
 procedure poly_set(num: longint; var p: poly);
  
 procedure quoly_set(num: longint; var p: quoly);
 	
 procedure free_colm(var t: colm_ptr);  { moved July 1998 }
 
 function row_mass(t: colm_ptr): longint;    { Nov 1996 }
 
 function quick_row_mass(t: colm_ptr): longint;  { Nov 1996 }
 
 function depth_only_2(u: poly): boolean;  { Oct 2002 }
 
 procedure remove_col(spar: sparseptr; k, dim: longint; var w: imptr; var nu: numptr); { Nov 1996 }
 
 procedure ham_remove_col(spar: sparseptr; k, dim: longint; var w: imptr);  { Nov 1996 }
 
 function minorshash(md: imptr): longint;  { Feb 1997 }
 
 function minorsize(n: longint): longint;  { Feb 1997 }
 
 function minor_is_there(md: imptr; addr: longint; var n: quoly): boolean;  { Feb 1997 }
 
 function int_minor_is_there(md: imptr; addr: longint; var n: longint): boolean; { Jul 1999 }
 
 procedure stash_minor(md: imptr; addr: longint; var n: quoly);  { Feb 1997 }

 procedure int_stash_minor(md: imptr; addr: longint; n: longint); { Jun 1999 }
 
 procedure free_minor_stash(size: longint; var count, hits: longint);  { Feb 1997 }
 
 procedure count_minor_stash(var count, hits: longint);  { Nov 2001 }
 
 procedure free_minor_data(md: imptr);  { Feb 1997 }
 
 procedure update_col_list(md: imptr; index: integer; var spot: integer; var p: numptr); 
               { Feb 1997, Nov 2000 }
 
 procedure update_row_list(md: imptr; index: integer; var spot: integer; var p: numptr); 
               { Feb 1997, Nov 2000 }
 
 procedure restore_col(k: longint; w: imptr; nu: numptr); { Nov 1996 }
 
 procedure ham_restore_col(k: longint; w: imptr); { Nov 1996 }
 
 procedure remove_row(spar: sparseptr; row, k: longint; var u: colm_ptr); { Nov 1996 }
 
 procedure ham_remove_row(spar: sparseptr; row, k: longint; var u: colm_ptr); { Nov 1996 }
 
 procedure restore_row(spar: sparseptr; row, k: longint; u: colm_ptr); { Nov 1996 }
 
 procedure ham_restore_row(spar: sparseptr; row, k: longint; u: colm_ptr); { Nov 1996 }
 
 function permute(cp: colptr; i: longint): longint;  { August 1996 }

 procedure get_sparse_colm(sp: sparseptr; r, c: longint; var t: colm_ptrptr); { August 1996 }

 function get_sparse(r, c: longint; var t: colm_ptrptr; var isp: sparseptr): quolyptr;
                      { August 1996; Nov 2000 } 
 
 procedure standard_to_sparse(q: arrptr; var arr: workarray; cols: longint; 
                              arr_free: boolean);
 
 procedure purge_sparse(t: colm_ptrptr; c: longint);  { Nov 1997 }
 
 procedure sparse_zero_set(t: colm_ptrptr; c: longint; var qp: quolyptr);  { Nov 1997 }
 
 procedure sparse_set(r, c: longint; q: arrptr; var qp: quolyptr; colflag: boolean);
                                              { Dec 1997 }

 procedure quick_sparse_create(sp: sparseptr; let: tokentipe; r, c: longint; 
                               liner: boolean);     { Nov 2000 }
															 
 procedure sparse_insert(r, c: longint; q: arrptr; colflag: boolean; var n: quoly);
 
 procedure isparse_insert(r, c, n: longint; q: arrptr; colflag, assign: boolean);
                { Nov 1997 }
 
 procedure sparse_delete(r, c: longint; q: arrptr; colflag: boolean);  {@@@}
 
 procedure sparse_iszero(spar: sparseptr; rows: longint; var ans: longint);  {@@@}

 function sparse_allpolys(sp: sparseptr; rows: longint; var allnumbs: boolean): boolean;  { Mar 2004 }
 
 function sparse_allnumbs(sp: sparseptr; rows: longint): boolean; { Nov 2000. }
 
 function sparse_polydepth(sp: sparseptr; rows: longint): integer; { Feb 2004 }
 
 function anynegs(p: poly): boolean;  { Oct 2003 }
 
 function negexponents(var ar: workarray; m: longint): boolean;   { Oct 2003 }
 
 function sparse_negexponents(sp: sparseptr; m: longint): boolean;  { Oct 2003 } 
 
 procedure move_data_into_quoly(sp: sparseptr; rows: longint);  { Nov 2000. }
 
 procedure move_data_outof_quoly(sp: sparseptr; rows: longint);  { Nove 2000. }
 
 procedure put_back_sparse(dup, spar: sparseptr; rows: longint); { Nove 2000. }
 
 function pos_leading_coef(p: poly): boolean;
 
 function neg_leading_term(n: poly): boolean;
 
 procedure leading_term(q: quoly; var n: quoly);  { Nov 1997 }
 
 function convert_to_int(var n: number): longint;
 
 function quoly_convert_to_int(p: quoly): longint;
 
 function big_quoly_convert_to_int(p: quoly): longint;  { Dec 2005 }
 
 function do_mod_method_now(u, v: poly; mod_deg:longint; tried_modular: boolean): boolean;
 
 function mod_do_Chinese(u, v:poly; mod_deg: longint): boolean;
										
 function poly_length(n: poly): longint;
 
 function exp_poly_length(n: poly; var expon: longint; var one_var: boolean): longint; { Oct 2003 }
 
 function fast_poly_length(n: poly; cut: integer): integer;  {~~~~~}
 
 function poly_level(n: poly): longint; {~~~}
 
 procedure poly_level_depth(p, q: poly; ptd: integer; var lev, depth: integer); { Oct 2002 }
 
 function fast_numterms(n: poly): integer;  { Nov 2002 }
 
 function node_total(n: poly): integer;  {!!}
 
 function new_node_total(n: poly): integer;  { Jun 2005 }
 
 function big_node_total(n: poly): integer;  { Dec 2001 }
 
 function expon_node_total(n: poly; depth: longint; init: boolean; var expop: longint): integer;  { Dec 2005 }
 
 function bigger_node_total(n: poly): longint;  { Dec 2001; Nov 2002 }
 
 procedure sub_expons(u: poly; var utail: poly; uexp: longint); {!!}
 
 procedure restore_exps(u, utail: poly; uexp: longint); {!!}
 
 function prod_num_size(n, m: poly): longint;  { Jul 2001 }
 
 function prod_size(n, m: poly; toplevel: boolean): longint;  { Jul 2001 }
 
 function poly_mass(n: poly; multplier, depth: longint): longint;
 
 function full_poly_mass(n: poly; multplier, depth: longint): longint;
 
 function simple_poly_mass(n: poly): longint; {~~~~}
 
 function quoly_mass(n: quoly): longint;
 
 procedure poly_to_scalar(p: poly; var n: number);
 
 function poly_small(n: poly): boolean;
 
 function monomial(n: poly): boolean;
 
 procedure make_monomial(var p: poly; expo: longint; cf: poly);
 
 function rand_integer2: longint;
 
 function rand_integer3: longint;
 
 procedure random_field_element(var q: poly; height: integer; pt: polypt);
 
 procedure gcdhash(u, v: poly; var pr: poly); {~~~~}
 
 procedure init_gcd_stash; { Dec 2003 } 
 
 procedure free_gcd_stash; {~~~~}
 
 function is_array_param(p: quoly): boolean;
 
 function is_poly_name(x: nametype; var depth: longint): boolean;
 
 function is_poly_var(n: quoly; var depth: longint): boolean;  { July 2002 }
 
 function its_a_polyname(x: nametype): boolean;
 
 procedure is_poly_name2(x: nametype; var depth: longint; var q: polypt);  
 
 procedure delete_poly_name(depth: longint);
 
 procedure remove_poly_var(var q: quoly; depth: longint);
 
 procedure base_poly(var p: poly; depth: longint); 
  
 procedure base_quoly(var p: quoly; depth: longint);
 
 function poly_equal(p,q: poly): boolean;
 
 function poly_neg(p, q: poly): boolean; { Jul 2002, moved here }
 
 function essentially_equal(p, q: poly): boolean;
 
 function quoly_equal(p,q: quoly): boolean; 
 
 function quoly_negtive(p, q: quoly): boolean;  { Sep 2000}
 
 function poly_iszero(p: poly): boolean;
 
 function node_iszero(p: poly): boolean;
 
 function quoly_iszero(p: quoly): boolean;
 
 function lint_quoly_iszero(p: quoly): boolean;  { Jun 2006 }
 
 function poly_eq_1(p: poly): boolean;
 
 function poly_eq_m1(p: poly): boolean;
 
 function quoly_eq_1(p: quoly): boolean;
 
 function quoly_eq_m1(p: quoly): boolean;   { Jul 2002}
 
 function quol_neg_lead_term(n: quoly): boolean; 
 
 function quoly_larger(p,q: quoly): boolean;
 
 function poly_depth(p: poly): integer;
 
 function real_degree(p: poly; polydepth: integer): longint;  { Mar 2004 }
 
 function real_q_degree(q: quoly; polydepth: integer): longint; { Mar 2004 }
 
 function height_is_1(n: poly): boolean;
 
 function leading_coef(n: poly): poly;
 
 procedure quoly_consume(var n: quoly; var p: poly);
 
 procedure poly_change_from_mod(p: poly); 
 
 procedure poly_to_prime(n: poly);
 
 procedure dump_mons(q: arrptr; n: quoly; strip: boolean);  { Aug 1997; Aug 2002 }
 
 procedure quoly_change_from_mod(q: quoly);  { Sep 2004 }
 
 procedure add_prime_to_list(q: polypt; thisone, x: longint);
 
 procedure insert_new_prime(this_prime, x: longint; ii: imptrptr);  { May 1998 }
 
 procedure add_all_to_list(q: polypt; x: longint; var y: number);
 
 procedure poly_consume(var n: poly; var q: quoly);
 
 procedure use_up_poly(var n: poly; var q: quoly);  { Oct 2003 }
 
 procedure rat_number_mult(n: poly; im: imptr);
 
 procedure num_poly_quot(n: poly; var m: number; x: longint);
 
 procedure mod_num_poly_mult(n: poly; x: longint);
 
 procedure num_poly_mult(n: poly; var m: number);
 
 procedure monic_coefs(u, v: poly; var ucoef, vcoef: longint);
 
 function nogood(u: poly; depth, test_depth: integer): boolean;
 
 function is_prime(x: longint): boolean;
 
 procedure prime_factors(x: longint; var np: numptr);  {~~~~~}
 
 procedure set_prime_quotients(var qp: numptr; n: longint);  {~~~~~}
 
 function cant_factor(q: poly; var errno: longint; check_below: boolean): boolean;
 
 procedure find_gcdcoefs(p: poly; var com: number);
 
 procedure free_gcd_data(q: polypt);
 
 function imaxx(a, b: integer): integer;
 
 function depth_below(p: poly): integer;
 
 procedure copy_syst(var arr: workarray; rows: longint; var spar: sparseptr);{ Nov 1997 }
 
 function poly_height(p: poly): integer; {~~~}
 
 function mod_mult(var x,y,modul: longint): longint;
 
 function mod_add(x,y: Uint32; modul: longint): longint;  { Sep 2004 }
 
 function spec_mod_add(x: Uint32; y, modul: longint): longint;  { Sep 2004 }
 
 function mod_sub(var x, y, modul: longint): longint;
 
 function modmult(x,y: Uint32): longint; { Sep 2004 }
 
 function spec_modmult(x, y: Uint32): longint;  { Sep 2004 }
 
 procedure verse(var ans: longint); 
 
 procedure Set_prods_for_char;
	
 procedure initialize;
 
 function doing_polymod_field: boolean;  
 
 procedure newcolm(var q: colm_ptr);
 
 procedure switchrow_col(index, j, k, start, total_rows, target_rows, cols: longint);
 
 procedure poly_to_array(rows, start: longint; var p: poly);
 
 procedure fillup(rows, cols, start: longint; var arr: workarray);
 
 procedure intfindbest(start, stop, rows, i: longint; var j, k, val: longint); 
  
 procedure int_col_manip(j, k, start, rows: longint; var factor: number); { July 1998 }
 
 procedure reduce_it(var m, pseudodet, halfpseudo: number; wanthalf: boolean); { 30 July 1998 }
 
 procedure int_col_neg(j, k, start, rows: longint);  { 30 July 1998 }
 
 procedure int_arr_col_neg(var arr: workarray; j, rows: longint);  { 30 July 1998 }
 
 procedure int_row_neg(j, k, start, rows, cols: longint);  { 30 July 1998 }
 
 procedure sp_row_neg(j: longint; sp: sparseptr);  { Aug 1998 }
 
 procedure sp_col_neg(j, start, rows: longint; sp: sparseptr);  { Aug 1998 }
 
 procedure int_arr_row_neg(var arr: workarray; j, rows, cols: longint);  { 30 July 1998 }
 
 procedure sparse_intfindbest(sp: sparseptr; rows, i: longint; var j, k, 
                              val: longint);  { June 1998 }
 
 procedure sparse_best_diag(sp: sparseptr; rows, i: longint; var j,
                            val: longint);   { July 1998 }
                                
 procedure sp_switchrow(sp: sparseptr; i, j: longint);
  
 procedure sp_switchcol(sp: sparseptr; i, k, rows, start: longint);
 
 procedure sparse_findbest(leave_early: boolean; sp: sparseptr; rows, i: longint; 
                           var j, k: longint);  { Nov 2000 }
 
 procedure mod_sparse_findbest(leave_early: boolean; sp: sparseptr; rows, i: longint; 
                           var j, k: longint);  { June 1998 } { Nov 2000 }
 
 procedure special_mod_sparse_findbest(leave_early: boolean; sp: sparseptr; rows, i: longint; 
                           var j, k: longint);  { Nov 2000 }

 procedure findbest(start, stop, rows, i: longint; var j, k: longint;
                    firstonly: boolean);  { Apr 1999 }
 
 procedure colfindbest(start, rows, i, col: longint; var j: longint);  { Oct 2000 } 
 
 procedure sparse_colfindbest(sp: sparseptr; rows, i, col: longint; var j: longint); { Nove 2000 } 
 
 procedure sparse_mod_colfindbest(sp: sparseptr; rows, i, col: longint; var j: longint); 
                                 { Nove 2000 } 
 
 procedure free_stuff(spar: sparseptr; row: longint);  { Nov 1996 }
 
 procedure free_sparse(var spar: sparseptr; dim: longint; arr_free: boolean);
 
 procedure free_sparse_frame(var spar: sparseptr; dim: longint);
 
 procedure copy_sparse(var s, t: sparseptr; dim: longint; neg: boolean);
 
 procedure special_copy_sparse(var s, t: sparseptr; dim: longint);  { Aug 2004 }
 
 procedure one_var_copy_sparse(var s, t: sparseptr; dim: longint);  { Aug 2004 }
  
 procedure spar_identi(var spar: sparseptr; rows: longint; arr_free: boolean);
 
 procedure flip_sparse(var spar, spar2: sparseptr; row, col: longint); { moved July 1998 }
	
 procedure trans_sparse(var spar: sparseptr; row, col: longint);   { moved July 1998 }
	 
 procedure sparse_set_scalar(q: arrptr; cols: longint; n: quoly); 
 
 procedure sparse_init(var spar: sparseptr; r: longint); 
 
 procedure sparse_makeneg(var spar: sparseptr; rows: longint; var arr_free: boolean);
	  
 procedure swap_rows(var n: quoly; var dup: workarray; want_n, 
                     do_all: boolean; i, j, m: longint);  {~~~~}
					
 procedure spec_swap_rows(var dup: workarray;  i, j, rows: longint); { Apr 1999 }
 
 procedure swap_cols(var arr: workarray; i, j, rows: longint);
  
 procedure identi(var arr: workarray; rows: longint; arr_free: boolean);
  
 procedure uppertri(var arr: workarray; rows: longint);  { Apr 1999 }
 
 procedure best_on_diag(start, stop, rows, i: longint; var j, val: longint);  { July 1998 }
 
 procedure best_other(start, stop, i, rows: longint; var j: longint);  { July 1998 }
 
 procedure row_red_arr(var arr: workarray; factor: number; rows, k, q: longint); { July 1998 }
 
 procedure col_red_arr(var arr: workarray; factor: number; rows, k, q: longint); { July 1998 }
 
 procedure int_rowreduce(start, i,j,k,t,rows,stop: longint; var j2,k2,  { July 1998 }
                          val2: longint; wantsmallest: boolean; var factor: number;
								  wantmod, wanthalf: boolean; var pseudodet, halfpseudo: number);
								  
 procedure int_colreduce(start, i,j,k,t,rows: longint; var j2,k2,  { July 1998 }
                          val2: longint; wantsmallest: boolean; var factor: number;
								  wantmod, wanthalf: boolean; var pseudodet, halfpseudo: number);
								  
 procedure sparse_int_rowred(t, u: colm_ptrptr; k,tg: longint; var j2,
                           k2, val2: longint; wantsmallest: boolean; var factor: number;
								           wantmod, wanthalf: boolean; var pseudodet, halfpseudo: number);  
								   { July 1998 }  { Oct 2000 }
  
 procedure sparse_int_colred(sp: sparseptr; init,j,k,tg,rows: longint; var j2,k2,
                           val2: longint; wantsmallest: boolean; var factor: number;
								           wantmod, wanthalf: boolean; var pseudodet, halfpseudo: number);  
								   { June 1998 }
								   
 procedure sparse_mod_col_add(sp: sparseptr; factor, rows, k, q: longint);  { Nove 2000 }
 
 procedure sparse_mod_row_add(sp: sparseptr; factor, k, q: longint);   { Nove 2000 }
 
 procedure sparse_mod_divide_row(sp: sparseptr; factor, k: longint); { Nove 2000 }
 
 procedure sparse_mod_mult_col(sp: sparseptr; factor, rows, k: longint);  { Nove 2000 }
 
 procedure fast_colreduce(start, j,k,t,rows: longint; var j2,k2,val2: longint;
                           var factor: number);  { July 1998 }
                           
 procedure fast_sparse_colred(sp: sparseptr; init,j,k,tg: longint; var j2,k2,
                              val2: longint; var factor: number);  { June 1998 }
                               
 procedure sparse_best_other(sp: sparseptr; i, rows: longint; var j: longint);  { July 1998 }
						  	
 function size_of(value, size: longint): longint;
 
 function hash(x: nametype; prime: integer): integer;  { moved Nov 2000 }
 
 function disper(n: longint): longint;  { July 1998 }
 
 procedure clear_bads(var p, exps, tail: poly; value: longint; depth: integer);  { moved Jan 2002 }
 
 procedure eliminate_bads(var p, exps: poly; factor: longint);  { moved Jan 2002 }
 
 procedure put_poly_disk(p: poly);  { Jul 2001 }
 
 procedure get_poly_disk(var p: poly);  { Jul 2001 }
 
 procedure sort_vars(q: sort_ptr; size: integer);   { Jul 2002 }
 
 procedure killdenoms(spar: sparseptr; spot, total_rows, target_rows, cols: longint); { Jul 2002 }
 
 function clean_degree(u: poly): longint;  { Jul 2004 }
 
 function sparse_one_var_polys(sp:sparseptr; rows: longint): boolean; { Jul 2004 }
 
 procedure egcd_ints(var n, m, x, y: longint);  { Jul 2004 }
 
 procedure parttion(var par: ptr_array; i, j: longint; var r: longint; var hit: boolean);  { Jul 2004 }
 
 procedure quiksort(var par: ptr_array; i, j: longint); { Jul 2004 }
 
 procedure clean_up_colm;  { Jul 2004 }
 
 function its_a_square(n: longint): boolean;  { Dec 2004 }

 procedure mult_expons(p: poly; n: longint);  { Feb 2005 }
 

 



implementation


 procedure newpoly { (var p: poly) };
	
    begin
       if polygarb = nil
          then new(p)  { := poly(newptr(polynodesize))}
          else begin
                  p := polygarb;
                  polygarb := polygarb^.next
               end
						 
	 end;
						 
 {***************************************************************}
  
 procedure newquoly { (var q: quoly) };
	
    begin
      if quolygarb = nil
         then new(q)  { := quoly(newptr(quolysize))}
         else begin
                 q := quolygarb;
                 quolygarb := quolygarb^.next
              end
						 
	end;
						 
 {***************************************************************}
  
 procedure newcolm { (var q: colm_ptr) };
	
    begin
      if colm_garb = nil
         then new(q) { := colm_ptr(newptr(sizeof(colnode)))}
         else begin
                 q := colm_garb;
                 colm_garb := colm_garb^.next
              end
						 
	end; 
						 
 {******************************************************************}
  
 procedure newpt { (var p: polypt) ~~};
	
    begin
       if pt_garb = nil
          then new(p)
          else begin
                  p := pt_garb;
                  pt_garb := pt_garb^.next
               end;
			 p^.modls := -1; 
			 p^.field := false;
			 p^.alt := nil;
			 p^.pwr := nil;
			 p^.multdata := nil;
			 p^.roots := nil;
			 p^.gcd_data := nil;
			 p^.next := nil;
			 p^.aux_num := 0;
			 p^.polycut := poly_cutoff; {@@@}
			 p^.p := nil
	 end;

 {******************************************************************}
  
 procedure newdummy { (var s, pp3: polypt) ~~};
	
    begin  
       newpt(pp3);
			 with pp3^ do
				 begin
					 next := s^.next;  depth := s^.depth; { the important things }
					 let := s^.let;
					 expon := s^.expon
				 end
	 end;

 {******************************************************************}
 
 procedure free_pt { (var p: polypt) ~~};
 
  begin

	   p^.next := pt_garb;
	   pt_garb := p;
		 free_poly(p^.p); 
		 free_poly(p^.alt);
		 free_poly(p^.roots);   {~~~~~}
		 free_poly(p^.multdata);  {~~~~~}
		 free_gcd_data(p)

	end;

 {***************************************************************}

 procedure init_poly_node { (var p: poly) };

    begin

	   newimag(p^.ncoef); 
	   p^.ncoef^.size := 0

	end;

 {***************************************************************}

 procedure init_quoly_node { (var p: quoly) };

    { leaves p freeable.  Oct 2003 }
		
    begin

	    newimag(p^.ncoef);
	    p^.ncoef^.size := 0

	end;
	
 {******************************************************************}

 procedure free_poly { (var p: poly) };

    { assume p <> nil means there is something to be freed. p is left nil}

    var q,tail: poly;

    begin

	   q := p;	   
	   while q <> nil do
	      begin
		     if q^.numb
			     then free_imag(q^.ncoef)
			     else free_poly(q^.pcoef);
			  if q^.next = nil then tail := q;
			  q := q^.next
		   end;
	   if p <> nil 
	      then begin
		           tail^.next := polygarb;
	              polygarb := p;
	              p := nil
			     end 
			   
	end;
	
 {******************************************************************}
 
 procedure special_free_poly; { (var p: poly);   Dec 2002 }
    { all nodes are numb, p <> nil }
    var q,tail: poly;
    begin
       q := p;	   
	     while q <> nil do
	        begin
		         if q^.ncoef <> nil
			          then free_imag(q^.ncoef);
			       if q^.next = nil then tail := q;
			       q := q^.next
		      end;
       tail^.next := polygarb;
	     polygarb := p;
	     p := nil
    end;
 
 {******************************************************************}
 
 procedure remove_dummy; {(u: poly)}
    { u^.exp = 0 and u^.pcoef is a number.  Oct 1996 }
    var t: poly;
	 begin
		 u^.numb := true;
		 t := u^.pcoef;
		 u^.ncoef := t^.ncoef;
		 t^.next := polygarb;
		 polygarb := t
	 end;
																
 {******************************************************************}

 procedure free_quoly { (var q: quoly) };

    { assume q <> nil means there is something to be freed. q is left nil }

    begin

	   if q = nil
	      then exit(free_quoly);
	   if q^.numb
		   then free_imag(q^.ncoef)
		   else begin
		           free_poly(q^.numer);
			        if q^.denom <> nil 
				        then free_poly(q^.denom);
			     end;
	   q^.next := quolygarb;
	   quolygarb := q;
	   q := nil

	end;

 {*************************************************************************}

 procedure poly_inplace { (p: poly) Apr 2004 looks OK large modulus } ;

   var num: longint;

	 begin
	   
	   while p <> nil do
	      begin
		      if p^.numb
				    then if modularmode 
					         then if not finf  { Sep 2004 }
					                 then begin
																   num := modulus - p^.ncoef^.lint;
																   if num = modulus 
																	   then p^.ncoef^.lint := 0
																	   else p^.ncoef^.lint := num
													      end
													 else
								else if lintmode
								        then p^.ncoef^.lint := - p^.ncoef^.lint
								else in_place_neg(p^.ncoef^)
				    else poly_inplace(p^.pcoef);
			    p := p^.next
		    end 
		  
	end;
	
 {*************************************************************************}

 procedure quoly_inplace { (p: quoly)} ;

    begin
	   
	   if p^.numb
		   then in_place_neg(p^.ncoef^)
		   else poly_inplace(p^.numer);
		  
	end;
	
 {*************************************************************************}

 function lastnum; { (n: poly): poly; }

    begin

	   while n^.next <> nil do
	      n := n^.next;

	   if n^.numb
	      then lastnum := n
		   else lastnum := n^.pcoef

    end;

 {*************************************************************************}
 
 function lastnode; { (n: poly): poly; }
  
    begin
	   
	   while n^.next <> nil do
	      n := n^.next;
		  
	   lastnode := n
	    
    end;
	
 {*************************************************************************}
 
{ function lastptrr; { (n: poly): polyptrr; !!
    
	 var q: polyptrr;
	 
    begin
	   
	   q := @ n;
		while q^^.next <> nil do
	      q := @ q^^.next;
		  
	   lastptrr := q
	    
    end;  }
	
 {*************************************************************************}
 
 procedure poly_set { (num: longint; var p: poly) };
 
	begin
	
	   free_poly(p);
	   newpoly(p);
	   p^.next := nil;
	   p^.exp := 0;
	   p^.numb := true;
	   init_poly_node(p);
	   if lintmode
		   then p^.ncoef^.lint := num
			else setvalue(num, p^.ncoef^)
	
	end;
		
 {*************************************************************************}
 
 procedure quoly_set { (num: longint; var p: quoly) };
 
	{ May 2001: Note that we do not set arr_arg here. }
	
	begin
	
	   free_quoly(p);
	   newquoly(p);
	   p^.numb := true;
	   init_quoly_node(p);
	   setvalue(num, p^.ncoef^)
	   
	end;   
		
 {***************************************************************************}
 
 function sizenumber(p: imptr): longint;
    var k: longint;
    begin
       k := numbersize;
       if not lintmode
          then k := k + p^.size * numnodesize;  
       sizenumber := k
    end;
    
 {**************************************************************************}
 
 function sizepoly;  {(p: poly): longint; Jul 2001 }
    var k: longint;
    begin
       k := 0;
       while p <> nil do
          begin
             k := k + polynodesize; 
             if p^.numb
                then k := k + sizenumber(p^.ncoef)
                else k := k + sizepoly(p^.pcoef);
             p := p^.next
          end;
       sizepoly := k
    end;
	    
 {************************************************************************}

 function sizequoly(q: quoly): longint;
    { q <> nil }
    
    begin
       
       if q^.numb
          then sizequoly := quolysize + sizenumber(q^.ncoef)  
          else sizequoly := quolysize + sizepoly(q^.numer) + sizepoly(q^.denom)
          
    end;
    
 {************************************************************************}
 
 function mass_gcd_stash: longint;  {@@@ June 1996}
    
    var i, k: longint;
	     q: quoly;
	 
	 begin
	 
	    k := 0;
		 for i := 0 to gcd_table_size do
		    if gcd_stash[i] <> nil 
			    then begin
				         q := gcd_stash[i];
							while q <> nil do
							   begin
							      k := k + sizequoly(q);
							      q := q^.next
							   end
					   end;
		 mass_gcd_stash := k
		 
	 end;					   

  {*************************************************************************}

  procedure garbage { (x: nametype) } ;

    var p: numptr;
        n, tot, i: longint;
	      q: imptr;
	      t: varptr;
			  u: arrptr;
			  v: poly;
			  w: quoly;
			  z: nameptr;
			  s: sparseptr;
			  c: colm_ptr;
			  f: fixptr;
			  pt: polypt;
			  fp: formptr;
			  cp: condexptr;
			  cl: colptr;

    begin

      p := numhead;                 
      n := 0;
		  tot := 0;
      while p <> nil do
        begin
          if x = 'G'
             then writeln(output, p^.value);
          n := n + 1;
          p := p^.next
        end;
      writeln(output, 'num count: ', n: 5);
		  tot := tot + numnodesize*n;
			
      q := imhead;
      n := 0;
      while q <> nil do
        begin
          n := n + 1;
          q := q^.imag
        end;
      writeln(output, 'im count: ', n: 5);
		  tot := tot + numbersize*n;
			
      t := var_garb;
      n := 0;
      while t <> nil do
        begin
          n := n + 1;
		    if x = 'G'
            then writeln(output, t^.let.name);
          t := t^.next
        end;
      if n > 0
		   then writeln(output, 'var count: ', n: 5);
	   tot := tot + 26*n;
			
      u := arr_garb;
      n := 0;
      while u <> nil do
        begin
          n := n + 1;
		    if x = 'G'
             then writeln(output, u^.name.name);
          u := u^.next
        end;
      tot := tot + 40*n;
		if n > 0
		   then writeln(output, 'array count: ', n: 5);  
			
      z := name_garb;
      n := 0;
      while z <> nil do
        begin
          n := n + 1;
		    if x = 'G'
             then writeln(output, z^.let.name);
          z := z^.next
        end;
      tot := tot + 23*n;
		if n > 0
		   then writeln(output, 'name count: ', n: 5);
			
	   f := fixgarb;
      n := 0;
      while f <> nil do
        begin
          n := n + 1;
		    f := f^.next
        end;
      tot := tot + 13*n;
		if n > 0
		   then writeln(output, 'fix count: ', n: 5);
		
		v := polygarb;
      n := 0;
      while v <> nil do
        begin
          n := n + 1;
		    if x = 'G'
            then writeln(output, v^.exp); 
          v := v^.next
        end;
      writeln(output, 'poly count: ', n: 5);
		tot := tot + polynodesize*n;
	 
	   w := quolygarb;
      n := 0;
      while w <> nil do
        begin
          n := n + 1;
          w := w^.next
        end;
      writeln(output, 'quoly count: ', n: 5);
		tot := tot + quolysize*n;
		
		s := spargarb;
      n := 0;
      while s <> nil do
        begin
          n := n + 1;
          s := s^.next
        end;
      tot := tot + (sparsesize*4+5)*n;
		if n > 0
		   then writeln(output, 'sparse count: ', n: 5);

		c := colm_garb;
      n := 0;
      while c <> nil do
        begin
          n := n + 1;
          c := c^.next
        end;
      tot := tot + 12*n;
		if n > 0
		   then writeln(output, 'colm count: ', n: 5);
			
	   cl := colgarb;
		n := 0;
      while cl <> nil do
        begin
          n := n + 1;
          cl := cl^.next
        end;
      if n > 0
		   then writeln(output, 'matrix col count: ', n: 5);
	   tot := tot + 16*n;		
		
		pt := pt_garb;  
      n := 0;
      while pt <> nil do
        begin
          n := n + 1;
          pt := pt^.next
        end;
      if n > 0
		   then writeln(output, 'poly pointer count: ', n: 5);
	   tot := tot + 31*n;
		
		fp := formhead;  
      n := 0;
      while fp <> nil do
        begin
          n := n + 1;
          fp := fp^.next
        end;
      if n > 0
		   then writeln(output, 'form node count: ', n: 5); {~~~}
	   tot := tot + 12*n;
		
		cp := condhead;  
      n := 0;
      while cp <> nil do
        begin
          n := n + 1;
          cp := cp^.next
        end;
      if n > 0
		   then writeln(output, 'cond expr count: ', n: 5); {~~~}
	   tot := tot + 21*n;
		
		n := 1;
		{ you can't just use first_available below. }
		while n <= worksize do 
		   if workhead[n] = nil
			   then leave
				else n := n + 1;
	  tot := (n-1)*arr_limit*4 + tot;
		if n > 1
		   then writeln(output, 'work arrays: ', n-1:5); {~~~~}
		   		
		writeln(output, 'total garbage (bytes): ', tot: 7);
		plflush(output);
		
		n := mass_gcd_stash + size_data_structs;
		if (dupptr <> nil) and (duparr^.name.name = 'dup')  {@@@}
	      then for i := 0 to duparr^.stop do
			        n := n + sizequoly(dupptr^[i]);
		writeln(output, 'system data size: ', n:7);  {@@@}
      tot := n + tot;
		writeln(output, 'total size: ', tot: 8);  {@@@}
	   plflush(output)

    end;

 {*************************************************************************}
 
 procedure poly_assign { (p: poly; var q: poly) };
 
    { q must be initialized }
 
    var dup, t: poly;
	    first: boolean;
 
    begin
	   
	   first := true;
	   while p <> nil do
	      begin
		     if first
			    then begin
				        newpoly(dup);
						  t := dup;
						  first := false
				      end
				 else begin
				        newpoly(t^.next);
						  t := t^.next
					   end;
		     t^.pcoef := nil;
			  t^.numb := p^.numb;
			  t^.exp := p^.exp;
		     if p^.numb
			    then begin
				        init_poly_node(t);
				        if lintmode
						     then t^.ncoef^.lint := p^.ncoef^.lint
							  else num_assign(p^.ncoef^, t^.ncoef^)
					   end
			    else poly_assign(p^.pcoef, t^.pcoef);
			  p := p^.next
		  end;
		  
	   t^.next := nil;
	   free_poly(q);
	   q := dup
		  
	end;
	
 {*************************************************************************}
 
 procedure one_var_poly_assign { (p: poly; var q: poly) };
 
    { q must be NULL. no laurents.   Aug 2004 }
 
    var dup, t: poly;
	      first: boolean;
 
    begin
	   
	    first := true;
	    
	    { move past dummy 0 nodes }
      if not p^.numb
         then while p^.exp = 0 do
                 p := p^.pcoef;
      
	    while p <> nil do
	       begin
			     if first
				     then begin
					           newpoly(dup);
							       t := dup;
							       first := false
					        end
					   else begin
					           newpoly(t^.next);
							       t := t^.next
						      end;
			       t^.pcoef := nil;
				     t^.numb := p^.numb;
				     t^.exp := p^.exp;
				     if p^.numb
						    then begin
								        init_poly_node(t);
								        if lintmode
										       then t^.ncoef^.lint := p^.ncoef^.lint
											     else num_assign(p^.ncoef^, t^.ncoef^)
								     end
						    else poly_assign(p^.pcoef, t^.pcoef);
					   p := p^.next
		     end;
		  
	   t^.next := nil;
	   q := dup
	   
	 end;
	
 {*************************************************************************}
 
 procedure spec_poly_assign; {(p: poly; var q: poly);   Oct 2002 }
 
    { q = nil on entry. q <> p. p <> nil. p is not a number (but it works fine if
      p is a numb). used only  by general_content. duplicate nodes at this level, 
      but not below, and no numbers. }
 
    var tp: polyptrr;
 
    begin
	   
	    tp := @ q;
	    while p <> nil do
	       begin
			      if p^.numb
					     then begin
						           tp^ := p;
								       exit(spec_poly_assign)
						        end
						   else newpoly(tp^);
			      tp^^.numb := false;
				    tp^^.exp := p^.exp;
				    tp^^.pcoef := p^.pcoef;
				    tp := @ tp^^.next;
					  p := p^.next
		     end;
		  
	   tp^ := nil
	   
	 end;
 
 {*************************************************************************}
 
 procedure node_assign { (p: poly; var q: poly) };
 
    { p is a number.  Like poly_assign, only make sure to take only one node 
      from p (i.e. beware Laurent). q must be initialized. Dec 1998 }
 
    var t: poly;    
 
    begin
	   
		   newpoly(t);
			 t^.numb := true;
			 t^.exp := 0;
			 init_poly_node(t);
			 if lintmode
				  then t^.ncoef^.lint := p^.ncoef^.lint
				  else num_assign(p^.ncoef^, t^.ncoef^);		  
		   t^.next := nil;
		   free_poly(q);
		   q := t
		  
	end;
	
 {*************************************************************************}
 
 procedure quoly_to_poly; { (q: quoly; var p: poly)}
 
    { q is a number and p is nil (or irrelevant), don't touch q. 
	  Convert to "poly number" format. }
	
	begin
	 
	   newpoly(p);
	   p^.next := nil;
	   p^.exp := 0;
	   p^.numb := true;
	   init_poly_node(p);
	   num_assign(q^.ncoef^, p^.ncoef^)
		  
	end;
	
 {**************************************************************************}
 
 procedure add_pad; {(var r: poly; h: integer)}
 
    { r is not a number. h must be positive! }
 
    var s,t: poly;
	      i: integer;
	
	  begin
	
			 for i := 1 to h do
					begin
						 if i = 1
								then begin
												newpoly(s);
												t := s
										 end
								else begin
												newpoly(t^.pcoef);
												t := t^.pcoef
										 end;
						 t^.exp := 0;
						 t^.next := nil;
						 t^.numb := false
					end;
			 t^.pcoef := r;
			 r := s
				
	  end;
	
 {*************************************************************************}
 
 procedure poly_to_quoly; {(p: poly; var q: quoly)}
 
    { p is a number and q is nil, don't touch p. Convert to "quoly number" format. }
	
	begin
	 
	   newquoly(q);
	   q^.numb := true;
	   init_quoly_node(q);
	   num_assign(p^.ncoef^, q^.ncoef^)
		   
	end;
	
 {*************************************************************************}
 
 procedure p_q_assign; {(p: poly; var q: quoly)}
 
    { p is converted to q.  p is read only. }
	
	begin
	
	   free_quoly(q);
	   if p^.numb & (p^.next = nil)
	      then poly_to_quoly(p, q)
		   else begin
		          newquoly(q);
		          q^.numb := false;
		          q^.rat := false;  { added Sept 1996!  apparent bug! }
				    q^.numer := nil;
				    q^.denom := nil;
				    poly_assign(p, q^.numer)
			     end			
	   
    end; 
 
 {************************************************************************}
 
 procedure polynum_to_quoly; {(var q: quoly)}  
 
    { q is illegal quoly - its numer is a number, and its denom is nil. }
	
	var n: poly;
  
    begin
	
	   q^.numb := true;
	   n := q^.numer;
	   q^.ncoef := n^.ncoef;
	   n^.next := polygarb;
	   polygarb := n
	   
	end;
	   
 {*************************************************************************}
 
 procedure quoly_assign { (p: quoly; var q: quoly) };
    
	var dup: quoly;
 
    begin
	
	   newquoly(dup);
	   if p^.numb
	      then begin
					  init_quoly_node(dup);
					  num_assign(p^.ncoef^, dup^.ncoef^)
				  end
		  else begin
		          dup^.numer := nil;
				    dup^.denom := nil;
					 dup^.rat := p^.rat & not lintmode;
				    poly_assign(p^.numer, dup^.numer);
				    if p^.denom <> nil
				       then poly_assign(p^.denom, dup^.denom)
			   end;
	   dup^.numb := p^.numb;
	   free_quoly(q);
	   q := dup
	   
	end;
	
 {*************************************************************************}
 
 procedure one_var_quoly_assign { (p: quoly; var q: quoly)  Sep 2004 };
    
	  var dup: quoly;
 
    begin
	
	    newquoly(dup);
	    if p^.numb
	      then begin
					      init_quoly_node(dup);
					      num_assign(p^.ncoef^, dup^.ncoef^)
				     end
		  else begin
		          dup^.numer := nil;
				      dup^.denom := nil;
					    dup^.rat := p^.rat & not lintmode;
				      one_var_poly_assign(p^.numer, dup^.numer)
				      { p^.denom is nil }
			    end;
	   dup^.numb := p^.numb;
	   free_quoly(q);
	   q := dup
	   
	 end;
	
 {*************************************************************************}
 
 procedure mod_quol_assign { (p: quoly; var q: quoly) };
 
    { q is nil or discardable. }
    
    begin
	
	   newquoly(q);
	   init_quoly_node(q);
      q^.ncoef^.lint := p^.ncoef^.lint;
	   q^.numb := true
	   
	end;
	
 {*************************************************************************}
 
 procedure poly_makeneg { (p: poly; var q: poly) };
 
    { q must be initialized }
 
    var dup, t: poly;
	      first: boolean;
		    num: longint;
 
    begin
	   
	   first := true;
	   while p <> nil do
	      begin
		     if first
			    then begin
				        newpoly(dup);
						    t := dup;
						    first := false
				      end
				else begin
				        newpoly(t^.next);
						    t := t^.next
					   end;
		    t^.pcoef := nil;
			  t^.numb := p^.numb;
			  t^.exp := p^.exp;
		    if p^.numb
			    then begin
				         init_poly_node(t);
				         if modularmode
									 then if finf  { Sep 2004 }
                           then t^.ncoef^.lint := p^.ncoef^.lint
                        else begin
															  num := modulus - p^.ncoef^.lint;
															  if num = modulus 
																   then t^.ncoef^.lint := 0
																   else t^.ncoef^.lint := num
														 end
								 else if lintmode
								        then t^.ncoef^.lint := - p^.ncoef^.lint
								 else makeneg(p^.ncoef^, t^.ncoef^)
					     end
			    else poly_makeneg(p^.pcoef, t^.pcoef);
			 p := p^.next
		  end;
		  
	   t^.next := nil;
	   free_poly(q); 
	   q := dup
		  
	end;
	
 {*************************************************************************}
 
 procedure quoly_makeneg { (p: quoly; var q: quoly) };
 
    var dup: quoly;
	
	begin
	
	   newquoly(dup);
	   if p^.numb
		  then begin
				   init_quoly_node(dup);
				   makeneg(p^.ncoef^, dup^.ncoef^)
			    end
		  else begin
		          dup^.numer := nil;
				    dup^.denom := nil;
					 dup^.rat := p^.rat & not lintmode;
				    poly_makeneg(p^.numer, dup^.numer);
				    if p^.denom <> nil
				       then poly_assign(p^.denom, dup^.denom)
			   end;
	   dup^.numb := p^.numb;
	   free_quoly(q);
	   q := dup
	   
	end;

 {*************************************************************************}
 
 procedure scalar_to_poly { var n: number; var p: poly };
 
    { n and d are used up by this procedure and get attached to p.
	  DO NOT REFER AGAIN TO N ! }
 
    begin
	
	   free_poly(p);
	   newpoly(p);
	   p^.next := nil;
	   p^.exp := 0;
	   p^.numb := true;
	   init_poly_node(p);
	   p^.ncoef^ := n
	    
	end;
	
 {*************************************************************************}
 
 procedure scalar_to_quoly { var n: number; var p: poly };
 
    { n and d are used up by this procedure and get attached to p.
	  DO NOT REFER AGAIN TO N ! }
 
    begin
	
	   free_quoly(p);
	   newquoly(p);
	   p^.numb := true;
	   init_quoly_node(p);
	   p^.ncoef^ := n
	   
	end;
	
 {*************************************************************************}
 
 procedure spec_scalar_quoly; {(var n: number; var p: quoly);  Oct 2000 }
    
    { n is array data, so is always in rational mode. n is NOT consumed. }
    
    begin
    
       free_quoly(p);
	     newquoly(p);
	     p^.numb := true;
	     init_quoly_node(p);
	     if lintmode
	        then if n.size = 1
	                then p^.ncoef^.lint := n.head^.value
	                else begin
	                        p^.ncoef^.lint := n.head^.value;
	                        writeln(' ** Warning. value is too large to display correctly.')
	                     end
	        else num_assign(n, p^.ncoef^)
       
    end;
 
 {*************************************************************************}
 
 procedure poly_to_scalar { (p: poly, var n: number) };
 
    { assume that p is a number. p is left untouched }
  
    begin
	
	   num_assign(p^.ncoef^, n)
	   
	 end;
	
 {*************************************************************************}
 
 function pos_leading_coef { (p: poly): boolean };
 
    { is the leading coef positive?  used only by poly_display. }
	 
    var xx: longint;  { was integer!?! Aug 1994 }
	 
    begin
	
	   if p^.numb 
	      then if lintmode
			        then if modularmode & alt_form_display  {~~~~}
					          then begin
							            xx := p^.ncoef^.lint;
											if xx > half_modulus
											   then xx := xx - modulus;
											pos_leading_coef := (xx > 0)
							         end
				             else pos_leading_coef := (p^.ncoef^.lint > 0)
					  else pos_leading_coef := (p^.ncoef^.head^.value > 0)
	      else pos_leading_coef := pos_leading_coef(p^.pcoef)
	
	end;
	
  {*************************************************************************}
 
  function convert_to_int; {(var n: number): longint;} 

	 {  Return neg_two_to_31 if no good. n is not changed.  Sep 2004 } 

   begin
			if lintmode
			   then convert_to_int := n.lint
				 else if n.size = 1  
						     then convert_to_int := n.head^.value
						  else if n.size = 2
						     then if abs(n.head^.value) > 7 { too large }
						             then convert_to_int := neg_two_to_31
						             else convert_to_int := n.head^.value*block + n.tail^.value
						  else convert_to_int := neg_two_to_31
   end;
			
 {************************************************************************}
 
 function quoly_convert_to_int { (p: quoly): longint };
 
    var q: poly;
  
    begin
	
	   if not p^.numb
	      then begin
		          q := p^.numer;
				    while not q^.numb do { sink }
	                 q := q^.pcoef;
				    quoly_convert_to_int := convert_to_int(q^.ncoef^)
			     end		  
	      else quoly_convert_to_int := convert_to_int(p^.ncoef^)
	   
	end;

 {************************************************************************}
 
 function big_convert_to_int(n: imptr): longint; { Dec 2005 }
  
   begin
	
	   if lintmode
	      then big_convert_to_int := n^.lint
	   else if n^.size > 2
	      then big_convert_to_int := neg_two_to_31  { too large }
	   else if n^.size = 2 
	      then if abs(n^.head^.value) < 8
                then big_convert_to_int := block * n^.head^.value + n^.tail^.value
				        else big_convert_to_int := neg_two_to_31  { too large }	  
	      else big_convert_to_int := n^.head^.value
	   
	end;

 {**************************************************************************}

 function big_quoly_convert_to_int; {(p: quoly)   Dec 2005 }

   var q: poly;

   begin
   
     if not p^.numb
       then begin
              q := p^.numer;
              while not q^.numb do           { sink }
                q := q^.pcoef;
              big_quoly_convert_to_int := big_convert_to_int(q^.ncoef)
            end
       else big_quoly_convert_to_int := big_convert_to_int(p^.ncoef)
       
   end;

{*************************************************************************}
 
 function poly_length { (n: poly): longint} ;
 
   var m: longint;
	
	begin
	
	   m := 0;
	   while n <> nil do
	      begin
		     m := m + 1;
			  n := n^.next
		  end;
		  
	   poly_length := m
		  
	end;
	
 {*************************************************************************}
 
 function exp_poly_length { (n: poly; var expon: longint; var one_var: boolean): longint} ;
 
   { n <> nil. We also measure density.  If too sparse, return negative. 
     Oct 2003: note that 0 is never returned.  added one_var, whose purpose is to
     say if we can run the fastest_poly_mult algorithm with n.  Note that if n^.exp = 0 and 
     not n^.numb, one_var := false. 
     Beware of laurents!  seeing any negative exponent -> one_var := false.
     Compare height_is_1. }
	
	var m, lead: longint;
	
	begin
	 
	   one_var := one_var and modularmode and (number_polys > 1);  { true means need to check in loop  
	                                                                 below for all coefs number }
	   m := 0;
		 lead := n^.exp;
	   repeat  { Oct 2003 }
        Inc(m);
        if one_var  { Oct 2003 }
           then if not n^.numb
                   then if laurent
                           then one_var := n^.pcoef^.numb and (n^.pcoef^.next = nil)
                           else one_var := n^.pcoef^.numb;
	      if n^.next = nil
	         then begin
	                 expon := n^.exp;
	                 leave
	              end
	         else n := n^.next
		 until false;
		  
	   if modularmode and (number_polys = 1)  { Oct 2003 }
	      then one_var := (expon >= 0)
	      else one_var := one_var and (expon >= 0);	   
	   
		 if lead - expon > 6*m
		    then exp_poly_length := -m  { too many gaps! }
		    else exp_poly_length := m
		  
	end;
	
 {*************************************************************************}
 
 function fast_poly_length { (n: poly; cut: integer): integer} ;
 
   var m: integer;  
	
	begin
	
	   m := 0;
	   while n <> nil do
	      begin
		     m := m + 1;
			  if m > cut
			     then leave;
			  n := n^.next
		  end;
		  
	   fast_poly_length := m
		  
	end;
	
 {*************************************************************************}
 
 function fast_numterms(n: poly): integer;  { Nov 2002 }
 
    { not the true term total; quits after reaching ~60.  Compare node_total.
      returns 1 for a number. }
	 
	 var m: integer;
	
	 begin
	
	   m := 0;
	   while n <> nil do
	      begin
		      if n^.numb
				     then Inc(m)
				     else m := m + fast_numterms(n^.pcoef);
			    if m > 60
				     then leave;
			    n := n^.next
		    end;
		  
	   fast_numterms := m
		  
	end;
 
{*************************************************************************}
 
 function node_total { (n: poly): integer} ;
 
    { not the true node total; quits after reaching 18.
    
     Oct 2002:  The above is not really true of course.  A bottom level 
     invocation can return 18.  Then a second level call can return 36, etc. Still,
     it's hard to imagine a call returning more than halfblock, 16384.
     
     see also poly_nodes }
	 
	 var m: integer;
	
	begin
	
	   m := 0;
	   while n <> nil do
	      begin
		      m := m + 1;
				  if not n^.numb
				     then m := m + node_total(n^.pcoef);
			    if m > 17
				     then leave;
			    n := n^.next
		    end;
		  
	   node_total := m
		  
	end;
	
 {*************************************************************************}
 
 function new_node_total { (n: poly): integer} ;
 
   { Jun 2005 }
	 
	 var m: integer;
	
	 begin
	
	   m := 0;
	   while n <> nil do
	      begin
		      if n^.numb
		         then m := m + 1
				     else m := m + n^.exp + new_node_total(n^.pcoef);
			    if m > 100
				     then if m > 200
				        then begin
				               m := 200;
				               leave
				             end
				        else leave;
			    n := n^.next
		    end;
		  
	   new_node_total := m
		  
	end;
	
 {*************************************************************************}
 
 function big_node_total { (n: poly): integer} ;
 
    { not the true node total; quits after reaching ~1600. Dec 2001
      Dec 2003:  always returns a nonnegative answer <= 1600. }
	 
	 var m: integer;
	
	 begin
	
	   m := 0;
	   while n <> nil do
	      begin
		      m := m + 1;
				  if not n^.numb
				     then m := m + big_node_total(n^.pcoef);
			    if m > 800
				     then begin
				             if m > 1600
				                then big_node_total := 1600
				                else big_node_total := m;
				             exit(big_node_total)
				          end;
			    n := n^.next
		    end;
		  
	   big_node_total := m
		  
	end;
	
 {*************************************************************************}
 
 function bigger_node_total { (n: poly): longint} ;
 
   { not the true node total; quits after reaching ~4800. Dec 2001
     changed to longint and 256000, Nov 2002. used only by content and dual_content }
	 
	 var m: longint;
	
	 begin
	
	    m := 0;
	    while n <> nil do
	       begin
			      m := m + 1;
					  if not n^.numb
					     then m := m + bigger_node_total(n^.pcoef);
				    if m > 256000
					     then leave;
				    n := n^.next
		     end;
		  
	    bigger_node_total := m
		  
	end;
	
{***************************************************************************}

function expon_node_total; { (n: poly; depth: longint; init: boolean; var expop: longint): integer; }
    { not the true node total; quits after reaching ~1600. Dec 2005
        always returns a nonnegative answer <= 3200.
        Also compute the product of all the (degree + 1) so caller can assess
      sparseness.  At end expop product of all (degree + 1) seen.
      Since this is not the true node total, this is not the true sparseness.
      init = this is top level. }

   var m, i: integer;

   begin
   
	   if init 
	     then begin
				       deglist[depth] := n^.exp + 1;
				       for i := depth+1 to number_polys do
				          deglist[i] := 0
				    end
	     else if n^.exp + 1 > deglist[depth]
	            then deglist[depth] := n^.exp + 1;

	   m := 0;
	   while n <> nil do
	     { upon entering this loop, m is always <= 1600.  }
	     begin
	       m := m + 1;
	       if not n^.numb
	         then m := m + expon_node_total(n^.pcoef, depth+1, false, expop);
	       if m > 1600 
	         then begin
	                if m > 3200
	                  then m := 3200;
	                leave;
	              end; 
	       n := n^.next
	     end;

	   if init 
	     then begin
					     expop := deglist[depth];
					     for i := depth+1 to number_polys do
					       begin
					         if deglist[i] = 0
					           then leave;
					         expop := deglist[i] * expop;
					         if expop < 0 
					           then begin
					                  expop := lastlrgprime;
					                  leave
					                end
					       end
	         end;

	   expon_node_total := m
  
  end;

 {*************************************************************************}
 
 function poly_eq_pm1(p: poly): boolean;
 
    var y: boolean; 
 
    begin
	
	    if p^.numb & (p^.next = nil)
	       then poly_eq_pm1 := equal_to_pm1(p^.ncoef^, y)
		    else poly_eq_pm1 := false
		  
	  end;
	
 {*************************************************************************}
 
 function poly_small { (n: poly): boolean};
 
   { used by quoly_display. Subtle. Want the user to be able to enter the displayed
	  line. }
 
	begin
	
	   if n^.numb  
		   then poly_small := (n^.next = nil)
			else if n^.exp = 0
	              then poly_small := poly_small(n^.pcoef)
		           else poly_small := (n^.next = nil) & poly_eq_pm1(n^.pcoef)
	   
	end;
	
 {*************************************************************************}
 
 function monomial; {(n: poly): boolean}
 
	{ n can't be nil.  Is n = c*x^n*y^m*...  Jul 2002, removed the recursion. }
	
	  begin
	
	     monomial := false;
		   while true do
			    if n^.next = nil
			       then if n^.numb 
			               then begin
			                       monomial := true;
			                       leave
			                    end
			               else n := n^.pcoef
				     else leave  { give up, false }
		  
	  end;
	
 {************************************************************************}
 
 function p_size_of(q: poly): longint;
 
    { q must be numb. rational mode. An approx to log base 2 of abs(number).}
	 
	 var k, spot, qval: longint;
    
	 begin
	    		 
		 qval := q^.ncoef^.head^.value; {@@@}
		 if qval >= 0
		    then begin
			         spot := -1;
						for k := logblock downto 0 do    { changed from 31 ~~~~}
							if BTST(qval, k)
								then begin
										  spot := k;
										  leave
									  end
					end
		    else begin
			         spot := 0;
						for k := logblock downto 0 do    { changed from 31 ~~~~}
							if not BTST(qval, k)
								then begin
										  spot := k;
										  leave
									  end
					end;
								  
		 p_size_of := logblock * (q^.ncoef^.size - 1) + spot
							
	 end;
						   
  {*************************************************************************}
 
 function poly_mass; {(n: poly; multplier, depth: longint): longint}
 
   { called only by quoly_mass. Note carefully multplier and depth in recursion. }
 
   var m: longint;
	
	begin 
	
	   m := 0;
	   if laurent & monomial(n) & not n^.numb
		   then m := poly_height(n) + poly_depth(n)  {@@@ June 3, 1996}
			else while n <> nil do
						begin		     
							if n^.numb
								then if lintmode
								        then m := m + 1
										  else m := m + n^.ncoef^.size
							   else if n^.exp <> 0
								        then m := m + abs(n^.exp)*multplier*depth*poly_mass(n^.pcoef, 
										            1, depth + 1)
							           else m := m + poly_mass(n^.pcoef, multplier, depth);
							if m < 0 { fail safe in case of integer overflow above }
	                     then begin
								        m := two_to_31;
										  leave
									  end;
						   multplier := 1;
							n := n^.next
					   end;

	   poly_mass := m 
		  
	end;
	
 {*************************************************************************}
 
 function prod_num_size; {(n, m: poly): longint}
 
   { Used by prod_size below.  n is a number, m might be. Jul 2001. laurent OK }
   
   var nsize: longint;
   
   function lint_mode_answer(p: poly; oneonly: boolean): longint;
     { resembles sizepoly }     
      var m: longint;	
		  begin 
			   if p^.numb
			      then begin
			              lint_mode_answer := 9; { sum of polynodesize and numbersize, 4 + 5 }
			              exit(lint_mode_answer)
			           end;
			   if oneonly
			      then begin
			              p := p^.pcoef;
			              m := 4
			           end
			      else m := 0;
			   while p <> nil do
					  begin		     
						  if p^.numb
							   then m := m + 9  { sum of polynodesize and numbersize, 4 + 5 }
						     else m := m + 4 + lint_mode_answer(p^.pcoef, false);
						  if m < 0  { in case of integer overflow above }
						     then begin
						             m := two_to_31;
						             leave
						          end;
							p := p^.next
					  end;  
			   lint_mode_answer := m 
		  end;    
      
   {----------------------------------------------------------------}
   
   function rat_mode_answer(p: poly; oneonly: boolean): longint;
      var m: longint;
      begin
         if p^.numb
			      then begin
			              rat_mode_answer := 8 + 2*(nsize + p^.ncoef^.size);
			              { 8 above is a heuristic; by rights should be 9, but often there
			                is no carrying }
			              exit(rat_mode_answer)
			           end;
			   if oneonly
			      then begin
			              p := p^.pcoef;
			              m := 4
			           end
			      else m := 0;
			   while p <> nil do
					  begin		     
						  if p^.numb
							   then m := m + 9 + 2*(nsize + p^.ncoef^.size)
						     else m := m + 4 + rat_mode_answer(p^.pcoef, false);
						  if m < 0  { in case of integer overflow above }
						     then begin
						             m := two_to_31;
						             leave
						          end;
						  p := p^.next
					  end;  
			   rat_mode_answer := m   
      end;
      
   {----------------------------------------------------------------}
   
   begin
   
      if lintmode
         then prod_num_size := lint_mode_answer(m, true)
         else begin
                 nsize := n^.ncoef^.size;  
               {  if nsize > 1   heuristic for fact that often there's no carrying. 
                    then nsize := nsize - 1;  }
                 prod_num_size := rat_mode_answer(m, true)
              end
   
   end;
 
 {*************************************************************************}
 
 function prod_size; {(n, m: poly; toplevel: boolean): longint}
 
   { For virtual memory management.  Estimate the size or mass of n*m as quickly
     as possible. We actually count the number of longints, not the number of
     bytes.  This makes (long)integer overflow less likely.  
        n^ = m^ is OK.  laurent OK.
        toplevel: we are searching for the authenic top level, i.e. all above 
     are entirely dummy exponent = 0 nodes.  If true upon entry, then the higher 
     levels think this one might be it.  We reevaluate it here and pass it on to
     lower levels.
        We don't want to take the time to simulate every coef of n times every coef
     of m, but we do want to look at each node of each.  So end_n means we have
     encountered the end of n once already, same for end_m.  Jul 2001 }
 
   var avval, val, val2, nterms, mterms, nlast, mlast, count: longint;
       end_n, end_m, nexttop: boolean;
       nhead, mhead: poly;
	
	 begin 
	
	    nterms := 0; 
	    mterms := 0; 
	    end_n := false;
	    end_m := false;
	    nhead := n;
	    mhead := m;
	    val := 0;
	    count := 0;
	    { Is the next level really the top level?  Is this it? }
	    if (n^.exp = 0) and (m^.exp = 0) and toplevel
	       then begin
	               nexttop := (n^.next = nil) and (m^.next = nil);
	               toplevel := not nexttop
	            end
	       else nexttop := false;
	    
	    { first pass through n and m }
	    while true do
			   begin		     
						if n^.numb
							 then val := val + prod_num_size(n, m)
					  else if m^.numb
					     then val := val + prod_num_size(m, n)
					  else val := val + 3 + prod_size(n^.pcoef, m^.pcoef, nexttop);
						if val < 0 { in case of integer overflow above }
	             then begin
							         prod_size := two_to_31;
									     exit(prod_size)
							      end;
						Inc(count);
						if not end_n
						   then Inc(nterms);
						if not end_m
						   then Inc(mterms);
					  if n^.next = nil
					     then begin
					             nlast := n^.exp;
					             end_n := true;
					             if end_m
					                then leave
					                else n := nhead
					          end
						   else n := n^.next;
						if m^.next = nil
					     then begin
					             mlast := m^.exp;
					             end_m := true;
					             if end_n
					                then leave
					                else m := mhead
					          end
						   else m := m^.next
		     end;

	    { at this point count is the max of the two sizes of n and m, and nterms and
	      mterms are correct. }
	    avval := val div count;  { average size of coef products actually looked at above. }
	    count := nhead^.exp + mhead^.exp + 1 - mlast - nlast; { # of nodes in product n*m
	                                                            if n and m are dense }
	                                                            
	    { Next, a heuristic to try to account for polys that aren't dense. The second 
	      alternative here is very delicate!  Don't increase it arbitrarily.  These things
	      get multiplied recursively. }
	    if count > sqr(1 + (nterms + mterms) div 2)
	       then begin
	               { product is sparse }
	               count := sqr((nterms + mterms) div 2);
	               toplevel := false  { turn off heuristic below }
	            end
	       else count := (count + nterms + mterms) div 2;
	    
	    if val < count * avval
	       then val := count * avval;
	    if toplevel
	       then val := (1 + val div 6) * 7;

	    if val < 0
	       then begin
	               prod_size := two_to_31;
	               exit(prod_size)
	            end
	       else prod_size := val;  
	       
	    { In some cases stop now, else do a second pass }
	    if val < 160 { heuristic obviously }
	       then exit(prod_size);
	       
	    { Second pass.  Change the shorter poly (n, say) by first moving up with n := 
	      n^.next.  Except for trivial cases, this will make different pairings
	      of the coeffs as we run through the main loop (above) again. }
	    { Make sure n is the shorter of the two polys; no need to swap nlast, mlast. }
	    if nterms > mterms
	       then begin
	               n := nhead;
	               nhead := mhead;
	               mhead := n;
	               count := nterms;
	               nterms := mterms;
	               mterms := count
	            end;
	    n := nhead;
	    m := mhead;
	    if m^.next = nil { so is n^.next }
	       then exit(prod_size)
	    else if n^.next = nil
	       then exit(prod_size) { there's no point in a second pass; no difference }
	    else n := n^.next;
	       
	    { Reset for second pass.  Use val2 this time, later compare to val.  }
	    end_n := false;
	    end_m := false;
	    val2 := 0;
	    count := 0;
	    while true do
			   begin		     
						if n^.numb
							 then val2 := val2 + prod_num_size(n, m)
					  else if m^.numb
					     then val2 := val2 + prod_num_size(m, n)
					  else val2 := val2 + 3 + prod_size(n^.pcoef, m^.pcoef, nexttop);
						if val2 < 0 { in case of integer overflow above }
	             then begin
							         prod_size := two_to_31;
									     exit(prod_size)
							      end;
						Inc(count);
					  if n^.next = nil
					     then begin
					             end_n := true;
					             if end_m
					                then leave
					                else n := nhead
					          end
						   else n := n^.next;
						if m^.next = nil
					     then begin
					             end_m := true;
					             if end_n
					                then leave
					                else m := mhead
					          end
						   else m := m^.next
		     end;

	    { at this point count is the max of the two sizes of n and m }
	    avval := val2 div count;  { average size of coef products actually looked at above. }
	    count := nhead^.exp + mhead^.exp + 1 - mlast - nlast; { # of nodes in product n*m
	                                                            if n and m are dense }

	    { Next, a heuristic to try to account for polys that aren't dense. The second 
	      alternative here is very delicate!  Don't increase it arbitrarily.  These things
	      get multiplied recursively. }
	    if count > sqr(1 + (nterms + mterms) div 2)
	       then count := sqr((nterms + mterms) div 2)
	       else count := (count + nterms + mterms) div 2;
	    
	    if val2 < count * avval
	       then val2 := count * avval;
	    if toplevel
	       then val2 := (1 + val2 div 6) * 7;	       
	            
	    if val2 < 0
	       then begin
	               prod_size := two_to_31; 
	               exit(prod_size)
	            end;
	       
	    if val2 > val
	       then val := val2;
	       
	    prod_size := val; 
	    
	    if toplevel
         then if val > 500000
                 then exit(prod_size);
	    
	    { Third pass }
	    if nterms <= 2
	       then exit(prod_size);
	       
	    m := mhead;
	    n := nhead^.next;
	    n := n^.next;
	    end_n := false;
	    end_m := false;
	    val2 := 0;
	    count := 0;
	    while true do
			   begin		     
						if n^.numb
							 then val2 := val2 + prod_num_size(n, m)
					  else if m^.numb
					     then val2 := val2 + prod_num_size(m, n)
					  else val2 := val2 + 3 + prod_size(n^.pcoef, m^.pcoef, nexttop);
						if val2 < 0 { in case of integer overflow above }
	             then begin
							         prod_size := two_to_31;
									     exit(prod_size)
							      end;
						Inc(count);
					  if n^.next = nil
					     then begin
					             end_n := true;
					             if end_m
					                then leave
					                else n := nhead
					          end
						   else n := n^.next;
						if m^.next = nil
					     then begin
					             end_m := true;
					             if end_n
					                then leave
					                else m := mhead
					          end
						   else m := m^.next
		     end;

	    { at this point count is the max of the two sizes of n and m }
	    avval := val2 div count;  { average size of coef products actually looked at above. }
	    count := nhead^.exp + mhead^.exp + 1 - mlast - nlast; { # of nodes in product n*m
	                                                            if n and m are dense }

	    { Next, a heuristic to try to account for polys that aren't dense. The second 
	      alternative here is very delicate!  Don't increase it arbitrarily.  These things
	      get multiplied recursively. }
	    if count > sqr(1 + (nterms + mterms) div 2)
	       then count := sqr((nterms + mterms) div 2)
	       else count := (count + nterms + mterms) div 2;
	    
	    if val2 < count * avval
	       then val2 := count * avval;
	    if toplevel
	       then val2 := (1 + val2 div 6) * 7;
	    if val2 < 0
	       then val2 := two_to_31;
	       
	    if val2 > val
	       then val := val2;
	       
	    prod_size := val  {(3*val2 + val) div 4}
		  
	 end;
	
  {*************************************************************************}
 
 function full_poly_mass; {(n: poly; multplier, depth: longint): longint}
 
   { laurents OK (Nov 1996).  }
	
	var m: longint;
	
	begin 
	
	   m := 0;
	   while n <> nil do
			begin		     
				if n^.numb
					then if lintmode
					        then m := m + 1
							  else m := m + p_size_of(n) { remove the div 2, May 1996}
					else if n^.exp <> 0
							  then m := m + abs(n^.exp)*multplier*depth*full_poly_mass(n^.pcoef, 
											multplier, depth - 1)
							  else m := m + full_poly_mass(n^.pcoef, multplier, depth - 1);
				if m < 0 { fail safe in case of integer overflow above ~~~~moved}
					then begin
							  full_poly_mass := block;  { Nov 1996 } 
							  exit(full_poly_mass)
						  end;
				n := n^.next
			end;
	   full_poly_mass := minn(m, block)  { Nov 1996 } 
		  
	end;
	
 {*************************************************************************}
 
 { function real_poly_mass; {(n: poly;  depth: longint): longreal}
 
   { called only by content.  almost the same as poly_mass. 
     Sep 2001:  gives different results than the identical procedure in QFer.
     Can't figure out why.
     Dec 2001;  no longer used. }
	
 {*************************************************************************}
 
 function simple_poly_mass; {(n: poly): longint;~~~~}
 
   { estimate the number of bytes. any poly, any mode. 
     Jul 2001: the numbers below are wrong!  I am not changing them since this proc is
     called in various ways and I don't want to run it all down.  But the numbers ought 
     to be:  36, 8, and 16.  see function sizepoly.  }
 
   var m: longint;
	
	begin 
	
	   m := 0;
	   while n <> nil do
				begin		     
					if n^.numb
						 then if lintmode
										 then m := m + 31
										 else m := m + 31 + 8*n^.ncoef^.size
						 else m := m + 13 + simple_poly_mass(n^.pcoef);
					n := n^.next
				end;  
	   simple_poly_mass := m 
		  
	end;
	
 {*************************************************************************}
 
 function very_simple_poly_mass(n: poly): longint;
 
   { estimate the number of bytes. any poly, any mode. 
     Jul 2001: the numbers below are wrong!  I am not changing them since this proc is
     called in various ways and I don't want to run it all down.  But the numbers ought 
     to be:  36, 8, and 16.  see function sizepoly.
       Nov 2003. stop early. }
 
   var m: longint;
	
	 begin 
	
	   m := 0;
	   while n <> nil do
			  begin		     
				  if n^.numb
					   then if lintmode
					           then m := m + 31
							       else m := m + 31 + 8*n^.ncoef^.size
				     else m := m + 13 + very_simple_poly_mass(n^.pcoef);
				  if m > 250
				     then leave;
				  n := n^.next
			  end;  
	   very_simple_poly_mass := m 
		  
	 end;
	
 {*************************************************************************}
 
 function quoly_mass { (n: quoly): longint };
 
    { used only by find_good_spot and findbest. n <> a number. @@@ June 1996
	   Changed Nov 1996: Now n can be number.  called by row_mass. }
	 
	 begin
	   
	   if n^.numb
	      then if lintmode
			        then quoly_mass := 1
					  else quoly_mass := n^.ncoef^.size
	   
		else if n^.rat and not lintmode
		   then quoly_mass := n^.numer^.ncoef^.size + n^.denom^.ncoef^.size
	   else if n^.denom = nil
	      then quoly_mass := poly_mass(n^.numer, depthnum, 1)
	   else if n^.denom^.numb
		   then quoly_mass := poly_mass(n^.numer, depthnum, 1) + 1 +
			                   p_size_of(n^.denom) div 3
		else quoly_mass := poly_mass(n^.numer, depthnum, 1) + 
	                      massnum * poly_mass(n^.denom, depthnum, 1)
 
    end;
 
 {*************************************************************************} 
 
 function is_array_param; {(p: quoly): boolean}
 
    begin
	
	   if p^.numb 
	      then is_array_param := p^.arr_arg
	      else is_array_param := false
	
	end;
	
 {*************************************************************************}

 function is_poly_name { x: nametype; var depth: longint : boolean }; 
 
    var q: polypt;
 
    begin
	
	   is_poly_name := false;
	   depth := 1;
	   q := polynames;
	   while q <> nil do
		  if q^.let.name = x
		     then begin
				       is_poly_name := true;
				       exit(is_poly_name)
				    end
			  else begin
			          q := q^.next;
					    depth := depth + 1
				    end
			 
    end;
 
 {*************************************************************************}

 function is_poly_var; {(n: quoly; var depth: longint): boolean;   July 2002 }
 
    { n is authentic. Is n just a poly var?  -- just a single 1*x^1 }
    
    var p: poly;
        one_seen: boolean;
 
    begin
	
		   is_poly_var := false;
		   depth := 0;
		   if n^.numb
		      then exit(is_poly_var);
		   if n^.denom <> nil
		      then exit(is_poly_var);
		   one_seen := false;
		   p := n^.numer;
		   while true do
			    if p^.next = nil
			       then if p^.numb
			               then begin
			                       is_poly_var := poly_eq_1(p);
			                       leave
			                    end
			               else begin
					                   if one_seen  
					                      then leave;  { give up, false }
					                   case p^.exp of
					                      1: one_seen := true;  { so no more 0 head nodes allowed}
					                      0: { OK, since one not seen yet };  
					                      otherwise leave;   { give up, false }
					                   end;
					                   p := p^.pcoef;
						                 depth := depth + 1
					                end
				     else leave  { give up, false }
			 
    end;
    
 {*************************************************************************}

 function its_a_polyname { x: nametype }; 
 
    var i: longint;
 
    begin
	
	   for i := 1 to number_polys do
		   if x < polyvar[i]
			   then begin
				        its_a_polyname := false;
						  exit(its_a_polyname)
					  end
		   else if x = polyvar[i]
			   then begin
				        its_a_polyname := true;
						  exit(its_a_polyname)
					  end;
					  
	   its_a_polyname := false
			 
    end;
 
 {*************************************************************************}

 procedure is_poly_name2 {(x: nametype; var depth: longint; var q: polypt) }; 
 
    begin
	
	   depth := 1;
	   q := polynames;
	   while q <> nil do
		   if q^.let.name = x
		      then exit(is_poly_name2)
			   else begin
			           q := q^.next;
					     depth := depth + 1
				     end
			 
    end;
 
 {*************************************************************************}
 
 procedure delete_poly_name; { (depth: longint) } {~~}
 
   { This procedure no longer throws away polydata nodes. March 1993. }
 
   var i: longint;
	    q, q2: polypt;  {~~} 
	
	begin
	
	   if depth = 1
	      then begin
			        q2 := polynames;
					  polynames := polynames^.next
				  end
	   else begin
	           q := polynames;
	           for i := 1 to depth - 2 do
			        q := q^.next;
			     q2 := q^.next;
				  q^.next := q2^.next
			  end;
			  
		free_pt(q2)
			
    end;
	
 {*************************************************************************}
 
 procedure remove_one(var p: poly; depth: longint);
 
    { Used after deleting a poly var, to purge dummy place-holding nodes that
	  correspond to the now defunct variable. }
	  
	var q: poly;
 
    begin
	
	   if depth = 1   { trivial case }
	      then if not p^.numb { it must point to a dummy place-holding node }
		           then begin
								  q := p^.pcoef;
								  p^.pcoef := nil;
								  free_poly(p);
								  p := q
					      end
				     else
	   else begin
	           q := p;
			     while q <> nil do
			       begin
				      if not q^.numb
					      then remove_one(q^.pcoef, depth - 1);
					   q := q^.next
				    end
			  end					 
	   
	end;
	
 {*************************************************************************}
 
 procedure remove_poly_var; {(var q: quoly; depth: longint)}
 
    begin 
	
	   if not q^.numb
	      then begin
		          remove_one(q^.numer, depth);
				    if q^.denom <> nil
				      then remove_one(q^.denom, depth)
			     end
			   
    end;	          

 {************************************************************************}
	
 procedure sub_expons; {(u: poly; var utail: poly; uexp: longint)}
 
    { last node in u has positive exponent, uexp. Subtract this from all nodes,
	   except maybe the last.  no laurents.  Pass back pointer to last node for 
		later restoration, but only if a number is encountered. else utail is
		undefined. }
	 
	 var pt: polyptrr;
	 
	 begin
	 
	    pt := @ u;
		  while pt^^.next <> nil do
	       begin
			      pt^^.exp := pt^^.exp - uexp;
				    pt := @ pt^^.next
			   end;
		  if pt^^.pcoef^.numb
		    then begin
			         utail := pt^;
						   pt^ := utail^.pcoef
			       end
			  else pt^^.exp := 0  { = pt^^.exp - uexp }
	 
	 end;
  
 {************************************************************************}
	
 procedure restore_exps; {(u, utail: poly; uexp: longint)}
 
	 var pt: polyptrr;
	 
	 begin
	 
	    pt := @ u;
		  while pt^^.next <> nil do
	       begin
			      pt^^.exp := pt^^.exp + uexp;
				    pt := @ pt^^.next
			   end;
	   if pt^^.numb
		    then pt^ := utail
			  else pt^^.exp := uexp
	 
	 end;
 
 {************************************************************************}
	
 procedure base_poly { var p: poly; depth: longint };
 
    var i: longint;
	     t: poly;
 
    begin
	
	   free_poly(p);
	   for i := 1 to depth + 1 do
	      begin
		     if i=1 
			     then begin
				          newpoly(p);
						    t := p
				       end
				  else begin
							 newpoly(t^.pcoef);
							 t := t^.pcoef
					    end;
			  t^.numb := (i = depth + 1);
			  t^.next := nil;
			  if i = depth
			     then t^.exp := 1
				  else t^.exp := 0;
		   end;
	   init_poly_node(t);
	   setvalue(1, t^.ncoef^) 
	
	end;
	
 {************************************************************************}
	
 procedure make_monomial; {(var p: poly; expo: longint; cf: poly)}
 
    { Make a monomial of exponent expo, with pcoef cf.  p nil or
	   irrelevant on entry. cf^ is gobbled up, but cf is unchanged.
		p might become a number.  no laurents. ~~~~}
	 
	 begin
	 
	    if (expo = 0) and cf^.numb
		    then p := cf
			 else begin
			         newpoly(p);
					   p^.next := nil;
					   p^.exp := expo;
					   p^.numb := false;
					   p^.pcoef := cf
				   end
					
	 end;
  
 {************************************************************************}
 
 procedure base_quoly { var p: quoly; depth: longint };
 
    begin
	
	    free_quoly(p);
	    newquoly(p);
	    p^.numb := false;
	    p^.denom := nil;
	    p^.numer := nil;
		 p^.rat := false;
	    base_poly(p^.numer, depth)
 
    end;
 
 {*************************************************************************}
 
 function poly_equal { (p,q: poly): boolean };
  
   { Note: either could be nil. It will say that two nils are equal, and that a nil 
    is not equal to a non-nil.  This is almost used by procedure look_at_polys.  Jul 2002 }
  
	var test: boolean;
	
	begin
	   
	   poly_equal := false;
	   test := true;
	   while p <> nil do
	      begin
		     if q = nil then exit(poly_equal);
		     if p^.numb
			     then if q^.numb
				          then test := equal(p^.ncoef^, q^.ncoef^)								 
					       else exit(poly_equal)
				  else if q^.numb
				          then exit(poly_equal)
						    else test := (p^.exp = q^.exp ) & poly_equal(p^.pcoef, q^.pcoef);
			  if test
			     then
				  else exit(poly_equal);
			  p := p^.next;
			  q := q^.next
		  end;
		  
	   poly_equal := (q = nil)
		  
	end;
	
 {*************************************************************************}
 
 function poly_neg(p, q: poly): boolean; { Sep 2000 }
  
   { Note: either could be nil and it won't crash, but it will say that
     two nils are neg of each other.  Jul 2002 }
   
   var test: boolean;
	
 	 begin
	   
	   poly_neg := false;
	   test := true;
	   while p <> nil do
	      begin
			     if q = nil then exit(poly_neg);
			     if p^.numb
				     then if q^.numb
					           then test := negtive(p^.ncoef^, q^.ncoef^)								 
						         else exit(poly_neg)
					   else if q^.numb
					           then exit(poly_neg)
							       else test := (p^.exp = q^.exp ) & poly_neg(p^.pcoef, q^.pcoef);
				   if test
				      then
					    else exit(poly_neg);
				   p := p^.next;
				   q := q^.next
		    end;
		  
	   poly_neg := (q = nil)
		  
	end;
	
 	{***************************************************************************}
			
	procedure mod_inverse(seca: longint; var ans: longint); 
	
     { seca and ans can be passed same argument. modulus is not necessarily a prime.
       seca can't be 0.  Apr 2004.  testing says this is OK for large modulus }
	  
	  var q, firsta, secf, firstf, temp: longint;
	  
    begin					 
			if finf {  Jul 2004 }
         then begin
                 ans := longint(f2t16inv[seca]);
                 exit(mod_inverse)
              end;
  
      firsta := modulus;
			secf := 1;
			firstf := 0;
			while true do  { June 1998. speed up loop. }
				begin
					q := firsta div seca;
					temp := firsta - seca * q;
					if temp = 0
					   then begin
					           if secf < 0
					              then ans := secf + modulus
					              else ans := secf;
					           exit(mod_inverse)
					        end;
					firsta := seca;
					seca := temp;
			    temp := firstf - q * secf;
					firstf := secf;
					secf := temp
				end
    end;         
 
 {*************************************************************************}
 
 function opposites(var n, m: number): boolean;
 
    var p, q: numptr;
	 
	 begin
	  
	    opposites := false;
		 if n.size = m.size
			 then begin
						p := n.head;
						q := m.head;
						while p^.value = - q^.value do
							begin
								p := p^.next;
								q := q^.next;
								if p = nil 
									then begin
											  opposites := true;
											  exit(opposites)
										  end
							end
					 end
	 
	 end;
 
 {*************************************************************************
 THIS IS A COMMENT.  This procedure is flawed. ratcheck must be turned on after first
 assignment of x := 0.  May 93.
 function essentially_equal  (p, q: poly; x: longint): boolean ;
 
    Are p and q equal, or is one an invertible element of the ground ring times
	  the other?  x = -1 on input means to compute x, which is then actually
	  used in modularmode.  x is only a flag in rational mode.
	      Assumes p and q are not numbers on first call in rational mode. 
 
   var test, modcheck, ratcheck: boolean;
	
	begin
	   
	   essentially_equal := false;
		modcheck := modularmode and mod_is_prime;
		ratcheck := not lintmode and (x = 0);
		if x = -1  { first call only 
		   then if modcheck
			        then begin		  	        
							    mod_inverse(leading_coef(q)^.ncoef^.lint, x);
							    x := leading_coef(p)^.ncoef^.lint * x;
							    if x >= modulus 
								    then x := x mod modulus
						    end
			     else if not lintmode
			             then if opposites(leading_coef(q)^.ncoef^, leading_coef(p)^.ncoef^)
					               then x := 0
										else x := 1;  { not 0 and not -1 
				  
	   test := true;
	   while p <> nil do
	      begin
		     if q = nil then exit(essentially_equal);
		     if p^.numb
			     then if q^.numb
				          then if modcheck
							         then test := (p^.ncoef^.lint = mod_mult(x, q^.ncoef^.lint, modulus))
									   else if ratcheck
									           then test := opposites(p^.ncoef^, q^.ncoef^)
								              else test := equal(p^.ncoef^, q^.ncoef^)								 
					       else exit(essentially_equal)
				  else if q^.numb
				          then exit(essentially_equal)
						    else test := (p^.exp = q^.exp ) & essentially_equal(p^.pcoef, q^.pcoef, x);
			  if test
			     then
				  else exit(essentially_equal);
			  p := p^.next;
			  q := q^.next
		  end;
		  
	   essentially_equal := (q = nil)
		  
	end;
	
  *************************************************************************}
 
 function essentially_equal { (p, q: poly): boolean };
 
   { Are p and q equal, or is one an invertible element of the ground ring times
	  the other?  }
 
   var x, z: longint;
	    cond: integer;
		 r, s: imptr;
	
	procedure check_all(p, q: poly);
	   var test: boolean;
		begin
		   while p <> nil do
				begin
				  if q = nil then exit(essentially_equal);
				  if p^.numb
					  then if q^.numb
								 then case cond of
											0: test := (p^.ncoef^.lint = modmult(x, q^.ncoef^.lint)); { Aug 2001 }
											1: test := opposites(p^.ncoef^, q^.ncoef^);
											2: test := equal(p^.ncoef^, q^.ncoef^)
										end
								 else exit(essentially_equal)
					  else if q^.numb
								 then exit(essentially_equal)
								 else begin
											test := (p^.exp = q^.exp);
											if test 
												then check_all(p^.pcoef, q^.pcoef)
										end;
				  if not test
					  then exit(essentially_equal);
				  p := p^.next;
				  q := q^.next
			   end;
			  
			if q <> nil
			   then exit(essentially_equal)
		end;	
	
	begin
	   
	   essentially_equal := false;
		
		r := leading_coef(p)^.ncoef;
		s := leading_coef(q)^.ncoef;
		if modularmode and mod_is_prime
		   then begin		  	        
					  mod_inverse(s^.lint, z);
					  x := modmult(r^.lint, z);  { Aug 2001 }
					  if x = 1
					     then cond := 2
						   else cond := 0
				  end
			else if lintmode
			        then exit(essentially_equal)
		   else if opposites(r^, s^)
					  then cond := 1
					  else if equal(r^, s^)
								 then cond := 2
								 else exit(essentially_equal);
				  
		check_all(p, q);
		essentially_equal := true
		  
	end;
	
 {*************************************************************************}
 
 function quoly_equal { (p,q: quoly): boolean };
 
    { assumes no negative denoms of numbers in rational mode. }
	 { assumes canonical forms! }
 
	begin
	
	   quoly_equal := false;
	   if p^.numb
		  then if q^.numb
				  then quoly_equal := equal(p^.ncoef^, q^.ncoef^)							 
				  else exit(quoly_equal)
	   else if q^.numb
			   then exit(quoly_equal)
	   else if p^.denom = nil
	           then if q^.denom = nil
	                   then quoly_equal := poly_equal(p^.numer, q^.numer)
					       else exit(quoly_equal)
	   else if q^.denom = nil
	           then exit(quoly_equal)
	   else quoly_equal := poly_equal(p^.numer, q^.numer) & poly_equal(p^.denom, q^.denom)

    end;	
	
 {*************************************************************************}
  
 function quoly_negtive { (p,q: quoly): boolean };  { Sep 2000}
 
    { assumes no negative denoms of numbers in rational mode. }
	  { assumes canonical forms! }
 
	begin
	
	   quoly_negtive := false;
	   if p^.numb
		    then if q^.numb
				  then quoly_negtive := negtive(p^.ncoef^, q^.ncoef^)							 
				  else exit(quoly_negtive)
	   else if q^.numb
			    then exit(quoly_negtive)
	   else if p^.denom = nil
	           then if q^.denom = nil
	                   then quoly_negtive := poly_neg(p^.numer, q^.numer)
					           else exit(quoly_negtive)
	   else if q^.denom = nil
	           then exit(quoly_negtive)
	   else quoly_negtive := poly_neg(p^.numer, q^.numer) & poly_equal(p^.denom, q^.denom)

    end;	
	
 {*************************************************************************}  
 
 function quoly_larger { (p,q: quoly): boolean };
 
    { assume both are numbers }
	
	begin
	   
	   quoly_larger := bigger(p^.ncoef^, q^.ncoef^)
	   
	end;
	
 {***********************************************************************}
 
 function poly_iszero { (p: poly): boolean };
 
    begin
	
	   if p^.numb & (p^.next = nil)
	      then if lintmode
			        then poly_iszero := (p^.ncoef^.lint = 0)
					  else poly_iszero := (p^.ncoef^.head^.value = 0)
		   else poly_iszero := false
		  
	 end; 
	
 {***********************************************************************}
 
 function node_iszero { (p: poly): boolean };
 
    begin
	
	   if p^.numb 
	      then if lintmode
			        then node_iszero := (p^.ncoef^.lint = 0)
					  else node_iszero := (p^.ncoef^.head^.value = 0)
		   else node_iszero := false
		  
	end;
	
 {************************************************************************}
 
 function poly_eq_1; { (p: poly): boolean }
  
    begin
	
	   if p^.numb & (p^.next = nil)
	      then if lintmode
			         then poly_eq_1 := (p^.ncoef^.lint = 1)
					     else poly_eq_1 := (p^.ncoef^.head^.value = 1) and (p^.ncoef^.size = 1)
		    else poly_eq_1 := false
		  
	end;
	
 {************************************************************************}
 
 function poly_eq_m1; { (p: poly): boolean }
 
   begin
	
	   if p^.numb and (p^.next = nil)
	      then if modularmode  { BUG found!  Jul 2002 }
	              then if finf  { Sep 2004 }
	                      then poly_eq_m1 := (p^.ncoef^.lint = 1)
	                      else poly_eq_m1 := (p^.ncoef^.lint = modulus - 1)
	              else if lintmode
			                  then poly_eq_m1 := (p^.ncoef^.lint = -1)
					              else poly_eq_m1 := (p^.ncoef^.size = 1) and (p^.ncoef^.head^.value = -1)
		    else poly_eq_m1 := false
		  
	end;
	
 {************************************************************************}
 
 function quoly_eq_m1; { (p: quoly): boolean    Jul 2002}
 
   begin	
	   if p^.numb
	      then if lintmode  
			          then if modularmode
			                  then if finf { Sep 2004 }
			                          then quoly_eq_m1 := (p^.ncoef^.lint = 1)
			                          else quoly_eq_m1 := (p^.ncoef^.lint = modulus - 1)
			                  else quoly_eq_m1 := (p^.ncoef^.lint = -1)
					      else quoly_eq_m1 := (p^.ncoef^.head^.value = -1) and (p^.ncoef^.size = 1)
		    else quoly_eq_m1 := false		  
	 end;
	
 {************************************************************************}
     
 procedure init_gcd_stash; 
   
	 { new Dec 2003. prev_modulus = -1 means (in modularmode) that the gcdstash is empty. 
	   In rat mode, it must be -1. }
	 
	 begin
	 
      lookupgcd := lookupgcd + 1;
      
      if lookupgcd = 1
         then if modularmode
				         then if (prev_modulus = modulus) or (prev_modulus = -1)
				                 then  { nothing }
				                 else begin
				                         free_gcd_stash;
				                         prev_modulus := -1;
				                         lookupgcd := 1  { free_gcd_stash changed it! }
				                      end
				         else if prev_modulus > 0
				                 then begin
				                         modularmode := true;
				                         lintmode := true;
				                         free_gcd_stash;
				                         modularmode := false;
				                         lintmode := false;
				                         prev_modulus := -1;
				                         lookupgcd := 1  { free_gcd_stash changed it! }
				                      end

	 end;
  
 {***********************************************************************}
 
 function quoly_iszero { (p: quoly): boolean };
 
    begin
	
	   if p^.numb 
	      then if lintmode
			        then quoly_iszero := (p^.ncoef^.lint = 0)
					  else quoly_iszero := (p^.ncoef^.head^.value = 0)
		   else quoly_iszero := false
		  
	end;
	
 {***********************************************************************}
 
 function lint_quoly_iszero { (p: quoly): boolean  Jun 2006. will check the lint node only };
 
    begin
	
	   if p^.numb 
	      then lint_quoly_iszero := (p^.ncoef^.lint = 0)
		    else lint_quoly_iszero := false
		  
	end;
	
 {***********************************************************************}
 
  procedure fermat_error(mess: bigstring);  { there are two of these. Other is in
                                             fer220 }
 
     begin
		  write('*** Fermat error. ');
		  writeln(mess);
		  plflush(output)
	  end;

   {****************************************************************************}

   function rand_integer2; {: longint; ~~~@@@} 
	
	    { used internally by Fermat. Very delicate!! Beware!  returns integer
	      from 0 to 2^31 - 1. NOTE: it's not < 2^28 !! }
       var randy, randy2: longint;		 
		 
		 begin
		    				
		{	 randy := abs(random * random) ; @@@ bug of April 21, 1996}
			 randy := rand;   { move integer function random into longint variable! }
			 randy2 := rand;
			 randy2 := BAND(halfmask, randy2);  { randy2 now must be nonnegative }
			 randy := BSL(randy, 16) + randy2;
			 BClr(randy, 31);
			 rand_integer2 := randy
				
		 end;

	{****************************************************************************}
	
   function rand_integer3; {: longint; ~~~~ many changes below @@@}
	
	    { used internally by Fermat. Note modding by bigprime. Result is never negative. }
       var randy: longint;
       	
		 begin
		    
		    randy := rand;  { move integer function random into longint variable. }
			 randy := abs((randy * GetTickcount) mod bigprime);
			 if randy < 0
			    then begin
			            writeln('*** Fermat warning. Corrected bad rand_integer3 ', randy);
			            BClr(randy, 31);
			            plflush(output)
			         end;
			 rand_integer3 := randy
				
		 end;

	{***************************************************************************
	
	COMMENT  function gap_height(p: poly): integer;
		 
		     no laurents.  Moves past dummy 0 exp nodes of p.  
		   Computes the minimum "distance" needed to drop between the nodes of p^ and the 
			 real nodes of the p^.coefs.  In other words, 1 + the minimum number of dummy 0 
			 exp nodes between p's real level (ignoring p's own dummy 0 exp nodes) and the
			 real levels of the p^.coefs. 
			    Returns halfblock if p^.number or if all coefs number. 
		 
		 var d: integer;
		 
		 begin
		 
				if p^.numb
				   then begin
					        gap_height := halfblock;
							  exit(gap_height)
						  end;
				
				d := halfblock;
				while p^.exp = 0 do
	         p := p^.pcoef;
							  
				while p <> nil do
					 begin
						 if not p^.numb
							 then d := Iminn(d, poly_depth(p^.pcoef));
						 p := p^.next
					 end;
				gap_height := d
				
		 end;
			 
   **************************************************************************}

  procedure random_field_element; {(var q: poly; height: integer; pt: polypt)}
	
	   {   modularmode.  q nil on input.  height = desired height of the field
		   element we are going to create.  height >= 0. if height > 0, pt points to 
		   a node at or below field_depth.  q will be at pt's level on output.  
			Return non-zero q or q = nil to mean 0. }
		 
		 var pp: polyptrr;
		     j: longint;
			  s: poly;
		 
		 begin
		 
		    if height = 0
				 then begin
							j := rand_integer3 mod modulus; {@@@ modulus can't be bigger than bigprime}
							if j > 0
								then poly_set(j, q);
							exit(random_field_element)
						end;
								
				pp := @ q;
				s := nil;
				for j := pt^.expon - 1 downto 0 do
				   begin
					    random_field_element(s, height - 1, pt^.next);
						 if s <> nil
							 then begin
										newpoly(pp^);
										pp^^.numb := false;
										pp^^.exp := j;
										pp^^.pcoef := s;
										if j = 0
											then if s^.numb
													  then begin
																  pp^^.numb := true;
																  pp^^.ncoef := s^.ncoef;
																  s^.next := polygarb;
																  polygarb := s
															 end;
										s := nil;
										pp := @ pp^^.next
								   end
					 end;
					 
				pp^ := nil
		 
		 end;

 {*************************************************************************}
 
 procedure dumpatt; {(messge: bigstring; n: longint; newline, multin, colon: boolean);}

    { n is >= -1. n = -1 used only to signal moveup to new line. 
      Apr 2001.
       There is a dumpitt in 220.p  This has to be here for one call in 220.p. }
	 begin
	    if dumpitt_level <= 1
		     then suppressor := 1
		     else if multin
			           then begin  { May 2001 }
			                   suppressor := suppressor * n;
			                   if suppressor < 0  { remove comment delimiters! of course it might be negative. }
			                      then suppressor := suppressorcut + 2  
			                end;
		 if suppressor > suppressorcut
		    then exit(dumpatt);
		 if 2*dumpitt_level > siouxcols - 9 { May 2001 }
		    then exit(dumpatt);
		 if newline
		    then begin
			          writeln;
			          write(' ': 2*dumpitt_level);
						    dumpitt_length := 2*dumpitt_level
			       end;
		 if n > -1
		    then begin
			          write(messge, n:1);
						    if messge <> ' '
						       then begin
						               if colon
						                  then write(': ')
						                  else write('. ');  { Apr 2001 }
						               dumpitt_length := dumpitt_length + 2
						            end;
		            if n > 0
						       then n := trunc(0.00001+log10e*ln(n));
					      dumpitt_length := dumpitt_length + length(messge) + 1 + n;
					      if dumpitt_length > siouxcols - 6   {Sept 1996}
						       then begin
									         writeln;
									         write(' ': 2*dumpitt_level);
									         dumpitt_length := 2*dumpitt_level
								        end
			      end
	end;
	 
 {************************************************************************}

 procedure decr_dumpitt; {(n: longint; newline, multin: boolean)  Mar 2004 
 
    Note that if not verbose and not multin then all this does is decrement dumpitt_level. }
 
    begin
	    
			 dumpitt_level := dumpitt_level - 1;
			 if 2*dumpitt_level <= siouxcols - 9   { May 2001 }
		      then if verbose and newline and (suppressor <= suppressorcut)
							    then begin
										     writeln;
								         write(' ': 2*dumpitt_level);
											   dumpitt_length := 2*dumpitt_level
								       end;
			 if n = 0
			    then n := 1;
			 if multin
			    then begin
			            suppressor := suppressor div n;
								  if suppressor <= 1
								     then suppressor := 1
							 end
	 
	 end;

 {************************************************************************}

 procedure purge_list(var p: quoly);
    var q: quoly;
	 begin
	    while p <> nil do
			 begin
				 q := p;
				 p := p^.next;
				 free_quoly(q)			 
			 end
	 end;
	 
 {************************************************************************}

 procedure purge_gcd_stash(j: longint);
    { Leave only the first data node in each hash spot. If that is still too much,
	   remove others, but don't remove the one in spot j!!! ~~~~}
    var i, k: longint;
	     q: quoly;
	 begin
	    k := 0;
		 for i := 0 to gcd_table_size do
		    if gcd_stash[i] <> nil 
			    then begin
				         q := gcd_stash[i];
							purge_list(q^.next);
							k := k + q^.denom^.exp  { previously stored mass }
					   end;
		 i := -1;
		 while k > initial_memory div 6 do
		    begin
			    i := i + 1;
				 if i = gcd_table_prime
				    then leave;
				 if (i = j) or (gcd_stash[i] = nil)
				    then cycle;
				 k := k - gcd_stash[i]^.denom^.exp;
				 purge_list(gcd_stash[i])
			 end;  
		 if k < 0
		    then k := 0;  { fail safe }
		 gcdmass := k
	 end;
  
 {***********************************************************************}
 
function lastexp(p:poly):longint; {~~~~~ can eventually remove}
   var t: poly;
	 begin
	    t:= p;
			while t^.next <> nil do
			   t := t^.next;
	    if t^.numb
			   then lastexp := t^.exp
				 else lastexp := lastexp(t^.pcoef)
	 end;

 procedure gcdhash; {(u, v: poly; var pr: poly)} 

	{    laurents ok.  If (u, v) is in the table, return pointer pr to the 
	  gcd stored there, which might possibly be nil.  Otherwise, add (u, v) to the 
	  table and return pointer to the gcd spot which holds nil. 
	     polygcd_stack_depth is necessary to ensure that a recursive call of polygcd
	  will not try to purge the gcdstash, thereby creating a dangling pointer 'gcdp'
	  within the procedure polygcd.  The coordination of polygcd_stack_depth and lookupgcd
	  with error and others is very delicate. ~~~~}
	
	var equaldegs: boolean;
	    q: quoly;
		 p: poly;
		 i: longint;
	
	{----------------------------------------------------------------------}
	
	function hash(p: poly; level: integer): longint;	
	   var i, val, x: longint;		
		begin		
		   val := 0;
		   for i := 1 to 6 do
			   begin
				   if p^.numb
				      then if lintmode 
						         then if smallmodulus  { Jan 2005  BUG FIX! }
						                 then val := val + p^.ncoef^.lint
						                 else val := val + p^.ncoef^.lint mod gcd_table_prime
								   else begin
								          x := abs(p^.ncoef^.head^.value) mod gcd_table_prime;
											    x := x + p^.ncoef^.size;
											    val := val + x mod gcd_table_prime
										   end
					    else val := val + hash(p^.pcoef, level+1);
				   p := p^.next;
					 if p = nil
					   then leave
			   end;
			hash := (level*val) mod gcd_table_prime  { integer overflow impossible }
		end;
		
    {--------------------------------------------------------------------}
	 
	 function intable(var q: quoly): boolean;	 
	    begin
		    intable := false;
		    while q <> nil do
			    if poly_equal(q^.numer, u)
				    then if poly_equal(q^.denom^.pcoef, v)
					         then begin
								        intable := true;
										  exit(intable)
									  end
								else q := q^.next
					 else if equaldegs
					         then if poly_equal(q^.numer, v)
										  then if poly_equal(q^.denom^.pcoef, u)
													 then begin
															   intable := true;
															   exit(intable)
														   end
													 else q := q^.next
										  else q := q^.next
								else q := q^.next
		 end;
		 
	 {-------------------------------------------------------------------}
	 
	 begin
	 
	    if u^.exp > v^.exp
		    then begin
			         p := u;
						u := v;
						v := p
			      end;
		 equaldegs := (u^.exp = v^.exp);
		 
		 i := hash(u, 1) + hash(v, 1);
		 if i >= gcd_table_prime
		    then i := i - gcd_table_prime;
		 q := gcd_stash[i];
		 if not intable(q)
		    then begin                  
			         newquoly(q);
						q^.next := gcd_stash[i];
						gcd_stash[i] := q;
						q^.numb := false;
						q^.rat := false;
						q^.numer := nil;
						poly_assign(u, q^.numer);
						newpoly(q^.denom);
						p := q^.denom;
						p^.next := nil;  { no gcd is known }
						p^.numb := false;
						p^.exp := simple_poly_mass(u) + simple_poly_mass(v);
						    { mass of the gcd will be added later when computed. }
						gcdmass := gcdmass + p^.exp;
{ writeln('stored. ',i,u^.exp, v^.exp, gcdmass, lastexp(u), lastexp(v)); 
 if modularmode
 then writeln('************ modular'); }
						p^.pcoef := nil;
						poly_assign(v, p^.pcoef);
			         if (gcdmass > initial_memory div 4) and (polygcd_stack_depth = 0)
						   then purge_gcd_stash(i)
			      end
{else begin
       writeln('found. ', i, u^.exp, v^.exp, q^.denom^.next^.exp,' ', 
		          lastexp(u), lastexp(v), lastexp(q^.denom^.next), gcdmass);
		 if not lintmode
		    then if neg_leading_term(q^.denom^.next)
			    then writeln('**** bad gcd coef')
	end } ;
			 
		 pr := q^.denom
	 
	 end;
 
 {************************************************************************}
 
 function quoly_eq_1; { (p: quoly): boolean }
 
    begin	
	   if p^.numb
	      then if lintmode
			        then quoly_eq_1 := (p^.ncoef^.lint = 1)
					  else quoly_eq_1 := (p^.ncoef^.head^.value = 1) & (p^.ncoef^.size = 1)
		   else quoly_eq_1 := false		  
	end;
	
 {************************************************************************}
     
 procedure free_gcd_stash; {~~~~}
 
   { changed Dec 2003.  now called when lookupgcd falls to 0, as before, but
     also when lookupgcd becomes 1, prev_modulus <> modulus, prev_modulus <> -1, OR
     in rat mode, lookupgcd = 1, and prev_modulus <> -1. }
     
   var i: integer;
	 begin
	 

      if modularmode
         then if (prev_modulus = modulus) or (prev_modulus = -1)
                 then begin
                        { DON'T purge. Leave the stuff in hopes of same prime modulus
                          coming up again.  Dec 2003 }
                         prev_modulus := modulus;
                         exit(free_gcd_stash) 
                      end
                 else if (prev_modulus <> modulus) and (lookupgcd = 0)
                         then fermat_error('prev_modulus = modulus in free_gcd_stash');
                         
      prev_modulus := -1;
      
	    for i := 0 to gcd_table_size do
		     purge_list(gcd_stash[i]);
		  gcdmass := 0;
		  lookupgcd := 0;  
		  polygcd_stack_depth := 0
	 end;
  
 {************************************************************************}
 
 procedure leading_term; { (q: quoly; var n: quoly);   Nov 1997 }
    
    { n is nil on input. don't touch q.  q is not a number. q is not a
      rat. copy leading term of q to n, with denominator.  Laurent ok. 
      At end n will need normalizing or other checking.
       Oct 2005: revise to make Lterm work for once, i.e. not just for top level var,
     which is unnatural. 
       works for Laurent too. }
       
    var t, s, nx: poly;
        m: integer;  { Oct 2005 }
        
    begin
    
       newquoly(n);
       n^.numb := false;
       n^.rat := false;
       n^.denom := nil;
       if q^.denom <> nil
          then poly_assign(q^.denom, n^.denom);
       newpoly(n^.numer);
       t := n^.numer;
       s := q^.numer;
       t^.numb := s^.numb; { it might be }
       t^.next := nil;
       t^.pcoef := nil;
       t^.exp := s^.exp;
       if t^.numb
				 then begin
					      init_poly_node(t);
					      if lintmode
							    then t^.ncoef^.lint := s^.ncoef^.lint
								  else num_assign(s^.ncoef^, t^.ncoef^)
						end
			 else if (s^.exp <> 0) or (s^.next <> nil)
			      then poly_assign(s^.pcoef, t^.pcoef)  { Oct 2005. original way, relative to top level. }
			   
			 else begin  { Oct 2005. drop to "right" level, i.e. first non-numb-non-0-exp node. }
			        m := 0;
					    while (s^.exp = 0) and (not s^.numb) and (s^.next = nil) do
					      begin
					        m := m + 1;
					        s := s^.pcoef
					      end;
					    t^.exp := s^.exp;
					    if s^.numb { possible in laurent }
					      then begin
					             t^.numb := true;
					             init_poly_node(t);
					             num_assign(s^.ncoef^, t^.ncoef^)
					           end
						    else begin
						           poly_assign(s^.pcoef, t^.pcoef);
						           add_pad(n^.numer, m)
						         end							 
			 
			      end
			       
    end;
 
 {************************************************************************}
 
 function neg_leading_term; { (n: poly): boolean; } 
 
    begin 
	
	   if n^.numb
	      then if lintmode
			        then neg_leading_term := (n^.ncoef^.lint < 0)
					  else neg_leading_term := (n^.ncoef^.head^.value < 0)
		   else neg_leading_term := neg_leading_term(n^.pcoef)
		  
	end;
	
 {************************************************************************}

 function quol_neg_lead_term; { (n: quoly): boolean } 

    { n^.numer might be a number, if n^denom <> nil. } 
 
    begin
	
	   if n^.numb
	      then if lintmode
			        then quol_neg_lead_term := (n^.ncoef^.lint < 0)
					  else quol_neg_lead_term := (n^.ncoef^.head^.value < 0)
		   else quol_neg_lead_term := neg_leading_term(n^.numer)
		  
	 end;
	
	{************************************************************************}
	
	procedure restore_from_mod;  { var fx: fixptr}
	
	   var p: fixptr;
		    q: quoly;
		 
		begin
		 
		   if fx = nil  { Feb 2004, failsafe(?) }
		      then exit(restore_from_mod);
		      
		   p := fx;  { assumes fx not nil }
			 while true do
				 begin
					 if p^.special = one { marking a quoly that became a number }
						 then begin
									q := quoly(p^.prev);
									q^.denom := nil;
									q^.numb := false
								end
					 else if p^.special = two  { free the two coeffs. }
							   then begin
										  q := quoly(p^.prev);
										  free_imag(q^.ncoef);
										  q^.denom := nil;
										  q^.numb := false
									  end
					 else if p^.special = three  { free the polys numer and denom. }
							   then begin
										  q := quoly(p^.prev);
										  free_poly(q^.numer);
										  free_poly(q^.denom)
									  end				
					 else p^.prev^ := p^.node;
					
					 if p^.next = nil
						 then leave
						 else p := p^.next
				 end;
			 p^.next := fixgarb;
			 fixgarb := fx;
			 fx := nil
											
		 end;
	
	{************************************************************************}
	
	procedure restore_sparsefix;    { Feb 2004 }
	
	  { Note there is no garbage list of sparse_fix nodes }
		 
		begin
		 
			 while sparse_fix <> nil do
				 begin
					  sparse_fix^.prev^ := sparse_fix^.node;
					  sparse_fix := sparse_fix^.next
				 end
											
		 end;
	
 {************************************************************************}
 
 function invertible_coef; { (q: poly; pt: polypt): boolean }
 
    { Assume field_depth > 0.  check for invertible lead-off coef. }
	 
	 var pt2: polypt;
	 
	 begin 
	 
		 pt2 := pt;
		 while not q^.numb do
		    begin
			    if pt2^.depth >= field_depth
				    then leave;
			    pt2 := pt2^.next;
			    q := q^.pcoef
			 end;
	    invertible_coef := not q^.numb
	 
	 end;
 
  {*************************************************************************}
	
  function is_prime; {(x: longint): boolean}  
	
	   var y, limit: longint;
		 
		begin
		 
	      if (x = 2) or (x = 3)
				then begin  
	                 is_prime := true;
			           exit(is_prime)
			        end;
			if (x mod 2 = 0) or (x mod 3 = 0)  
	         then begin  
	                 is_prime := false;
			           exit(is_prime)
			        end;
	      limit := trunc(sqrt(x)) + 2;
	      y := 5;
	      while y <= limit do
	         begin
	             if x mod y = 0
		             then leave;
		          y := y+2;
		          if x mod y = 0
		             then leave;
		          y := y+4
	         end;
	     if y > limit
	        then is_prime := true
	        else is_prime := false
					
	  end;
		
  {*************************************************************************}
	
  procedure prime_factors; {(x: longint; var np: numptr)} 
	
	   { x must be >= 2. np nil or irrelevant on input. }
		
		var y, limit: longint;
		 
		procedure append(n: longint);
		   var p: numptr;
			begin
			   p := np;
				newnode(np);
			   np^.value := n;
			   np^.next := p;
			   x := x div n;
			   while (x mod n = 0) do
				   x := x div n;
				if x = 1
					then exit(prime_factors)
			end;			
			
		begin
		 
	      np := nil;
			if x mod 2 = 0 
			   then append(2);
						  						
			if x mod 3 = 0
	         then append(3);
				
	      if x = 1
				then exit(prime_factors);
						 
		   limit := trunc(sqrt(x)) + 2;
	      y := 5;
	      while y <= limit do
	         begin
	             if x mod y = 0
		             then append(y);
		          y := y+2;
		          if x mod y = 0
		             then append(y);
					 y := y+4
	         end;
	     if x > 1
	        then append(x)
					
	  end;
		
 {***********************************************************************}

 procedure set_prime_quotients; {(var qp: numptr; n: longint)}
 
    { need n >= 2 }
	 
	 var p: numptr;
	 
	 begin
	 
	    prime_factors(n, qp);
		 p := qp;
		 while p <> nil do
		    begin
			    p^.value := n div p^.value;
			    p := p^.next
			 end
		 
	 end;
	 
 {************************************************************************}
 
 function real_degree; {(p: poly; polydepth: integer): integer; Apr 2001 }
    { polydepth is correct, no laurents. Looks like laurents could be OK.
      Mar 2004: change return to longint! } 
    var i: integer;
    begin
       if not p^.numb
          then for i := 2 to polydepth do
					        p := p^.pcoef;
			 real_degree := p^.exp
    end; 
 
 {************************************************************************}
 
 function real_q_degree; {(q: quoly; polydepth: integer): longint; Mar 2004 }
    { polydepth is correct, no laurents. Looks like laurents could be OK. } 
    var i: integer;
        p: poly;
    begin
       if q^.numb
          then real_q_degree := 0
          else begin
                  p := q^.numer;
                  for i := 2 to polydepth do
					           p := p^.pcoef;
			            real_q_degree := p^.exp
			         end
    end; 
 
 {************************************************************************}
 
 function poly_depth { (p: poly): integer }; 
  
    {   poly_depth looks only at the node p is pointing to -- and this is
	   enough!!  
	     poly_depth provides a relative, not absolute depth; it returns 1 in
	   laurent for a poly leading off with a number (which is exactly right!); and 
		it gives a very large answer for (true) numbers.
		  Compare poly_level. }
 
    var ans: integer;
 
    begin
	
	   if p^.numb
	      then begin
		          if p^.next = nil
		             then poly_depth := halfblock  { 'infinity' }
				       else poly_depth := 1;  { a Laurent poly }
				    exit(poly_depth)
			     end
		   else ans := 1;
		  
	   while (p^.exp = 0) and (p^.next = nil) do
	      begin
		      ans := ans + 1;
			   p := p^.pcoef
		   end;
		  
	   poly_depth := ans
		  
   end;
   
 {***********************************************************************}
 
 function poly_level; {(n: poly): longint}
 
    { Compare poly_depth }
 
    var k: longint; 
	 
	 begin
	 
	    if n^.numb
		    then if n^.next = nil
			         then poly_level := 0
						else poly_level := 1
		    else begin
			         k := 1;
						while not n^.numb & (n^.exp = 0) & (n^.next = nil) do
					      begin
						      n := n^.pcoef;
						      k := k + 1
					      end;
					   poly_level := k
					end
	 
	 end;
 
 {***********************************************************************}
 
 function depth_only_2; {(u: poly): boolean;   Oct 2002 }
    { no laurents }
    var p: poly;
    begin
    
       depth_only_2 := false;
       while not u^.numb do
		      begin
				     p := u^.pcoef;
				     if not p^.numb
					      then if not p^.pcoef^.numb
					              then exit(depth_only_2);
				     u := u^.next;  { Nov 2002: was initially u := u^.pcoef !! } 
				     if u = nil
				        then leave  { Mar 2003.  bug fix! } 
			    end;
       depth_only_2 := true
       
    end;
    
 {************************************************************************}
 
 procedure poly_level_depth; {(p, q: poly; ptd: integer; var lev, depth: integer)}
 
   { Combination of poly_depth and quick_depth_below.  no laurents.  p
     or q might be a number. designed for call from polygcd. ptd := pt^.depth.  p
     and q are one level below ptd. lower bound on lev is 2.  upper marks the
     lowest possible poly var.  Oct 2002 }
 
   var k, upper: integer;   { Nov 2002 }
	 
	 begin
	 
	    lev := 2;
	    if field_depth = 0
	       then upper := number_polys - ptd + 1
	       else upper := field_depth - ptd;
	    if p^.numb and q^.numb
	       then begin
	               if upper <= 3
	                  then depth := 2
	                  else depth := 3;
	               exit(poly_level_depth)
	            end;
	            
	    depth := upper;
	    if not p^.numb
	       then begin
	               k := 2;
	               while p^.exp = 0 do
				            begin
					             p := p^.pcoef;
					             Inc(k)
				            end;
                 lev := k;
							 	 depth := k + depth_below(p) - 1;  
							 	 { we want the range of values to be at least 2, if possible }
							 	 if lev > 2
							 	    then lev := lev - 1
							 	    else if depth < upper
							 	            then Inc(depth)
							end;
		
			if q^.numb
			   then exit(poly_level_depth)
			   else begin
			           k := 2;
	               while q^.exp = 0 do
				            begin
					             q := q^.pcoef;
					             Inc(k)
				            end;
                 lev := imaxx(lev, k);
							 	 depth := iminn(depth, k + depth_below(q) - 1); 
							 	 { we want the range of values to be at least 2, if possible }
							 	 if lev > 2
							 	    then lev := lev - 1
							 	    else if depth < upper
							 	            then Inc(depth)
			        end			 
	 
	 end;
 
  {************************************************************************}
		
  procedure poly_to_prime; {(n: poly)}
	
		{ Used in modular mode when modulus is a prime. Exponent is modulus.
		  Just multiply all exps by modulus.
		  Very dangerous in poly_mod_out!  Returned n cannot be multiplied! ~~~~~}
		 
		begin			 
		   while n <> nil do
				begin
				   if not n^.numb
						then begin
								  n^.exp := modulus * n^.exp;
								  if (not n^.pcoef^.numb) | (n^.pcoef^.next <> nil)
									  then poly_to_prime(n^.pcoef)
							  end;
					n := n^.next
				end
		end;  
												
 {***********************************************************************}
 
 procedure dump_mons; {(q: arrptr; n: quoly; strip: boolean)  Aug 1997 }
 
    {  n is number or poly; read-only.  Break n down into its monomials and store in
	     the array q. "strip" means strip off numerical 
	     coefficients (in case n=0, the stored value is still 1). Compare procedure 
		   leading_mon in fer220.   Sep 1997. 
		      Aug 2002: changed to do sparse matrix. On entry, only first block of q^.spar 
		   has been created. }
	 
	 var head: poly;
	     j: longint;
	     sp: sparseptr;
	     u: colm_ptr;
	 
	 {--------------------------------------------------------------}
	 
	 procedure newcolnode(k: longint);
	    begin
	       newcolm(sp^.indx[k]);
				 u := sp^.indx[k];
				 u^.coord := 1;
				 u^.next := nil
	    end;
	    
	 {---------------------------------------------------------------}
	 
	 procedure duplcate(var ans: poly);
  	 var s, t: poly;
		     p, q: polyptrr;
		     depth: integer;  { Jul 2003 }
		     field_coef: boolean;
		 begin
		   s := head;  { the input of nodes that point to stuff to be duplicated }
			 p := @ ans;
			 q := @ ans;  { q is for solving the zero-head-node problem. }
			 depth := 1;  { Jul 2003 }
			 repeat
			   field_coef := (field_depth > 0) and (depth >= field_depth);  { Jul 2003 }
			   t := s^.next;
			   if field_coef and strip  { a kludgy way to make sure we leave. Jul 2003 }
			      then t := poly_1;  
				 newpoly(p^);
				 p^^.next := nil;
				 p^^.exp := t^.exp;
				 p^^.numb := t^.numb;
				 if t^.exp <> 0
					  then q := @ p^^.pcoef;  
				 if t^.numb
				    then begin
										init_poly_node(p^);
										if lintmode
											 then if strip
											         then p^^.ncoef^.lint := 1
													     else p^^.ncoef^.lint := t^.ncoef^.lint
											 else if strip
											         then setvalue(1, p^^.ncoef^)
													     else num_assign(t^.ncoef^, p^^.ncoef^);
										if q <> p  { there is a zero-head-node. }
										   then begin
													    t := p^;  
													    p^ := nil;
													    free_poly(q^);
													    q^ := t
												    end;
										leave
						     end
						else if field_coef  { Jul 2003 }
						        then begin  { t is not a number and we don't want strip }
						                p^^.next := polygarb;
						                polygarb := p^;
						                p^ := nil;
						                poly_assign(t, p^);
						                leave
						             end;
				 s := s^.pcoef;
				 p := @ p^^.pcoef;
				 Inc(depth)  { Jul 2003 }
			 until false
		 end;
	 
	 {--------------------------------------------------------------}
	 
	 procedure attach_it;
	   var q: quoly;
		 begin
		    newquoly(q);
			  q^.numb := false;
			  q^.denom := nil;
		    q^.rat := false;
			  duplcate(q^.numer);
			  if q^.numer^.numb & (q^.numer^.next = nil)
				   then polynum_to_quoly(q);
				j := j + 1;
			  if j > sparsesize
			     then begin
								   newsparse(sp^.next);
								   sp := sp^.next;
								   sp^.next := nil;
								   j := 1
							  end;
				newcolnode(j); { sets u }
			  u^.val := q
		 end;
	 
	 {--------------------------------------------------------------}
	 
	 procedure storepoly(p: poly; var h: poly; depth: integer);  { Jul 2003 }
	    { p points to the input, part of n^.numer. We create one new node h at 
		    each level to point to the nodes at that level as the poly is traversed.  }
	    var field_coef: boolean;
	    begin
		     field_coef:= (field_depth > 0) and (depth >= field_depth);  { Jul 2003 } 
		     newpoly(h);
			   while p <> nil do
				    begin
					     h^.next := p;
						   if p^.numb or field_coef   { Jul 2003 }
						      then attach_it
							    else storepoly(p^.pcoef, h^.pcoef, depth+1);
							 if field_coef
							    then leave  { Jul 2003 }
						      else p := p^.next
				    end;
			   h^.next := polygarb;
			   polygarb := h
		  end;
		 
	 {---------------------------------------------------------------}
	 
	 begin  { all new Aug 2002 }
	   
		 sp := q^.spar;
		 j := 0;
		 sp^.indx[1] := nil;
		 sp^.next := nil;  
		 
		 if n^.numb
		    then if strip { even if n = 0 }
			          then begin
			                  newcolnode(1); { sets u }
			                  u^.val := nil;
			                  quoly_set(1, u^.val)
			               end
						    else if not quoly_iszero(n)
						            then begin
						                    newcolnode(1); { sets u }
						                    u^.val := nil;
						                    quoly_assign(n, u^.val)
						                 end
						            else { nothing }
		    else storepoly(n^.numer, head, 1)  { Jul 2003 }
	 
	 end;
	 
 {***********************************************************************}
 
 function height_is_1; { (n: poly): boolean }
 
    { now works for laurent.  March 14, 1993 
      Oct 2003: compare exp_poly_length. }
	 
	 begin
	
	    height_is_1 := false;
	    while n <> nil do
	       begin
		       if not n^.numb
			       then if not (n^.pcoef^.numb & (n^.pcoef^.next = nil))
				            then exit(height_is_1);
			    n := n^.next
		    end; 
	    height_is_1 := true  		
		  
	 end; 
	
 {************************************************************************}
 
 procedure findHeight; { (var n, m: poly; var h: integer; var pt: polypt) }
 
	{ no good for laurent }
	
	begin
	
	   h := 0;
	   while (n^.exp = 0) & (m^.exp = 0) do
	      begin
		      n := n^.pcoef;
			   m := m^.pcoef;
			   pt := pt^.next;
			   h := h + 1
		   end
		     
    end;

 {***********************************************************************}
 
	procedure max_degree; {(q: poly; lev: longint; var ans: longint)}
	
	   { ~~~~Find max degree of q at level lev.  Caller must preset ans to -infinity. }
		
		begin
			if lev = 1
				then if q^.exp > ans
						  then ans := q^.exp
						  else
				else while q <> nil do
						  begin
							  if q^.numb
								  then if 0 > ans
											 then ans := 0
											 else
								  else max_degree(q^.pcoef, lev - 1, ans);
							  q := q^.next
						  end
		end;
		 		 
 {*********************************************************************}
 
 function leading_coef; { (n: poly): poly }
 
    { NOTE: in laurent, n is not necessarily pointing to a poly that is ONLY
	  a number!  Outside laurent, it is. }
 
    begin
	
	   while not n^.numb do
	      n := n^.pcoef; 
	   leading_coef := n
	  
	end;
	
 {**************************************************************************}
 
 procedure quoly_consume; {(var n: quoly; var p: poly)}  
 
    { convert number n to poly format by consuming n. p is nil or irrelevant.  }
 
    begin
	
	   newpoly(p);
	   p^.next := nil;
	   p^.exp := 0;
	   p^.numb := true;
	   p^.ncoef := n^.ncoef;
	   n^.next := quolygarb;
      quolygarb := n;
	   n := nil 
	   
	end;
	 
 {***********************************************************************}
 
 procedure direct_number_read(var n: number);
 
    var i: integer;
        nsz: longint;
	     p: numptr;
	 
	 begin 
	 
	    read(char_poly_data, nsz);
	    n.size := Integer(nsz);
		 newnode(n.head);
		 p := n.head;
		 for i := 1 to n.size do
		    begin
			    read(char_poly_data, p^.value);
				 if i < n.size
				    then begin
					         newnode(p^.next);
				            p := p^.next
						   end
			 end;
		 p^.next := nil;
		 n.tail := p
	 	 
	 end;
  
 {**************************************************************************}
 
 procedure direct_poly_read(var p: poly);
 
    var q: poly;
	     i: longint;
	 
	 procedure fillup(var p: poly);
	    var q: poly;
		 begin
		    newpoly(p^.pcoef);
			 q := p^.pcoef;
			 q^.numb := true;
			 q^.exp := 0;
			 q^.next := nil;
			 newimag(q^.ncoef);
			 direct_number_read(q^.ncoef^)
	    end;
	 
	 begin
	 
	    newpoly(p);
		 read(char_poly_data, p^.exp);
		 p^.numb := false;
		 fillup(p);
		 q := p;
		 for i := p^.exp - 1 downto 0 do
		    begin
			    newpoly(q^.next);
				 q := q^.next;
				 q^.exp := i;
				 q^.numb := (i = 0);
				 if q^.numb
				    then begin
					         q^.next := nil;
								newimag(q^.ncoef);
			               direct_number_read(q^.ncoef^)
					      end
					 else fillup(q)
			 end
	 
	 end;
 
 {**************************************************************************}
 
 procedure direct_quoly_read(var q: quoly);
 
    { works independently of modularmode }
	 
	 var p: poly;
	 
	 begin
	 
	    newquoly(q);
		 q^.numb := false;
		 q^.rat := false;
	    newpoly(q^.denom);
		 p := q^.denom;
		 p^.numb := true;
	    p^.next := nil;
		 p^.exp := 0;
		 newimag(p^.ncoef);
	    direct_number_read(p^.ncoef^);
		 if (p^.ncoef^.head^.value = 1) and (p^.ncoef^.size = 1)
		    then free_poly(q^.denom);
		 direct_poly_read(q^.numer)
		 	 
	 end;
  
 {**************************************************************************}
 
 procedure poly_consume; {(var n: poly; var q: quoly)}
 
    { convert number n to quoly format by consuming n. q must be nil or irrelevant.}
 
    begin
	
	   newquoly(q);
	   q^.numb := true;
	   q^.ncoef := n^.ncoef;
	   n^.next := polygarb;
      polygarb := n;
	   n := nil
	   
	end; 
	 
  {**************************************************************************}
 
 procedure use_up_poly; {(var n: poly; var q: quoly)}
 
    { q must be nil or irrelevant. nodes of n are totally used up or freed. Oct 2003 }
 
    begin
	
	      if n^.numb
				   then poly_consume(n, q)
				   else begin
				           newquoly(q);
			             q^.numb := false;
			             q^.rat := false;  
					         q^.numer := n;
					         q^.denom := nil
					      end
	   
	end; 
	 
  {*************************************************************************}
	 
  procedure insert_new_prime(this_prime, x: longint; ii: imptrptr);	
  
	  var q: imptr;
	  
	  begin
	  
		  newimag(q);
		  q^.size := 1;
		  q^.lint := this_prime;
		  q^.imag := ii^;
		  ii^ := q;
		  newnode(q^.head);
		  q^.head^.value := x;
		  q^.head^.next := nil;
		  q^.tail := q^.head
		  
	  end;		 
		 
 {*************************************************************************}
 
 procedure add_prime_to_list; {(q: polypt; thisone, x: longint)}
 
    var ii: imptrptr;
	 
	 begin
	 
	    ii := @ q^.gcd_data;
	    while ii^ <> nil do
			 if ii^^.lint > thisone
				 then ii := @ ii^^.imag
			 else if ii^^.lint = thisone
				 then leave { prime is already present }
			 else begin
					   insert_new_prime(thisone, x, ii);
					   leave
				   end;
		 if ii^ = nil
			 then insert_new_prime(thisone, x, ii)

	 end;
 
 {*************************************************************************}
 
 procedure add_all_to_list; {(q: polypt; x: longint; var y: number)}
 
    {    Caller has evaluated some polynomial at x, with result y.  Find the primes
	   p that are in the file 'primelist' (< 10000), are at least 40, and that divide 
		into y, add the data pairs (p, x) to the list q^.gcd_data, unless p already occurs
		in the list.  y will be changed.  q^.gcd_data could be nil on input.  must 
		be in rational mode. 
		    im's list will be built up in reverse order, largest prime first. }
		
	 var i: integer;
		  this_prime: longint;
		  prme, quot, rem: number;
	 
	 begin
 
       if y.head^.value = 0
		    then exit(add_all_to_list)
		    else if y.head^.value < 0
		            then in_place_neg(y);
			 		 
		 i := 0;
		 prme.size := 0;
		 rem.size := 0;
		 quot.size := 0;
		 setvalue(1, prme);
		 while (y.size <> 1) or (y.head^.value <> 1) do
		    begin
			    i := i + 1;
				 if i > small_prime_size
				    then leave;
				 prme.head^.value := small_prime^[i];
			    divide(y, prme, quot, rem);
			    if rem.head^.value = 0
				    then begin
					         repeat
								   free_num(y);
					            y := quot;
								   quot.size := 0;
								   divide(y, prme, quot, rem)
							   until rem.head^.value <> 0;
								this_prime := prme.head^.value;
								if this_prime > 40 
								   then add_prime_to_list(q, this_prime, x mod this_prime)
					      end
			 end;
		 
		 free_num(prme);
		 free_num(quot);
		 free_num(rem)
		 
    end;
 
 {**************************************************************************}
 
 procedure free_gcd_data; {(q: polypt)}
 
    var im: imptr; 
	 
    begin
	
	    while q^.gcd_data <> nil do  
			 begin
				 im := q^.gcd_data;
				 q^.gcd_data := im^.imag;
				 free_imag(im)
			 end;
		 q^.aux_num := 0
					 
    end;
					 					
 {***************************************************************************}
 
 procedure find_gcdcoefs; {(p: poly; var com: number)}
   
    { used in rational mode.  find gcd of all numerical coefs in p. com is positive. 
	    p can't be 0. works for laurents. <~~~}
	   
    procedure find_gcd(p: poly; var com: number);
	     begin
		      while p <> nil do
		         begin
				        if p^.numb
					         then binary_gcd(com, p^.ncoef^, com)  { Jul 2002 }
						       else find_gcd(p^.pcoef, com); 
					      if (com.size = 1) & (com.head^.value = 1)
					         then exit(find_gcdcoefs);
					      p := p^.next
			       end
	     end;
 
   begin
	
	   if node_iszero(p) 
		    then begin
				        fermat_error('0 in find gcd coefs.');
						    setvalue(1, com);
						    exit(find_gcdcoefs) {~~~}
				     end;
	   abs_val_num(leading_coef(p)^.ncoef^, com);
	   find_gcd(p, com)
		 	   
	 end;
		   
 {*************************************************************************}
 
 function cant_factor; {(q: poly; var errno: longint; check_below: boolean): boolean}
 
    { q is not a number. no laurents.  
	 
	    used to be (q: poly; var index, errno: longint): boolean
		 Right now, check_below is always true.  Some day may have a more sophisticated
		 square free factoring routine.
		 
		 Oct 1996: Someday has arrived. }
	 
	 var p: polypt;
	     depth, k, i, fd: integer;
	 
	 begin
	 
	    cant_factor := true;
		 depth := 1;
		 while q^.exp = 0 do
		     begin
			     depth := depth + 1;
				  q := q^.pcoef
			  end;
		 p := polynames;
		 k := -1;
		 i := 1;
		 while p <> nil do 
			 begin
				 if (p^.p <> nil) and not p^.field
					 then k := i;
				 p := p^.next;
				 i := i + 1
			 end;
		 errno := 298;
		 if k >= depth
		    then exit(cant_factor);
		 errno := 299;
		 if field_depth = 0
		    then fd := halfblock
			 else fd := field_depth;
		 if check_below and (depth < fd)
		    then if nogood(q, depth, field_depth)
		            then exit(cant_factor);
		 cant_factor := false
		 
	 end;
	 
 {************************************************************************}
 
 function nogood; {(u: poly; depth, test_depth: integer): boolean}
 
    {    u^.exp <> 0.  depth = u's level.  Assume u is above test_depth.  
	   test_depth is usually field_depth, which can be 0.  If all coefs are numbers, 
		nogood is false; i.e., such a poly is called "good".  nogood is true if any 
		term in any p^.coef of u involves a poly var above test_depth. 
		   Looks like Laurent is ok (Sept 1995) } 
		
	 begin
		 if depth + 1 = test_depth
			 then nogood := false
			 else begin
					   nogood := true;
					   while u <> nil do
							begin
								if not u^.numb
									then if u^.pcoef^.exp = 0
											  then begin
														 if not u^.pcoef^.numb
															 then if nogood(u^.pcoef, depth + 1, test_depth)
																		then exit(nogood)
													 end
											  else exit(nogood);
								u := u^.next
							end;
						nogood := false
				   end
	 end;

 {************************************************************************}
 
 function first_coef_invrtble; { (q: poly; depth: integer): boolean }
 
    { q is not a number. no laurents. Is q^.pcoef invertible? }
	 
	 begin 	
	 
		 q := q^.pcoef;  
		 if q^.numb
			 then begin
					   if field_depth > 0
							then first_coef_invrtble := true
							else first_coef_invrtble := modularmode and mod_is_prime;
					   exit(first_coef_invrtble)
				   end
			 else if field_depth = 0
					   then begin
						        first_coef_invrtble := false;
					           exit(first_coef_invrtble)
				           end;
					
		 depth := depth + 1;
		 while q^.exp = 0 do
		    begin
			    q := q^.pcoef;
				 depth := depth + 1
			 end;
	    first_coef_invrtble := (depth >= field_depth)
	 
	 end;
 
 {*************************************************************************}
 
 function mod_mult; {(var x,y,modul: longint): longint;  big simplification Apr 2004.}
    var z: Uint32;  { Oct 2004 }
    begin
       if f256
          then begin
                  mod_mult := longint(f256prod^[x, y]);
                  exit(mod_mult)
               end;

       if f2t16   { Jul 2004 }
          then if (x=0) or (y=0)
                  then mod_mult := 0
                  else begin
			                    z := f2t16log[x] + f2t16log[y];
			                    if z >= halfmask  { 65535 }
				                     then mod_mult := f2t16exp[z - halfmask]
			                       else mod_mult := f2t16exp[z]
			                 end
       else begin
				       z := Uint32(x) * Uint32(y);  { modul < halfmask; June 1998 }
               if z >= Uint32(modul)
							    then mod_mult := longint(z mod Uint32(modul))
						      else mod_mult := longint(z)
						end
    end;
	 
 {*************************************************************************}
 
 function spec_mod_add; {( x: Uint32; y, modul: longint): longint;}
     { Apr 2004. x can be >= block but must be positive and < modul. y can be negative but
       must be less than block in abs value.  abs(y) can be larger than modul.  
       don't worry about f256. Jun 2004 }
     
    begin
       if y < 0
          then begin
                  y := y mod modul;
                  y := y + modul
               end;
       if y >= modul
          then y := y mod modul;
               
       { so y is >= 0 now }
       x := x + y;
		   if x >= Uint32(modul)
			    then spec_mod_add := longint(x - Uint32(modul))
		      else spec_mod_add := longint(x)
    end;
	 
 {*************************************************************************}
 
 function mod_add; {(x,y: Uint32; modul: longint): longint;} 
    begin
       if finf  { Sep 2004 }
          then mod_add := longint(BXor(x,y))
       else begin
               x := x + y;
						   if x >= Uint32(modul)
							    then mod_add := longint(x - Uint32(modul))
						      else mod_add := longint(x)
						end
    end;
	 
 {*************************************************************************}
 
 function mod_sub; {(var x,y,modul: longint): longint;}
    begin
       if finf  { Sep 2004 }
          then mod_sub := longint(BXor(x,y))
       else begin
               x := x - y;
						   if x < 0
							    then mod_sub := x + modul
						      else mod_sub := x
						   end
    end;
	 
 {*************************************************************************}
 
 function modmult; {(x,y: Uint32): longint;  Sep 2004 }
    { x and y are legal modular values. allow big mults. }
    var z: Uint32;  { Sep 2004. massive changes below }
        r, t: longreal;
    begin
       if f256
          then begin
                  modmult := longint(f256prod^[x,y]);
                  exit(modmult)
               end;

       if f2t16   { Sep 2004 }
          then if (x=0) or (y=0)
                  then begin
		                     modmult := 0;
		                     exit(modmult)
		                   end
							    else begin
										      z := Uint32(f2t16log[x]) + Uint32(f2t16log[y]);
										      if z >= Uint32(halfmask)  { 65535 }
											       then modmult := f2t16exp[z - halfmask]
										         else modmult := f2t16exp[z];
										      exit(modmult)
										   end;

       if smallmodulus
          then begin
				          z := x * y;  
					        if z >= Uint32(modulus)
								     then modmult := longint(z mod modulus)
							       else modmult := longint(z)
							 end
				  else begin
				          r := x;
				          r := r * y;
				          t := trunc(r/rmodulus); 
									modmult := round(r - t*rmodulus)
				       end
    end;
	 
 {*************************************************************************}
 
 function spec_modmult; {(x,y: Uint32): longint;   }
    { x and y are legal modular values. procedure mod_simple_case 
      Sep 2004: answer can be > block, must be < modulus - 1 }
    var z: Uint32;  { Sep 2004 }
        r, t: longreal;
    begin
       if smallmodulus
          then begin
				          z := x * y;  
					        if z >= modulus - 1
								     then spec_modmult := longint(z mod (modulus - 1))
							       else spec_modmult := longint(z)
							 end
				  else begin
				          r := x;
				          r := r * y;
				          t := trunc(r/(rmodulus-1)); 
									spec_modmult := round(r - t*(rmodulus-1))
				       end
    end;
	 
 {******************************************************************}

  procedure verse; {(var ans: longint);} 
     
     { seca can't be 0. Apparently ans is assumed invertible. June 1998.
       Careful of calling and falling into infinite loop.
       Sep 2004. apparently same as mod_inverse, so OK for large modulus  }
	
     var q, firsta, seca, firstf, secf, temp: longint;
	  
     begin
		 
      if finf {  Oct 2004 }
         then begin
                 ans := longint(f2t16inv[ans]);
                 exit(verse)
              end;
  
      seca := ans;
			firsta := modulus;
			secf := 1;
			firstf := 0;
			while true do  { June 1998. speed up loop }
				begin
					q := firsta div seca;
					temp := firsta - seca * q;
					if temp = 0
					   then begin
					           if secf < 0
					              then ans := secf + modulus
					              else ans := secf;
					           exit(verse)
					        end;
					firsta := seca;
					seca := temp;
			      temp := firstf - q * secf;
					firstf := secf;
					secf := temp
				end
	
     end;       
 
 {**************************************************************************}
 
  function poly_numterms(n: poly; depth: integer): longint; { changed Jul 2003 }
 
	 { called only by numterms.  changed so that a field element is just one term. Jul 2003
	   n is authenic. }
	 
	 var s: longint;

	 begin
		 
		 { assume n <> nil for this first case. }
		 if field_depth > 0  { Jul 2003 }
		    then if depth >= field_depth  
						    then begin
						            poly_numterms := 1;
						            exit(poly_numterms)
						         end;
		         
		 s := 0;
		 while n <> nil do
			  begin
					 if n^.numb
						  then Inc(s)
						  else s := s + poly_numterms(n^.pcoef, depth + 1);
					 n := n^.next
			  end;
		 poly_numterms := s
	
	 end;

 {**************************************************************************}
 
  function qpoly_numterms; { (n: poly; depth: integer): longint;  Mar 2006 }
	 
	 var s: longint;

	 begin
		 
		 if field_depth > 0  
		    then if depth >= field_depth  
						    then begin
						            qpoly_numterms := 1;
						            exit(qpoly_numterms)
						         end;
		         
		 s := 0;
		 while n <> nil do
			  begin
					 if n^.numb
						  then Inc(s)
						  else begin
						          s := s + qpoly_numterms(n^.pcoef, depth + 1);
						          if s > 1000 
						             then leave
						       end;
					 n := n^.next
			  end;
		 qpoly_numterms := s
	
	 end;

 {**************************************************************************}
 
 function numterms; {(n: quoly): longint}
    { n is not a number. a field element is just one term. Jul 2003.
      added second arg to poly_numterms. }
    begin	 
	     if n^.denom = nil
	        then numterms := poly_numterms(n^.numer, 1)
	        else numterms := poly_numterms(n^.numer, 1) + poly_numterms(n^.denom, 1)
	  end;
 
 {******************************************************************************}
 
 function f_poly_numterms; {(n: poly): longint; }
 
	 { called only by fieldterms. count field elements as distinct terms. Jul 2003.
	   n is authenic. }
	 
	 var s: longint;

	 begin
		 
		 s := 0;
		 while n <> nil do
			  begin
					 if n^.numb
						  then Inc(s)
						  else s := s + f_poly_numterms(n^.pcoef);
					 n := n^.next
			  end;
		 f_poly_numterms := s
	
	 end;

{**************************************************************************}
 
 function poly_nodes; {(n: poly): integer.  changed Oct 2002. had been unused
                        compare node_total.  This one only counts numbers. } 
 
	 var s: integer;

	 begin
		 
			s := 0;
			while n <> nil do
				 begin
						if n^.numb
						   then Inc(s)
						   else s := s + poly_nodes(n^.pcoef);
						if s > 40  { was 5, Oct 2002 }
							 then leave
							 else n := n^.next
				 end;
			poly_nodes := s
	
	 end;
	
   {************************************************************************}
		
	procedure poly_change_from_mod; {(p: poly)}
	  { modularmode is off. 
      Sep 2004. make OK for large modulus.  a pain.
      We assume the lint value (x below) is legal, i.e. not negative and
      < modulus.  We go out of our way to make sure we do NOT change x.  I'm not
      sure this is necessary, but it may be assumed by some of the fast in-and-out
      routines.
        NOTE:  This is inappropriate for finf!  Makes no sense.  Warn user! } 
        
		var x: lintptr;
        np: imptr;
        val: longint;
        
		begin			 
		   while p <> nil do
				  begin
						 if p^.numb
								then begin
								       x := @ p^.ncoef^.lint;
								       if modulus < block  { classic case }
                         then if alt_form_display & (x^ > modulus div 2)  { added alt_form_display  Jun 2004 }
                                 then setvalue(x^ - modulus, p^.ncoef^)
                                 else setvalue(x^, p^.ncoef^)
                         else  {  modulus >= block }
                              if alt_form_display & (x^ > modulus div 2)  
											          { the hardest case. added alt_form_display  Jun 2004 
											             Note: due to outsize values, val might be up to 2^31-1. }
											          then begin
											                  val := x^ - modulus;  { Note: this is negative (probably!) }
												                if (val > negblock) & (val < block) { Jun 2004 }
												                   then setvalue(val, p^.ncoef^)
																	         else begin
																				           setvalue(val mod block, p^.ncoef^);
																				           np := p^.ncoef;
																			             np^.size := 2;
																				           newnode(np^.head);
																				           np^.head^.next := np^.tail;
																				           np^.head^.value := val div block
																				        end
                                     end
                                 else if x^ < block
															           then setvalue(x^, p^.ncoef^)
															         else begin
																		           setvalue(x^ mod block, p^.ncoef^);
																		           np := p^.ncoef;
																	             np^.size := 2;
																		           newnode(np^.head);
																		           np^.head^.next := np^.tail;
																		           np^.head^.value := x^ div block
																		        end
										 end
					 			else poly_change_from_mod(p^.pcoef);
						 p := p^.next
				  end		  
	   end;
			    
  {*************************************************************************}
	
	procedure quoly_change_from_mod; {( q: quoly)   Sep 2004 }
	
	  { modularmode is off.
      Apr 2004. make OK for large modulus.  a pain.
      We assume the lint value (*x below) is legal, i.e. not negative and
      < modulus.  We go out of our way to make sure we do NOT change *x.  I'm not
      sure this is necessary, but it may be assumed by some of the fast in-and-out
      routines.  Jun 2004: YES IT IS NECESSARY! 
        NOTE:  This is inappropriate for finf!  Makes no sense.  Warn user! }
	
		 var x: lintptr;
        np: imptr;
        val: longint;
     
     begin
		 
		   if q^.numb
		      then begin
					       x := @ q^.ncoef^.lint;
					       if modulus < block  { classic case }
                   then if alt_form_display & (x^ > modulus div 2)  { added alt_form_display  Jun 2004 }
                           then setvalue(x^ - modulus, q^.ncoef^)
                           else setvalue(x^, q^.ncoef^)
                   else  {  modulus >= block }
                        if alt_form_display & (x^ > modulus div 2)  
								          { the hardest case. added alt_form_display  Jun 2004 
								             Note: due to outsize values, val might be up to 2^31-1. }
								          then begin
								                  val := x^ - modulus;  { Note: this is negative (probably!) }
									                if (val > negblock) & (val < block) { Jun 2004 }
									                   then setvalue(val, q^.ncoef^)
														         else begin
																	           setvalue(val mod block, q^.ncoef^);
																	           np := q^.ncoef;
																             np^.size := 2;
																	           newnode(np^.head);
																	           np^.head^.next := np^.tail;
																	           np^.head^.value := val div block
																	        end
                               end
                           else if x^ < block
												           then setvalue(x^, q^.ncoef^)
												         else begin
															           setvalue(x^ mod block, q^.ncoef^);
															           np := q^.ncoef;
														             np^.size := 2;
															           newnode(np^.head);
															           np^.head^.next := np^.tail;
															           np^.head^.value := x^ div block
															        end
							 end
			 else begin
						   poly_change_from_mod(q^.numer);
						   if q^.denom <> nil
							    then poly_change_from_mod(q^.denom)
										{ don't need check_quoly(q) }							
					  end  
						 
		end;				 		
		
  {***************************************************************************}

  procedure get_char_poly;{(i, j: integer; var q: quoly)}
  
     begin
		  
		  Seek(char_poly_data, pol_index^[i,j]);  
		
		{  pol_index^[i,j] := Plfilepos(char_poly_data);  }
		  
		  direct_quoly_read(q)
		  
	  end;   
						
  {***************************************************************************}

  procedure Set_prods_for_char;
	
	  { Initializations for char_poly @@@ moved here}
   
	  var i, j: integer;
	  
	  begin	
		    
			{ start to set up characteristic poly stuff. Finish if user
		     actually attaches a poly var. }
			for i := 1 to full_charpol do
				begin
					denom[i] := nil;
					quoly_set(i, denom[i]) 
				end;
				 				
			size_data_structs := size_data_structs + full_charpol * sizequoly(denom[1]);
			
			for i := first_step + 1 to in_house_charpol - 1 do
			    for j := 1 to i + 1 do
					 begin
					    get_char_poly(i, j, pol^[i,j]);
					    size_data_structs := size_data_structs + sizequoly(pol^[i,j])
					 end
								
		 end;

 {****************************************************************************}
 
 procedure num_poly_quot; {(n: poly; var m: number; x: longint)}
 
    {  In modularmode, assumes modulus is invertible, or at least that m is 
	        invertible.
			 In rational mode, must have that m divides evenly into all coefficients of n,
	        else coefs of 0 will appear in the answer, due to truncation. ~~~~
	     Jan 2005:  rearranged a lot of things. }
   
    procedure simple_quot(var n1, n2: number);
		  var n4: number;  { moved here Jan 2005 }
		  begin
				if lintmode
				   then if modularmode
						       then n1.lint := modmult(n1.lint, x)  { Aug 2001 }
				           else n1.lint := n1.lint div n2.lint
				   else begin
									 n4.size := 0;
			             divide(n1, n2, n1, n4);
									 if n4.head^.value <> 0
									    then fermat_error('non-0 rem, num_poly_quot');
									 free_num(n4)
							  end 
		  end;

   begin
							 
			if modularmode & (x = 0)
			   then mod_inverse(m.lint, x);
			while n <> nil do
			   begin
				    if n^.numb
					     then simple_quot(n^.ncoef^, m)
					     else num_poly_quot(n^.pcoef, m, x);
				    n := n^.next
			   end
					
	end;
		
 {****************************************************************************}
 
 procedure num_poly_mult; {(n: poly; var m: number)}
 
     {  rational mode. must have that m divides evenly into all coefficients of n,
	   else coefs of 0 will appear in the answer, due to truncation. ~~~~}
 
   begin							 
		while n <> nil do
		   begin
			   if n^.numb
				   then fast_mult(n^.ncoef^, m, n^.ncoef^)
				   else num_poly_mult(n^.pcoef, m);
			   n := n^.next
		   end
	end;

 {****************************************************************************}
 
 procedure mod_num_poly_mult; {(n: poly; x: longint)}
 
    {   modularmode.  laurent ok.  multiply n by x in place.  x > 0 and small 
	      enough that no overflow results below -- presumably x < modulus. 
	      compare number_by_poly in 220.p.  Oct 2003  }
 
	begin
							 
		while n <> nil do
		   begin
			   if n^.numb
				   then n^.ncoef^.lint := modmult(n^.ncoef^.lint, x)  { Aug 2001 }
				   else mod_num_poly_mult(n^.pcoef, x);
			   n := n^.next
		   end
					
	end;
		
 {**************************************************************************}
	
 procedure monic_coefs; {(u, v: poly; var ucoef, vcoef: longint)}
 
    { modularmode ~~~~ modulus is assumed prime.  June 1998 }
	 
	 var x: longint;
	 
	 begin
	 
	    ucoef := leading_coef(u)^.ncoef^.lint;
		 if ucoef <> 1
		    then begin
			         mod_inverse(ucoef, x);
						mod_num_poly_mult(u, x)
			      end;
		 vcoef := leading_coef(v)^.ncoef^.lint;
		 if vcoef <> 1
		    then begin
			         mod_inverse(vcoef, x);
						mod_num_poly_mult(v, x)
			      end
	 
	 end;
 
 {**************************************************************************}
 
 function imaxx; {(a, b: integer): integer}
	 begin
		 if a > b
			 then imaxx := a
			 else imaxx := b
	 end;
					 
 {***************************************************************************}
	
  function depth_below; {(p: poly): integer}
  
	  { laurent ok.  depth below p.  fer220 has a quick_depth_below. 
	  
	    Nov 2002: more like depth from p on down. }
	  
	  var d: integer;
	 
	  begin
		   d := 0; 
		   while p <> nil do
				  begin
					   if not p^.numb
						    then d := imaxx(d, 1 + depth_below(p^.pcoef));
					   p := p^.next
				  end;
		   depth_below := d
	  end;
	 
  {****************************************************************************}
 
 procedure copy_syst; { var arr: workarray; rows: longint; var spar: sparseptr}
    var j: longint;  { Nov 1997 }
    begin
      if syst^.spar = nil
		   then for j := 0 to syst^.stop do
					  begin
						  arr[j] := nil;
						  quoly_assign(stash^[j], arr[j])
					  end
			else copy_sparse(syst^.spar, spar, rows, false)
	 end;
	 
 {******************************************************************************}															 
																			 
 function poly_height; {(p: poly): integer;} 
		 
	 { laurent ok. maximum difference in depth anywhere in p }
	 	 
	 begin
	 
		 { ignore leading dummy nodes }
		 while not p^.numb do
			 if (p^.exp = 0) and (p^.next = nil)
				 then p := p^.pcoef
				 else leave;
		 poly_height := depth_below(p)
			
	 end;
			 
  {****************************************************************************}
	
 function sparse_allnumbs; {(sp: sparseptr; rows: longint): boolean; Nov 2000. }
 
    var i, k: longint;
		  u: colm_ptr;
		
	 begin
		
		 for k := 0 to (rows - 1) div sparsesize do
			  begin
					 for i := 1 to sparsesize do
						  if i > rows
								 then leave
								 else begin
												u := sp^.indx[i];
												while u <> nil do
													 begin
															if not u^.val^.numb
															   then begin
														             sparse_allnumbs := false;
																	       exit(sparse_allnumbs)
														          end;
															u := u^.next
													 end
										  end;
					 sp := sp^.next;
					 rows := rows - sparsesize
			  end;
			 
		 sparse_allnumbs := true
			 
	 end;
 
	{****************************************************************************}
	 
	function sparse_polydepth; {(sp: sparseptr; rows: longint): integer;  Feb 2004 }
	
	 { assumes array is all polys }
	
   var i, k: longint;
		   u: colm_ptr;
		   pd, thisdepth: integer;
		
	 begin
		
		 pd := halfblock;  { means all numbers }
		 for k := 0 to (rows - 1) div sparsesize do
			  begin
					 for i := 1 to sparsesize do
						  if i > rows
								 then leave
								 else begin
												u := sp^.indx[i];
												while u <> nil do
													 begin
															if not u^.val^.numb
															   then begin
														             thisdepth := poly_depth(u^.val^.numer);
																				 if thisdepth < pd
																						then pd := thisdepth
														          end;
															u := u^.next
													 end
										  end;
					 sp := sp^.next;
					 rows := rows - sparsesize
			  end;

		 sparse_polydepth := pd
			 
	 end;
 
	{****************************************************************************}
	 
	function anynegs; {(p: poly): boolean;}
	 
		{ Is there a negative exponent in p?  laurent ok. moved here Oct 2003 }
 
		begin
			 anynegs := true;
			 while p <> nil do
					if p^.exp < 0
						 then exit(anynegs)
						 else if p^.numb
										 then p := p^.next
										 else if anynegs(p^.pcoef)
														 then exit(anynegs)
														 else p := p^.next;										
			 anynegs := false	        					
		end;
				
 {**********************************************************************}
 
 function negexponents; {(var ar: workarray; m: longint): boolean; }  
 
	 { laurent ok.  Don't look at denoms. moved here Oct 2003 }
	 var i: longint;
		
	 begin
	 
		 negexponents := true;
		 for i := 0 to sqr(m) - 1 do
			  if not ar[i]^.numb
				   then if anynegs(ar[i]^.numer)
							     then exit(negexponents);
		 negexponents := false
		 
	 end;
				
 {**********************************************************************}
 
 function sparse_negexponents; {(sp: sparseptr; m: longint): boolean; }  
 
	 { laurent ok.  Don't look at denoms. Oct 2003 }
	 
	 var i, k: longint;
		   u: colm_ptr;
		
	 begin
		
		 sparse_negexponents := true;
		 
		 for k := 0 to (m - 1) div sparsesize do
			 begin
				 for i := 1 to sparsesize do
					 if i > m
						 then leave
						 else begin
										u := sp^.indx[i];
										while u <> nil do
											begin
												if not u^.val^.numb
												   then if anynegs(u^.val^.numer)
													         then exit(sparse_negexponents);
												u := u^.next
											end
								  end;
				 sp := sp^.next;
				 m := m - sparsesize
			 end;
			 
		 sparse_negexponents := false
		 
	 end;
				
 {****************************************************************************}
	
 function sparse_allpolys; {(sp: sparseptr; rows: longint; var allnumbs: boolean): boolean; Sept 1996.
  
    Note new way of structuring a sparse loop.  added allnumbs Mar 2004 }
 
   var i, k: longint;
		  u: colm_ptr;
		
	 begin
		
		 allnumbs := true;
		 for k := 0 to (rows - 1) div sparsesize do
			 begin
				 for i := 1 to sparsesize do
					 if i > rows
						 then leave
						 else begin
										u := sp^.indx[i];
										while u <> nil do
											 begin
													if not u^.val^.numb
													   then begin
													           allnumbs := false;
													           if u^.val^.denom <> nil
															          then begin
																		            sparse_allpolys := false;
																					      exit(sparse_allpolys)
																	           end
																	end;
													u := u^.next
											 end
								  end;
				 sp := sp^.next;
				 rows := rows - sparsesize
			 end;
			 
		 sparse_allpolys := true
			 
	 end;
 
{****************************************************************************}
	
 procedure move_data_into_quoly; {(sp: sparseptr; rows: longint); Nov 2000. }
 
    { modularmode and all entries are known to be numbers }
    
    var i, k: longint;
		    u: colm_ptr;
		    q: quoly;
		
	 begin
		
		 for k := 0 to (rows - 1) div sparsesize do
			  begin
					 for i := 1 to sparsesize do
						  if i > rows
								 then leave
								 else begin
												u := sp^.indx[i];
												while u <> nil do
													 begin
															q := u^.val;
															u^.val := quoly(q^.ncoef^.lint);
															free_quoly(q);
															u := u^.next
													 end
										  end;
					 sp := sp^.next;
					 rows := rows - sparsesize
			  end
			 
	 end;
 
{****************************************************************************}
	
 procedure move_data_outof_quoly; {(sp: sparseptr; rows: longint); Nove 2000. }
 
    { modularmode.  all entries are known to be numbers, and are stored in 
      the quoly nodes.  None are 0.  Presumably each row has only one node,
      but that doesn't matter here. }
    
    var i, k, value: longint;
		    u: colm_ptr;
		
	 begin
		
		 for k := 0 to (rows - 1) div sparsesize do
			  begin
					 for i := 1 to sparsesize do
						  if i > rows
								 then leave
								 else begin
												u := sp^.indx[i];
												while u <> nil do
													 begin
															value := Ord4(u^.val);
															if value = 0
															   then fermat_error('0 value in move_data_outof_quoly.');
															u^.val := nil;
															quoly_set(value, u^.val);
															u := u^.next
													 end
										  end;
					 sp := sp^.next;
					 rows := rows - sparsesize
			  end
			 
	 end;
 
{****************************************************************************}
	
 procedure put_back_sparse; { (dup, spar: sparseptr; rows: longint);  Nove 2000. }
 
    { dup and spar are the same size.  Go down the rows killing off spar's nodes
      and replacing them with dup's.  At end, dup is just a skeleton. }
    
    var i, k: longint;
		    u: colm_ptrptr;
		
	 begin
		
		 for k := 0 to (rows - 1) div sparsesize do
			  begin
					 for i := 1 to sparsesize do
						  if i > rows
								 then leave
								 else begin
												u := @ spar^.indx[i];
												while u^ <> nil do
													 begin
															free_quoly(u^^.val);
															u := @ u^^.next
													 end;
												u^ := colm_garb;
												colm_garb := spar^.indx[i];
												spar^.indx[i] := dup^.indx[i];
												dup^.indx[i] := nil
										  end;
					 spar := spar^.next;
					 dup := dup^.next;
					 rows := rows - sparsesize
			  end
			 
	 end;
 
  {*************************************************************************}
	
	procedure free_colm; {(var t: colm_ptr)}  { July 1998 }
	
	   var s: colm_ptr;
		 
		begin
		   free_quoly(t^.val);
			s := t^.next;
			t^.next := colm_garb;
			colm_garb := t;
			t := s
		end;
	
 {****************************************************************************}

 function row_mass; {(t: colm_ptr): longint}
	 var sum: longint;
	 begin
		sum := 0;
		while t <> nil do
			begin
				sum := sum + quoly_mass(t^.val);
				if sum < 0
				   then begin
					        row_mass := mediummask;
							  exit(row_mass)
					     end;
				t := t^.next
			end;
		row_mass := sum
	end;
				
 {****************************************************************************}

 function quick_row_mass; {(t: colm_ptr): longint}
	 var sum: longint;
	 begin 
		sum := 0;
		while t <> nil do
			begin
				if Ord4(t^.val) > 0
					then sum := sum + 1;
				t := t^.next
			end;
		quick_row_mass := sum
	end;
				
 {****************************************************************************}

 procedure remove_col; {(spar: sparseptr; k, dim: longint; var w: imptr; var nu: numptr)}
	 { remove column k from spar^.  Attach the nodes to w. w nil or irrelevant 
		on input. dim is number of rows. Nov 1996.  Note that we can't stop in each row
		if column coord gets > k. k is an absolute coord.
		   mediummask is meant to be a number larger than the rank of any possible matrix,
	   yet small enough not to blow out the integer data type.  Adding it to
		sparse_number_col^[k] ensures that the kth column will never be considered in 
		find_best because the value is so large.  Delicate intertwining of this procedure
		and find_best! }
	
	 var i, j, col: longint;
		  t: colm_ptrptr;
		  ip: imptr;
		  u: colm_ptr;
		  np: numptr;
	 
	 begin
	 
		{ build up stack w with ip and stack nu with np. }
	   w := nil;
		nu := nil;
		for j := 0 to (dim - 1) div sparsesize do
			 begin
				 for i := 1 to sparsesize do
					 if i > dim
						 then leave
					 else begin
								t := @ spar^.indx[i]; 
								while t^ <> nil do
									begin
									   col := t^^.coord div bblock;  { absolute column coord }
								      if col < k
										   then t := @ t^^.next
											else if col > k
												then begin
														  u := t^;
														  newnode(np);
														  np^.next := nu;
														  nu := np;
														  nu^.value := Ord4(u);
														  while u <> nil do
														     begin { change the relative col coords }
															     u^.coord := u^.coord - 1;
															     u := u^.next
															  end;
														  leave
													  end
											else begin
													  newimag(ip);
													  ip^.imag := w;
													  w := ip;
													  w^.head := Pointer(Ord4(t));
													  w^.tail := Pointer(Ord4(t^));
													  w^.lint := i + j*sparsesize;  { row coord }
													  w^.size := t^^.coord mod bblock; { rel col coord }
													  t^ := t^^.next
												  end
									end
							end;
				 spar := spar^.next;
				 dim := dim - sparsesize
			 end;
		 
		 sparse_number_col^[k] := sparse_number_col^[k] + mediummask 
		 
	 end;
		
 {****************************************************************************}

 procedure ham_remove_col; {(spar: sparseptr; k, dim: longint; var w: imptr)}
	 
	 { remove column k from spar^.  Attach the nodes to w. w nil or irrelevant 
		on input. dim is number of rows. Nov 1996.  Note that we stop in each row
		if column coord gets > k. 
		   8192 is meant to be a number larger than the rank of any possible matrix,
	   yet small enough not to blow out the integer data type.  Adding it to
		number_col^[k] ensures that the kth column will never be considered in find_best
		because the value is so large. }
	
	 var i, j: longint;
		  t: colm_ptrptr;
		  ip: imptr;
	 
	 begin
	 
		{ build up stack w with ip. }
	   w := nil;
		for j := 0 to (dim - 1) div sparsesize do
			 begin
				 for i := 1 to sparsesize do
					 if i > dim
						 then leave
					 else begin
								t := @ spar^.indx[i];
								while t^ <> nil do
									if t^^.coord < k
										then t := @ t^^.next
									else if t^^.coord > k
										then leave
									else begin
											  newimag(ip);
											  ip^.imag := w;
											  w := ip;
											  w^.head := Pointer(Ord4(t));
											  w^.tail := Pointer(Ord4(t^));
											  w^.lint := i + j*sparsesize; { row coord }
											  t^ := t^^.next;
											  leave
										  end
							end;
				 spar := spar^.next;
				 dim := dim - sparsesize
			 end;
		 
		 number_col^[k] := number_col^[k] + 8192 
		 
	 end;
		
 {****************************************************************************}

 procedure update_col_list; {(md: imptr; index: integer; var spot: integer; var p: numptr)}
    { index is an absolute col coord.  Find it in the md list and set its spot to 0 with
      BCLR. Note that index of, say, 64 goes in spot 31, 33 goes in spot 1.
          changed Nov 2000. Next proc is more complex because this one uses ABSOLUTE 
      coords. }
    var i: integer;
    begin
       p := md^.head;
       spot := index mod 32;
       if spot = 0
          then for i := 2 to index div 32 do
				          p := p^.next
          else for i := 1 to index div 32 do
				          p := p^.next;
			 if spot = 0
			    then spot := 31
			    else spot := spot - 1;
			 BCLR(p^.value, spot)
    end;   
    
 {****************************************************************************}

 procedure update_row_list; {(md: imptr; index: integer; var spot: integer; var p: numptr)}
    { index is a relative row coord.  So it may well be less than the
      absolute coord of the row in question.  We have to find the absolute coord.
         Nov 2000:  changed the data structures to save space and (we hope) time too. 
      Certainly that's true of above proc.  This one is more messy.  Basic idea:
      every time we see a 0 in md^.tail^, we increment index. }
    var i: integer;
    begin
       p := md^.tail;
       i := 1;
       spot := 0;
       { spot points to the i^th entry; shadows i }
       while true do
          begin
             if BTST(p^.value, spot)
                then { nothing }
                else Inc(index);
             Inc(i);
             if i > index
                then leave;
             Inc(spot);
             if spot = 32
                then begin
                        spot := 0;
                        p := p^.next
                     end
          end;
			 BCLR(p^.value, spot)
    end;    
    
 {************************************************************************}
		 
 function minorsize; {(n: longint): longint}
    { used only to set minorprime.   changed primes Nov 2001 }
    begin
       if n < 31
          then minorsize := 641
       else if n < 45
          then minorsize := 1277
       else if n < 80
          then minorsize := 2473
       else if n < 110
          then minorsize := 4967
       else if n < 190
          then minorsize := 9901
       else if n < 300
          then minorsize := 20011
       else minorsize := 40087
    end;
		    
 {***********************************************************************}
		 
 function minorshash; {(md: imptr): longint}  { Feb 1997 }
    var i, val: longint;
        p, q: numptr;   { changed prime multipliers Nov 2001 }
    begin
       val := 0;
       p := md^.head;
       q := md^.tail;
       for i := 1 to md^.size do
          begin
             val := abs(40093 * p^.value + val) mod minorprime;  { Nov 2000 }
             val := abs(40099 * q^.value + val) mod minorprime;
             p := p^.next;
             q := q^.next
          end;
       minorshash := val + 1
    end;
		    
  {******************************************************************************}
 
  procedure try_purge_minors;  { Feb 1997 }
  
     var i, k, count, size: longint;
	      u: colm_ptrptr;
			t: colm_ptr;
			q: quoly;
			sp: sparseptr;
	  
     begin
     
       minor_memory := minor_memory div 5;  { Nov 2001 }
		  sp := minorstash;
		  size := minorprime;
		  if verbose
		     then begin
			          writeln;
						 writeln('Running low on memory; purging minor stash.'); 
						 plflush(output)
					 end;
		  for k := 0 to (size - 1) div sparsesize do
			  begin
				  for i := 1 to sparsesize do
					  if i > size 
						  then leave
					  else begin
								{ try to delete minor_count nodes from each bucket in sp. }
								u := @ sp^.indx[i];
								t := u^;
								count := 0;
								while u^ <> nil do
									begin
										Inc(count);
										purged_hits := purged_hits + u^^.coord;
										q := u^^.val;
										free_quoly(q^.next);
										free_minor_data(q^.ncoef);
										q^.next := quolygarb;
										quolygarb := q;
										u := @ u^^.next;
										if count = minor_count
										   then leave
									end;
								if t <> nil
									then begin
											  minor_total := minor_total - count;
											  sp^.indx[i] := u^;
											  u^ := colm_garb;
											  colm_garb := t
										  end
							 end;
				  sp := sp^.next;
				  size := size - sparsesize
			  end;
			  
			minor_count := 2*minor_count;
			Inc(min_stash_row);
			max_stash_row := max_stash_row div 2

      end;	  
	  
  {*****************************************************************************}
  
  function minor_is_there;{(md: imptr; addr: longint; var n: quoly): boolean}
     { If md is not there, n is unchanged, else n := the stored quoly.
       Jun 1999: changed the way n is passed back. 
       Jul 1999: changed it again, more like the original.  The June method had a bug
       when purges when done. }
     var j: longint;
         spar: sparseptr;
         cp: colm_ptr;
         im: imptr;
         h1, h2, t1, t2: numptr;
     
     begin
        
      spar := minorstash;
		  for j := 1 to (addr - 1) div sparsesize do
			  begin
				  spar := spar^.next;
				  addr := addr - sparsesize
			  end;
		  cp := spar^.indx[addr];
		  while cp <> nil do
		     begin
		        im := cp^.val^.ncoef;
		        if md^.size = im^.size
		           then begin
		                   h1 := im^.head;
		                   h2 := md^.head;
		                   t1 := im^.tail;
		                   t2 := md^.tail;
		                   while h1 <> nil do
		                      begin
		                         if h1^.value <> h2^.value
		                            then leave;
		                         if t1^.value <> t2^.value
		                            then leave;
		                         h1 := h1^.next;
		                         h2 := h2^.next;
		                         t1 := t1^.next;
		                         t2 := t2^.next
		                      end;
		                   if h1 = nil
		                      then begin
		                              minor_is_there := true;
		                              Inc(cp^.coord);
		                              quoly_assign(cp^.val^.next, n);
		                              { Assignment to n must be done before any purging below!
		                                Jul 1999 } 
																	if memavail < minor_memory div 5  { Nov 2001 }
																	   then try_purge_minors;
							                    exit(minor_is_there)
		                           end
		                end;
		        cp := cp^.next
		     end;
		  minor_is_there := false
     
     end;
     
  {*****************************************************************************}
  
  function int_minor_is_there;{(md: imptr; addr: longint; var n: longint): boolean}
     { If md is not there, n is unchanged, else n := the stored value.
       new Jul 1999  }
     var j: longint; 
         spar: sparseptr;
         nq: quoly;
         cp: colm_ptr;
         im: imptr;
         h1, h2, t1, t2: numptr; 
     
     begin
        
      spar := minorstash;
		  for j := 1 to (addr - 1) div sparsesize do
			   begin
				    spar := spar^.next;
				    addr := addr - sparsesize
			   end;
		  cp := spar^.indx[addr];
		  while cp <> nil do
		     begin
		        im := cp^.val^.ncoef;
		        if md^.size = im^.size
		           then begin
		                   h1 := im^.head;
		                   h2 := md^.head;
		                   t1 := im^.tail;
		                   t2 := md^.tail;
		                   while h1 <> nil do
		                      begin
		                         if h1^.value <> h2^.value
		                            then leave;
		                         if t1^.value <> t2^.value
		                            then leave;
		                         h1 := h1^.next;
		                         h2 := h2^.next;
		                         t1 := t1^.next;
		                         t2 := t2^.next
		                      end;
		                   if h1 = nil
			                      then begin
			                              int_minor_is_there := true;
			                              Inc(cp^.coord);
			                              nq := cp^.val^.next;
			                              n := nq^.ncoef^.lint; 
																		if memavail < minor_memory div 5 { Nov 2001 }
																		   then try_purge_minors;
								                    exit(int_minor_is_there)
			                           end
		                end;
		        cp := cp^.next
		     end;
		  int_minor_is_there := false
     
     end;
     
  {****************************************************************************}
  
  procedure free_minor_data; {(md: imptr) Feb 1997 }
  
     var i: longint;
	      p: numptr;
			
	  begin
	  
	     p := md^.head;
		  for i := 2 to md^.size do
		     p := p^.next;
		  p^.next := numhead;
		  numhead := md^.head;
		  
		  p := md^.tail;
		  for i := 2 to md^.size do
		     p := p^.next;
		  p^.next := numhead;
		  numhead := md^.tail;
		  
		  md^.imag := imhead;
		  imhead := md
	  
	  end;
  
  {****************************************************************************}
  
  procedure free_minor_stash; {(size: longint; var count, hits: longint)}
  
     { similar to free_sparse_data.  Feb 1997 }
  
     var i, k: longint;
	      u, t: colm_ptrptr;
			q: quoly;
			sp, tp: sparseptr;
	  
     begin
     
        count := 0;
		  hits := 0;
		  sp := minorstash;
		  for k := 0 to (size - 1) div sparsesize do
			  begin
				  for i := 1 to sparsesize do
					  if i > size 
						  then leave
					  else begin
								u := @ sp^.indx[i];
								t := u;
								while u^ <> nil do
									begin
										hits := hits + u^^.coord;
										Inc(count);
										q := u^^.val;
										free_quoly(q^.next);
										free_minor_data(q^.ncoef);
										q^.next := quolygarb;
										quolygarb := q;
										u := @ u^^.next
									end;
								if t^ <> nil
									then begin
											  u^ := colm_garb;
											  colm_garb := t^;
											  t^ := nil
										  end
							 end;
				  tp := sp;
				  sp := sp^.next;
				  size := size - sparsesize
			  end;
			  
		  tp^.next := spargarb;
		  spargarb := minorstash
     
     end;
     
  {****************************************************************************}
  
  procedure count_minor_stash; {(var count, hits: longint)}
  
     { new Nov 2001 }
  
     var i, k, size: longint;
	       u: colm_ptrptr;
			   sp: sparseptr;
	  
     begin
     
        count := 0;
			  hits := 0;
			  sp := minorstash;
			  size := minorprime;
			  for k := 0 to (minorprime - 1) div sparsesize do
				  begin
					  for i := 1 to sparsesize do
						  if i > size 
							   then leave
						  else begin
											u := @ sp^.indx[i];
											while u^ <> nil do
												 begin
														hits := hits + u^^.coord;
														Inc(count);
														u := @ u^^.next
												 end
								   end;
					  sp := sp^.next;
					  size := size - sparsesize
				  end
     
     end;
     
  {****************************************************************************}  
  
  procedure reconfigure_stash;
  
     var sp, sp2, newstash: sparseptr;
	      i, k, j, size, oldprime, addr: longint;
			t, u, v: colm_ptr;
     
     function nextminorprime: longint;  {  changed primes Nov 2001 }
	     begin
				  case oldprime of
					  641: nextminorprime := 1277;
					  1277: nextminorprime := 2473;
					  2473: nextminorprime := 4967;
					  4967: nextminorprime := 9901;
					  9901: nextminorprime := 20011;
					  20011: nextminorprime := 40087;
					  otherwise nextminorprime := 40087
				  end
       end;
		  			
	  begin
	  
	     if verbose
		     then begin
			          writeln;
						 writeln('Minor stash has grown large; will reconfigure.'); 
						 plflush(output)
					 end;
		  oldprime := minorprime;
		  minorprime := nextminorprime;
		  
		  { We know oldprime <> minorprime. }
		  
		  sparse_init(newstash, minorprime);
		  sp := minorstash;
		  size := oldprime;
	     for k := 0 to (size - 1) div sparsesize do
			  begin
				  for i := 1 to sparsesize do
					  if i > size 
						  then leave
					  else begin
								t := sp^.indx[i];
								while t <> nil do
									begin
										addr := minorshash(t^.val^.ncoef);
										sp2 := newstash;
									   for j := 1 to (addr - 1) div sparsesize do
										   begin
											   sp2 := sp2^.next;
											   addr := addr - sparsesize
										   end;
										v := t^.next;
										u := sp2^.indx[addr];
										sp2^.indx[addr] := t;
										t^.next := u;
										t := v
									end
							 end;
				  sp2 := sp;
				  sp := sp^.next;
				  size := size - sparsesize
			  end;
	  
	     sp2^.next := spargarb;
		  spargarb := minorstash;
		  minorstash := newstash
	  
	  end;	  
	  
  {*****************************************************************************}
  
  procedure stash_minor; {(md: imptr; addr: longint; var n: quoly)}
	
	   { Stash the value n with the minor that has it for a value. To store the minor,
       duplicate what md is pointing to.  The hash table itself is a sparse array.
       (comment added Nov 2000) }
     
     var cp: colm_ptr;
         q: quoly;
         r: numptrptr;
         p: numptr;
         j: longint;
         spar: sparseptr;

	  begin
        
        newcolm(cp);
        cp^.coord := 1;
        newquoly(cp^.val);
        q := cp^.val;
        q^.next := nil;
        quoly_assign(n, q^.next);
        newimag(q^.ncoef);
        q^.ncoef^.size := md^.size;
        r := @ q^.ncoef^.head;
        p := md^.head;
        for j := 1 to md^.size do
			  begin
				  newnode(r^);
				  r^^.value := p^.value;
				  r := @ r^^.next;
				  p := p^.next
			  end;
		  r^ := nil;
		  p := md^.tail;
		  r := @ q^.ncoef^.tail;
        for j := 1 to md^.size do
			  begin
				  newnode(r^);
				  r^^.value := p^.value;
				  r := @ r^^.next;
				  p := p^.next
			  end;
		  r^ := nil;
		  
		  spar := minorstash;
		  for j := 1 to (addr - 1) div sparsesize do
			  begin
				  spar := spar^.next;
				  addr := addr - sparsesize
			  end;
			
		  cp^.next := spar^.indx[addr];
		  spar^.indx[addr] := cp;
		  
		  Inc(minor_total);
		  if minorprime < 40087  { Nov 2001 }
			     then if minor_total > minorprime * 4
				          then reconfigure_stash
     
     end;
     
  {*****************************************************************************}
  
  procedure int_stash_minor; {(md: imptr; addr: longint;  n: longint) Jun 1999 }
     
     var cp: colm_ptr;
         q: quoly;
         r: numptrptr;
         p: numptr;
         j: longint;
         spar: sparseptr;

	  begin
        
        newcolm(cp);
        cp^.coord := 1;
        newquoly(cp^.val);
        q := cp^.val;
        q^.next := nil;
        quoly_set(n, q^.next);
        newimag(q^.ncoef);
        q^.ncoef^.size := md^.size;
        r := @ q^.ncoef^.head;
        p := md^.head;
        for j := 1 to md^.size do
			  begin
				  newnode(r^);
				  r^^.value := p^.value;
				  r := @ r^^.next;
				  p := p^.next
			  end;
		  r^ := nil;
		  p := md^.tail;
		  r := @ q^.ncoef^.tail;
        for j := 1 to md^.size do
			  begin
				  newnode(r^);
				  r^^.value := p^.value;
				  r := @ r^^.next;
				  p := p^.next
			  end;
		  r^ := nil;
		  
		  spar := minorstash;
		  for j := 1 to (addr - 1) div sparsesize do
			  begin
				  spar := spar^.next;
				  addr := addr - sparsesize
			  end;
			
		  cp^.next := spar^.indx[addr];
		  spar^.indx[addr] := cp;
		  
		  Inc(minor_total);
		  if minorprime < 40087  { Nov 2001 }
			     then if minor_total > minorprime * 4
				          then reconfigure_stash
     
     end;
     
  {*****************************************************************************}
  
  procedure restore_col; {(k: longint; w: imptr; nu: numptr)}
	 
	 { Restore column k using w and nu, created with remove_col. w and nu undefined
	   at end.  k is an absolute coord. Nov 1996. }
	 
	 var im: imptrptr;
	     t: colm_ptrptr;
		  u: colm_ptr;
		  np: numptrptr;
		
	 begin
	
		sparse_number_col^[k] := sparse_number_col^[k] - mediummask; 
		 
		im := @ w;
		while im^ <> nil do
			begin
				t := colm_ptrptr(im^^.head);
				u := colm_ptr(im^^.tail);
				t^ := u;
				im := @ im^^.imag
			end;
		im^ := imhead;
		imhead := w;
		
		np := @ nu;
		while np^ <> nil do
		   begin
			   u := Pointer(np^^.value);
			   while u <> nil do
				   begin
					   Inc(u^.coord);
					   u := u^.next
				   end;
			   np := @ np^^.next
			end;
		 np^ := numhead;
		 numhead := nu
			
    end;
				
 {****************************************************************************}

 procedure ham_restore_col; {(k: longint; w: imptr)}
	 
	 { Restore column k using w, created with ham_remove_col. w undefined
	   at end.  Nov 1996. }
	 
	 var im: imptrptr;
	     t: colm_ptrptr;
		  u: colm_ptr;
		
	 begin
	
		number_col^[k] := number_col^[k] - 8192;
		 
		im := @ w;
		while im^ <> nil do
			begin
				t := colm_ptrptr(im^^.head);
				u := colm_ptr(im^^.tail);
				t^ := u;
				im := @ im^^.imag
			end;
		im^ := imhead;
		imhead := w
			
    end;
				
 {****************************************************************************}

 procedure remove_row; {(spar: sparseptr; row, k: longint; var u: colm_ptr)}
	 { remove row k from spar^, which has 'row' rows.  Attach the nodes to u. 
	   u nil or irrelevant on input.  kth row is nonempty. Nov 1996. 
	   The matrix has been preconditioned by initialize in sparse_minors_det. }
		var i, j: longint;
		    t: colm_ptr;
		begin
			
			for j := 1 to (k - 1) div sparsesize do
			   begin
				   spar := spar^.next;
				   k := k - sparsesize;
					row := row - sparsesize
			   end;
			
			u := spar^.indx[k];
			t := u;
			while t <> nil do
			   begin
				   j := t^.coord div bblock;  { j is an absolute coord }
					sparse_number_col^[j] := sparse_number_col^[j] - 1;
					sparse_mass^[j] := sparse_mass^[j] - quoly_mass(t^.val); { overflow?? hope not }
				   t := t^.next
				end;
			
			for j := 0 to (row - 1) div sparsesize do
			   begin
				   for i := k to sparsesize do
					   if i > row
						   then exit(remove_row)
					   else if i = sparsesize
						   then spar^.indx[i] := spar^.next^.indx[1]
					   else spar^.indx[i] := spar^.indx[i+1];
				   spar := spar^.next;
				   k := 1;
				   row := row - sparsesize
			   end
				
		end;
				
 {****************************************************************************}

 procedure ham_remove_row; {(spar: sparseptr; row, k: longint; var u: colm_ptr)}
	 { remove row k from spar^, which has 'row' rows.  Attach the nodes to u. 
	   u nil or irrelevant on input.  kth row is nonempty. Nov 1996. }
		var i, j: longint;
		    t: colm_ptr;
		begin
			
			for j := 1 to (k - 1) div sparsesize do
			   begin
				   spar := spar^.next;
				   k := k - sparsesize;
					row := row - sparsesize
			   end;
			
			u := spar^.indx[k];
			t := u;
			while t <> nil do
			   begin
				   j := t^.coord;
					number_col^[j] := number_col^[j] - 1;
					if Ord4(t^.val) > 0
						then colm_mass^[j] := colm_mass^[j] - 1;
				   t := t^.next
				end;
			
			for j := 0 to (row - 1) div sparsesize do
			   begin
				   for i := k to sparsesize do
					   if i > row
						   then exit(ham_remove_row)
					   else if i = sparsesize
						   then spar^.indx[i] := spar^.next^.indx[1]
					   else spar^.indx[i] := spar^.indx[i+1];
				   spar := spar^.next;
				   k := 1;
				   row := row - sparsesize
			   end
				
		end;
				
 {****************************************************************************}

 procedure restore_row; {(spar: sparseptr; row, k: longint; u: colm_ptr)}
	 { restore column k to spar^.  Attach the nodes pointed to by u. u was formed
		by remove_row. u <> nil. At end, u is undefined or irrelevant.
		Nov 1996. }
		var i, j: longint;
		    t: colm_ptr;
		begin
		
			for j := 1 to (k - 1) div sparsesize do
			   begin
				   spar := spar^.next;
				   k := k - sparsesize;
					row := row - sparsesize
			   end;
			
			t := u;
			while t <> nil do
			   begin
				   j := t^.coord div bblock;  { j is an absolute coord }
					Inc(sparse_number_col^[j]);
					sparse_mass^[j] := sparse_mass^[j] + quoly_mass(t^.val); { overflow?? }
				   t := t^.next
				end;
		   
			for j := 0 to (row - 1) div sparsesize do
			   begin
				   for i := k to sparsesize do
					   if i > row
						   then exit(restore_row)
					   else begin
						        t := spar^.indx[i];
								  spar^.indx[i] := u;
								  u := t
							  end;
				   spar := spar^.next;
				   k := 1;
				   row := row - sparsesize
			   end
				
		end;
				
 {****************************************************************************}

 procedure ham_restore_row; {(spar: sparseptr; row, k: longint; u: colm_ptr)}
	 { restore column k to spar^.  Attach the nodes pointed to by u. u was formed
		by remove_row. u <> nil. At end, u is undefined or irrelevant.
		Nov 1996. }
		var i, j: longint;
		    t: colm_ptr;
		begin
		
			for j := 1 to (k - 1) div sparsesize do
			   begin
				   spar := spar^.next;
				   k := k - sparsesize;
					row := row - sparsesize
			   end;
			
			t := u;
			while t <> nil do
			   begin
				   j := t^.coord;
					Inc(number_col^[j]);
					if Ord4(t^.val) > 0
						then Inc(colm_mass^[j]);
				   t := t^.next
				end;
		   
			for j := 0 to (row - 1) div sparsesize do
			   begin
				   for i := k to sparsesize do
					   if i > row
						   then exit(ham_restore_row)
					   else begin
						        t := spar^.indx[i];
								  spar^.indx[i] := u;
								  u := t
							  end;
				   spar := spar^.next;
				   k := 1;
				   row := row - sparsesize
			   end
				
		end;
				
 {****************************************************************************}
	
 function permute; {(cp: colptr; i: longint): longint;   August 1996 }
    { cp is a list of transpositions.  Compute the image of i. }
	 
	 begin
	 
	    while cp <> nil do
		    begin
			    if cp^.i = i
			       then i := cp^.j
					 else if cp^.j = i
					         then i := cp^.i;
			    cp := cp^.next
			 end;
			 			    
	    permute := i
		 
	 end;
 
 {***************************************************************************}
 
 procedure initialize; 
 
    var i, j: integer;
	     k: longint;
		   r: numptr;
		   {  x: longreal;  @@@}
		   p: poly;
 
    begin
	
	   subinitialize;
	   
      gcdmass := 0;  {~~~~}
		mod_det_method_cut := 150;  {~~~~}
		rat_det_method_cut := 5000; {May 1996}
		gauss_cutoff := 0; { Gaussian elim. June 1996}

		total_cnt := 0;   { Nov 1996 }
		sp_total_cnt := 0;  { Nov 1996 }
		number_col := nil;  { Nov 1996 }
		colm_mass := nil;   { Nov 1996 }
		sparse_number_col := nil;  { Nov 1996 }
		sparse_mass := nil;   { Nov 1996 }
		minorstash := nil;  { Feb 1997 }
		init_max_stash := 2;  { Feb 1997. Doesn't seem to matter much.  }
		init_min_stash := 4;  { Feb 1997. Doesn't seem to matter much.  }
		purged_hits := 0;  { Nov 2001.  not needed I guess }
		
		poly_1 := nil;  { Jul 2003 }
		poly_set(1, poly_1);
		poly_1^.ncoef^.lint := 1;

	  new(syst);    { system's array }
		with syst^ do  
		   begin
			   start := 0;
				 stop := -1;
				 special_set(0, sizearr);  { Oct 2000 }
				 rows := 0;
				 linear := false;  {@@@}
				 next := nil; 
				 spar := nil;
				 name.name := chr(17)
		   end;
		syst_dump := false;  { syst array hasn't been changed so don't display it. }
		new(stash);
		for k := 0 to arr_limit - 1 do  { initialize space for syst }
		   stash^[k] := nil;
		   
		size_data_structs := size_data_structs + 4*arr_limit; {@@@}

		polygarb := nil;
	   quolygarb := nil; 
	   polynames := nil;  
		nilpol := nil;
		pseudo_polynames := nil; 		
	  number_polys := 0;
	  poly_cutoff := 8;  { much testing July 1993, August 1995, modular mode too 
	                       Oct 2003, cutoff for using the fastest method for one var polys, 
	                       rat or modmode, dividing. }
	  emgcd_basic_cut := 10;  { Oct 2003 }
	  hgcd_cut := 7000;  { Jan 2004. should probably be even larger than this! }  
		
		div_poly_cutoff := 6;  { Jan 2004, used by a Karatsuba div method, fast_mod_and_div, has value
		                         25 in mod mode.  }
		mod_method_diff := 6;  {~~~~}
	   quoly_set(0, prevnum); 
		for i := 1 to primesize do 
	      begin
				newimag(prime[i]);
			   prime[i]^.size := 0;
			   prime[i]^.imag := nil
		   end;
	   setvalue(3001, prime[1]^);   { changed from 181 ~~~ } { changed from 751, Feb 2003 }
	   setvalue(16087, prime[2]^);
	   setvalue(16273, prime[3]^);
	   setvalue(16339, prime[4]^);
	   setvalue(19997, prime[5]^);
	   
		new(invs_prod); 
		
		size_data_structs := size_data_structs + sizeof(inversearray) + primesize*numbersize;
		
	   for i := 6 to primesize do
		   begin 
			   read(primeprods, k);
{ write(pprods, k);}
				setvalue(k, prime[i]^)
		   end;
		   
		size_data_structs := size_data_structs + primesize*(numbersize+numnodesize);
		
		{ Create the two arrays (invs_prod and num_prod) needed for the Chinese Remainder 
		  Theorem method of determinant computation. See Knuth vol 2, p. 277, ex. 7. }
		for i := 1 to primesize do
		   prime[i]^.lint := prime[i]^.head^.value;
		   
		if prime[primesize]^.lint <> lastprime  { June 1998 }
		   then begin
			        write('*** Fermat error. ');
			        writeln('error in primeprods, last prime.');
			        plflush(output)
			     end;
		   
		for i := 7 to primesize do
		   begin
			   modulus := prime[i]^.lint;
				invs_prod^[i] := 1;
				for j := 6 to i-1 do
				   begin
					   k := prime[j]^.lint;
				      verse(k);
				      invs_prod^[i] := mod_mult(invs_prod^[i], k, modulus)
					end
		   end;

    	 for i := 7 to primesize+1 do    
			 begin
				 read(primeprods, k);
{write(pprods, k);}

				 num_prod^[i].size := k;
				 num_prod^[i].imag := nil;
				 for j := 1 to k do
					begin
						if j = 1
							then begin
									  newnode(num_prod^[i].head);
									  r := num_prod^[i].head;
								  end
		   				else begin
									  newnode(r^.next);
									  r := r^.next
								  end;
						read(primeprods, r^.value);
						
{ write(pprods, r^.value);  }
					end;
				 size_data_structs := size_data_structs + k * numnodesize; {@@@}
             num_prod^[i].tail := r;
				 r^.next := nil
			 end;
		if num_prod^[primesize+1].size <> last_num_prod_size
		   then begin
			        write('*** Fermat error. ');
			        writeln('error in primeprods, last num_prod.');
			        plflush(output)
			     end;
			     
{ write(pprods, r^.value);
write(pprods, r^.value);
close(pprods);  }
			     
	  new(polygarb);  {@@@}
		p := polygarb;
    for k := 1 to 5000 do
         { Do not call newpoly here!! Can't build polygarb list with newpoly! }
		   begin
				  new(p^.next);  { := poly(newptr(sizeof(polynode)));}
				  p := p^.next
		   end;
		p^.next := nil;
      
		for i := 1 to 80 do
			read(pow2028, binom^[i]^.lint);
				
    close(pow2028);

		close(primeprods);
		
		pol^[0,1] := nil;
		quoly_set(1, pol^[0,1]);
		for i := 1 to first_step do
		   for j := 1 to i + 1 do
			   begin
			      get_char_poly(i, j, pol^[i,j]);
			      size_data_structs := size_data_structs + sizequoly(pol^[i,j])  {@@@}
			   end;
				
	   mod_mode_matrix_in_use := false;   {~~~~}
	   
	   wanthalf_ := true;  { 30 July 1998 }
	   
		new(mod_mode_matrix); 
		mod_matrix_size := 399; 
		size_data_structs := size_data_structs + sizeof(workarray);  {@@@}
		for j := 0 to mod_matrix_size do
			begin
				newquoly(mod_mode_matrix^[j]);
				mod_mode_matrix^[j]^.numb := true;
				newimag(mod_mode_matrix^[j]^.ncoef)
			end;
	   size_data_structs := size_data_structs + mod_matrix_size*(numbersize+quolysize);
		 
		 for i := 0 to max_number_polys do  { Nov 2001 }
	      global_list[i] := small_prime^[i+8];
				
		 new(xx);  { Jan 2004 }
	   new(yy);
	   new(zz);  
	   size_data_structs := size_data_structs + 3*sizeof(gcd_array)
				 					 
	end;
	
  {**********************************************************************}
		 
	procedure free_stuff; { spar: sparseptr; row: longint }
	  { can't call the usual sparse-freeing routines because t^.val is weird. 
	    Used by hamiltonian stuff. }
		 var i, j: longint;
			   t: colm_ptrptr;
			   spar2: sparseptr;
		 begin
			 j := 0;
			 spar2 := spar;
			 for i := 1 to row do
				 begin
						Inc(j);
						if j > sparsesize
							then begin
										 j := 1;
										 spar2 := spar2^.next
								   end;
						t := @ spar2^.indx[j];
					  while t^ <> nil do
							 t := @ t^^.next;
						t^ := colm_garb;
						colm_garb := spar2^.indx[j]
				 end;
			 spar2^.next := spargarb;
		   spargarb := spar
		end;
		 
  {********************************************************************}

  procedure free_sparse; {(var spar: sparseptr; dim: longint; arr_free: boolean)}
    
		var i, k, n, startrow: longint;
		    s, t: colm_ptr;
			 sp: sparseptr;
		
		begin
		
			 if not arr_free
			    then begin
				         spar := nil;
							   exit(free_sparse)
					     end;
						
			 sp := spar;  {```}
			 n := (dim - 1) div sparsesize;
			 startrow := 0;
			 for k := 0 to n do
				 begin
					 for i := 1 + startrow to startrow + sparsesize do
						 if i > dim 
							 then leave
						 else begin
								   s := sp^.indx[i-startrow];
								   t := s;
								   while s <> nil do
									   begin
										   free_quoly(s^.val);
										   t := s;
										   s := s^.next
									   end;
								   if t <> nil
									   then begin
												  t^.next := colm_garb;
												  colm_garb := sp^.indx[i-startrow]
											  end
							   end;
				    startrow := startrow + sparsesize;
					 if k < n
					    then sp := sp^.next
				 end;
				 
			 sp^.next := spargarb;
			 spargarb:= spar;
			 spar := nil
			 
		end;
 
  {********************************************************************}

  procedure free_sparse_data(sp: sparseptr; dim: longint);  {```}
    
		var i, k: longint;
			 u, t: colm_ptrptr;
		
		begin
		
			 for k := 0 to (dim - 1) div sparsesize do
				 begin
					 for i := 1 + k*sparsesize to (k+1)*sparsesize do
						 if i > dim 
							 then leave
						 else begin
										 u := @ sp^.indx[i-k*sparsesize];
										 t := u;
										 while u^ <> nil do
											 begin
												 free_quoly(u^^.val);
												 u := @ u^^.next
											 end;
										 if t^ <> nil
											 then begin
															u^ := colm_garb;  { BUG, July 1998 }
															colm_garb := t^;
															t^ := nil
														end
							   end;
				    sp := sp^.next
				 end
			 
		end;
 
  {********************************************************************}

  procedure free_sparse_frame; {(var spar: sparseptr; dim: longint)}
    
		{ Leave the quolies untouched; somebody else owns them. Used only
		  for flipped sparses.
        also for sparse_mod_int_determ and some similar procs. Apr 2004 }
		  
		var i, k, n, startrow: longint; 
		    s, t: colm_ptr;
			  sp: sparseptr;
		
		begin
		
			 sp := spar;  {```}
			 n := (dim - 1) div sparsesize;
			 startrow := 0;
			 for k := 0 to n do
				 begin
					 for i := 1 + startrow to startrow + sparsesize do
						 if i > dim 
							 then leave
						 else begin
								   s := sp^.indx[i-startrow];
								   t := s;
								   while s <> nil do
									   begin
										   t := s;
										   s := s^.next
									   end;
								   if t <> nil
									   then begin
												    t^.next := colm_garb;
												    colm_garb := sp^.indx[i-startrow]
											    end
							   end;
				    startrow := startrow + sparsesize;
					  if k < n
					     then sp := sp^.next
				 end;
				 
			 sp^.next := spargarb;
			 spargarb:= spar;
			 spar := nil
			 
		end;
 
	{******************************************************************************}
	
	procedure get_sparse_colm;{(sp:sparseptr; r, c: longint; var t: colm_ptrptr;August 1996 }
	
	   { r and c are absolute coords based on (1,1) in block sp. revised Nov 2000 }
	   
	   begin
	      
	     t := @ sp^.indx[1 + (r-1) mod sparsesize];
		   while t^ <> nil do
		      if t^^.coord < c
				     then t := @ t^^.next
			       else leave
					         
		 end;
										        
	{******************************************************************************}
	
	function get_sparse;{(r, c: longint; var t: colm_ptrptr; var isp:
	                      sparseptr): quolyptr;   August 1996 }
	
	   { r and c are absolute coords based on (1,1). changed Nov 2000. t is both input and
	     output. t points to the first entry in row r. move up when necessary for
	     next call.  
	       Jan 2005: so evidently calling procedure calls this once per row r, then r increments
	     in a loop.  Seems to be true of all calls. 
	       Very rarely isp can be nil at end -- only if number of rows is a
	     multiple of sparsesize and this is the last invocation.  Then of course there
	     will be no "next time", yet we must be careful of nil pointers. }
	
	   var t2: colm_ptr;
	   
	   begin
	      
	      t2 := t^;
	      while t2 <> nil do
				   if t2^.coord >= c  
					    then leave
					    else t2 := t2^.next;
			  if t2 = nil
				   then get_sparse := nil
				   else if t2^.coord > c
					         then get_sparse := nil
					         else get_sparse := @ t2^.val;
					         				   
				{ set t and isp to point to first element in next row. }
				if r mod sparsesize = 0
				   then isp := isp^.next;
				if isp <> nil
				   then t := @ isp^.indx[1 + r mod sparsesize]
				   { else don't care (very rare).  t is not changed but it doesn't matter. }
					        
		 end;
										        
	{*************************************************************************}
	 
	procedure purge_sparse; {(t: colm_ptrptr; c: longint)}  { Nov 1997 }
	   { value in row t and col c might be 0.  if so, delete it. 
	     It's ok if t^ = nil or entry c is not there. 
	     Note that c has already been corrected with addresser; we don't do that here.}
	   var s: colm_ptr;
	   begin
	     while t^ <> nil do
		     if c > t^^.coord
				  then t := @ t^^.next
			     else leave;
		  if t^ = nil
		     then exit(purge_sparse);
		  if t^^.coord > c
		     then exit(purge_sparse);
		  if quoly_iszero(t^^.val)
		     then begin
		             s := t^^.next;
		             free_quoly(t^^.val);
		             t^^.next := colm_garb;
		             colm_garb := t^;
		             t^ := s
		          end
		end;
		  
  {**************************************************************************}

  procedure quick_sparse_create; {(sp: sparseptr; let: tokentipe; r, c: longint; 
                                  liner: boolean);    Nov 2000 }
     { already have sp, valid r and c }
     	
	   var p: arrptr;
			   i: integer;

     begin
		     
				newarray(p); 	
				with p^ do
				   begin
					    name := let;
							start := 0;
							stop := -1;
							special_set_2(r, c, p^.sizearr);   
							rows := r;
							spar := sp;
							linear := liner;   
							time := array_time
					 end;
				Inc(array_time);
				if let.address = -1
					 then i := hash(let.name, 151)
					 else i := let.address;
				p^.next := arr_store[i];
				arr_store[i] := p
		    
		 end;	
	
	{*************************************************************************}
	 
	procedure sparse_zero_set; {(t: colm_ptrptr; c: longint; var qp: quolyptr)} 
	  { Nov 1997. Note that caller has corrected c for addresser and colflag; we don't 
	    check it here. }
	   var s: colm_ptr;
	   begin
	     while t^ <> nil do
		     if c > t^^.coord
				  then t := @ t^^.next
			     else leave;
		  s := t^;
		  newcolm(t^);
		  t^^.next := s;
		  t^^.val := nil;
		  t^^.coord := c;
		  quoly_set(0, t^^.val);
		  qp := @ t^^.val
		end;
		  
   {*************************************************************************}
   
   procedure sparse_set; {(r, c: longint; q: arrptr; var qp: quolyptr; 
                           colflag: boolean)}
  
     { entry r,c is not in the sparse matrix, i.e. it was 0. We need to actually insert
	    it as 0, then change qp. 
	    
	    changed Nov 1997.  added colflag, Dec 1997.  }
		 
	  var t: colm_ptrptr;
	      sp: sparseptr;
			i: longint;
	  
	  begin
	  
	     r := r - addresser; 
		  c := c - addresser;
		  if colflag
		     then Inc(c)  
			  else begin { this all new! bug! April 1996}
				       c := 1 + r div q^.rows;
		             r := r mod q^.rows  
		          end;
		  sp := q^.spar;  {```}
		  for i := 1 to r div sparsesize do
			  sp := sp^.next;
		  t := @ sp^.indx[1 + r mod sparsesize];
		  sparse_zero_set(t, c, qp)
	  
	  end;
  
 {*************************************************************************}
  
  procedure sparse_set_scalar; {(q: arrptr; cols: longint; n: quoly)```}
  
     { New sparse loops, Sept 1996 }
  
     var sp: sparseptr;
			i, j, k, rows: longint;
			u: colm_ptrptr;
			
	  begin
	  
	     free_sparse_data(q^.spar, q^.rows);
		  if quoly_iszero(n)
		     then exit(sparse_set_scalar);
		  
		  sp := q^.spar;  
		  rows := q^.rows;
		  for k := 0 to (rows-1) div sparsesize do
			  begin
				  for i := 1 to sparsesize do
					  if i > rows 
						  then leave
					  else begin
					          u := @ sp^.indx[i];
								 for j := 1 to cols do
								    begin
									    newcolm(u^);
					                u^^.coord := j;
					                u^^.val := nil;
										 quoly_assign(n, u^^.val);
									    u := @ u^^.next
									 end;
					          u^ := nil
					       end;
				  sp := sp^.next;
				  rows := rows - sparsesize
			  end
	  	  
	  end;
  
  {*************************************************************************}
	 
  procedure standard_to_sparse; {(q: arrptr; var arr: workarray; cols: longint; 
                                  arr_free: boolean)}
  
     { sparse array q already exists and matches arr in dimensions. Sept 1996.
	    Note we can't use the new sparse loops. }
	  
	  var sp: sparseptr;
			i, j, k, n, startrow: longint;
			u: colm_ptrptr;
			
	  begin

	     free_sparse_data(q^.spar, q^.rows);	  
		  
		  sp := q^.spar;  
		  startrow := 0;
		  for k := 0 to (q^.rows-1) div sparsesize do
			  begin
				  for i := 1 + startrow to startrow + sparsesize do
					  if i > q^.rows 
						  then leave
					  else begin
					          u := @ sp^.indx[i-startrow];
								 n := i - 1;
								 for j := 1 to cols do
								    begin
									    if not quoly_iszero(arr[n])
										    then begin
											         newcolm(u^);
													   u^^.coord := j;
													   if arr_free
														   then u^^.val := arr[n]
														   else begin
																	  u^^.val := nil;
																	  quoly_assign(arr[n], u^^.val)
																  end;
														u := @ u^^.next
													end;
									    n := n + q^.rows
									 end;
					          u^ := nil
					       end;
				  sp := sp^.next;
				  startrow := startrow + sparsesize
			  end
	  	  
	  end;
	  
  {**********************************************************************}
  
  procedure sparse_init; {(var spar: sparseptr; r: longint) ```}
  
     { When adding new sparse routines, check all invocations of this and 
	    sparse_create }
	  
	  var sp: sparseptr;
	      j, k: longint;
	  
     begin
	  
	     newsparse(spar);   
		  sp := spar;  
		  for k := 1 to (r - 1) div sparsesize do
			  begin
				  for j := 1 to sparsesize do
					  sp^.indx[j] := nil;
				  newsparse(sp^.next);
				  sp := sp^.next
			  end;
		  for j := 1 to 1 + (r - 1) mod sparsesize do
			  sp^.indx[j] := nil;
		  sp^.next := nil  { July 1998, new convention!! }	
	  
	  end;  
  
  {*************************************************************************}
	
  procedure sparse_insert; {(r, c: longint; q: arrptr; colflag: boolean; var n: quoly)}
  
     { entry r,c is not in the sparse matrix, i.e. it was 0. We need to insert
	    it as n, unless n = 0. } 
		 
	  var t: colm_ptrptr; 
	      s: colm_ptr;
			sp: sparseptr;
			i: longint;
	  
	  begin
	  
	     if quoly_iszero(n)
		     then exit(sparse_insert);
			  
		  r := r - addresser;  
		  c := c - addresser;
		  if colflag
		     then Inc(c)  
			  else begin {@@@ this all new! bug! April 1996}
				       c := 1 + r div q^.rows;
		             r := r mod q^.rows  
		          end;
		  sp := q^.spar;  {```}
		  for i := 1 to r div sparsesize do
			  sp := sp^.next;
		  t := @ sp^.indx[1 + r mod sparsesize];
		  while t^ <> nil do
		     if t^^.coord < c
				  then t := @ t^^.next
			     else leave;
		  s := t^;
		  newcolm(t^);
		  t^^.next := s;
		  t^^.val := nil;
		  t^^.coord := c;
		  quoly_assign(n, t^^.val)

	  end;
  
  {*************************************************************************}
	
  procedure isparse_insert; {(r, c, n: longint; q: arrptr; colflag, assign: boolean)}
    
     { insert n into q at spot r,c. q is known sparse. assign means n is to be
       assigned, else it's to be incremented. Nov 1997 } 
		 
	  var t: colm_ptrptr; 
	      s: colm_ptr;
			sp: sparseptr;
			k: longint;
	  
	  procedure delete_it;
	     begin
	        s := t^;
		     t^ := s^.next;
		     free_quoly(s^.val);
		     s^.next := colm_garb;
		     colm_garb := s
	     end;
	     
	  procedure stash_it;
	     begin
		     s := t^;
		     newcolm(t^);
		     t^^.next := s;
		     t^^.val := nil;
		     quoly_set(n, t^^.val);
		     t^^.coord := c
	     end;
	     
	  procedure store_n;
	     begin
	        with t^^.val^.ncoef^ do
	           if lintmode
	              then lint := n
	              else head^.value := n
	     end;
	     
	  procedure retrieve_k;
	     begin
	        with t^^.val^.ncoef^ do
	           if lintmode
	              then k := lint
	              else k := head^.value
	     end;
	     
	  begin
	  
		  r := r - addresser;  {@@@ remove +1}
		  c := c - addresser;
		  if colflag
		     then Inc(c)  
			  else begin {@@@ this all new! bug! April 1996}
				       c := 1 + r div q^.rows;
		             r := r mod q^.rows  
		          end;
		  sp := q^.spar;  
		  for k := 1 to r div sparsesize do
			  sp := sp^.next;
		  t := @ sp^.indx[1 + r mod sparsesize];
		  while t^ <> nil do
		     if t^^.coord < c
				  then t := @ t^^.next
			     else leave;
		  if (t^ = nil) | (t^^.coord > c) { not there }
		     then if n = 0
		             then { nothing }
		             else stash_it
	     else if n = 0
	             then if assign
	                     then delete_it
	                     else { nothing }
	     else if assign
                then store_n
                else begin
                        retrieve_k;
                        n := k + n;
                        if n = 0
                           then delete_it
                           else store_n
                     end

	  end;
  
  {*************************************************************************}
  
  procedure sparse_delete; {(r, c: longint; q: arrptr; colflag: boolean;)}
  
     { entry r,c IS in the sparse matrix. We need to delete it. } 
		 
	  var t: colm_ptrptr; 
	      s: colm_ptr; 
			i: longint;
			sp: sparseptr;
	  
	  begin
	  
	     r := r - addresser;  
		  c := c - addresser;
		  if colflag
		     then Inc(c)  
			  else begin {@@@ this all new! bug! April 1996}
				       c := 1 + r div q^.rows;
		             r := r mod q^.rows  
		          end;
		  sp := q^.spar;
		  for i := 1 to r div sparsesize do
			  sp := sp^.next;
		  t := @ sp^.indx[1 + r mod sparsesize];
		  while true do
		     if t^^.coord < c
				  then t := @ t^^.next
			     else leave;
		  s := t^;
		  t^ := s^.next;
		  free_quoly(s^.val);
		  s^.next := colm_garb;
		  colm_garb := s
	  
	  end;
  
 {****************************************************************************}
	
 procedure sparse_iszero; {(spar: sparseptr; rows: longint; var ans: longint)}
 
	  { ans is 1 at start; i.e. all 0's is the default assumption.  We assume
	    that a zero sparse array must be entirely nil! 
		 
		 Sept 1996: Note new way of structuring a sparse loop.}
	  
	  var i, k: longint;
	  
     begin
	  
	     for k := 0 to (rows - 1) div sparsesize do
		     begin
				  for i := 1 to sparsesize do
					  if i > rows 
					     then exit(sparse_iszero)
					     else if spar^.indx[i] <> nil
								    then begin
									         ans := 0;
									         exit(sparse_iszero)
									      end;
		        spar := spar^.next;
		        rows := rows - sparsesize
			  end	
     end;
 
 {****************************************************************************}
 
 procedure copy_sparse; { var s, t: sparseptr; dim: longint; neg: boolean }
 
	 { t is assumed to be nil, or at least never assigned anything. }
	 
	 var i, k, n, startrow: longint;
		  u, v: colm_ptr;
		  sp, sp2: sparseptr;
	
	 begin
	
		 sp := s;  {```}
		 startrow := 0;
		 for k := 0 to (dim - 1) div sparsesize do
			 begin
				 if k = 0
					 then begin
								newsparse(t);
							   sp2 := t
							end
					 else begin
								newsparse(sp2^.next);
								sp2 := sp2^.next
							end;
				 sp2^.next := nil;  { July 1998, new convention!! }
				 for i := 1 + startrow to startrow + sparsesize do
					 if i > dim 
						 then leave
					 else begin
								 n := i - startrow;
								 u := sp^.indx[n];
								 if u = nil
									 then sp2^.indx[n] := nil
									 else begin
												newcolm(sp2^.indx[n]);
												v := sp2^.indx[n];
												v^.val := nil;
												if neg
													then quoly_makeneg(u^.val, v^.val)
													else quoly_assign(u^.val, v^.val);
												v^.coord := u^.coord;
												u := u^.next;
												while u <> nil do
													begin
														newcolm(v^.next);
														v := v^.next;
														v^.val := nil;
														if neg
															then quoly_makeneg(u^.val, v^.val)
															else quoly_assign(u^.val, v^.val);
														v^.coord := u^.coord;
														u := u^.next
													end;
												v^.next := nil
											end
							end;
			    startrow := startrow + sparsesize;
			    sp := sp^.next
		    end
		 
	end;
 
 {****************************************************************************}
 
 procedure one_var_copy_sparse; { var s, t: sparseptr; dim: longint }
 
	 {  t is assumed to be nil, or at least never assigned anything.
  
     Don't bother with dummy zero nodes!  Aug 2004 }
	 
	 var i, k: longint;
		   u, v: colm_ptr;
		   sp, sp2: sparseptr;
	
	 begin
	
		 sp := s;  
		 for k := 0 to (dim - 1) div sparsesize do
			 begin
				 if k = 0
					 then begin
								   newsparse(t);
							     sp2 := t
							  end
					 else begin
								   newsparse(sp2^.next);
								   sp2 := sp2^.next
							  end;
				 sp2^.next := nil;  
				 for i := 1 to sparsesize do
					  if i > dim 
						   then leave
					  else begin
									 u := sp^.indx[i];
									 if u = nil
										 then sp2^.indx[i] := nil
										 else begin
														newcolm(sp2^.indx[i]);
														v := sp2^.indx[i];
														v^.val := nil;
														one_var_quoly_assign(u^.val, v^.val);
														v^.coord := u^.coord;
														u := u^.next;
														while u <> nil do
														 	 begin
																  newcolm(v^.next);
																  v := v^.next;
																  v^.val := nil;
																  one_var_quoly_assign(u^.val, v^.val);
																  v^.coord := u^.coord;
																  u := u^.next
															end;
														v^.next := nil
												 end
							   end;
			    dim := dim - sparsesize;
			    sp := sp^.next
		    end
		 
	end;
 
 {****************************************************************************}
 
 procedure special_copy_sparse; {(var s, t: sparseptr; dim: longint);   Aug 2004 }
   
    {  Sep 2004.  shortcut of move_data_into_quoly  }

    var i, k: longint;
        u, v: colm_ptr;
        sp, sp2: sparseptr;

		begin
		
		  sp := s;
		  for k := 0 to (dim - 1) div sparsesize do
		    begin
			    if k = 0 
			      then begin
			              newsparse(t);
			              sp2 := t
			           end
			      else begin
			              newsparse(sp2^.next);
			              sp2 := sp2^.next
			           end;
			    sp2^.next := nil;           { July 1998, new convention!! }
			    for i := 1 to sparsesize do
			      if i > dim 
			        then leave
			      else begin
						        u := sp^.indx[i];
						        if u = nil
						          then sp2^.indx[i] := nil
						        else begin
									          newcolm(sp2^.indx[i]);
									          v := sp2^.indx[i];
									          v^.val := quoly(u^.val^.ncoef^.lint);
									          v^.coord := u^.coord;
									          u := u^.next;
									          while u <> nil do
									            begin
									              newcolm(v^.next);
										            v := v^.next;
										            v^.val := quoly(u^.val^.ncoef^.lint);
										            v^.coord := u^.coord;
										            u := u^.next;
										          end;
									          v^.next := nil
									       end
			           end;
			    dim := dim - sparsesize;
			    sp := sp^.next
			 end
			 
   end;
 
 {****************************************************************************}
 
 procedure sparse_makeneg; {(var spar: sparseptr; rows: longint; var arr_free: boolean)}
 
    var sp: sparseptr;
	     u: colm_ptr;
	     i, k: longint;
	 
	 begin
	 
	    sp := spar;  {```}
		 if arr_free
		    then for k := 0 to (rows - 1) div sparsesize do
						 begin
							 for i := 1 + k*sparsesize to (k+1)*sparsesize do
								 if i > rows 
									 then leave
								 else begin
											u := sp^.indx[i-k*sparsesize];
											while u <> nil do
												begin
													quoly_inplace(u^.val);
													u := u^.next;
												end
										end;
							 sp := sp^.next
						 end
			 else begin
			         copy_sparse(spar, sp, rows, true);
						spar := sp
				   end;
			 
		arr_free := true
		
	 end;
 
 {****************************************************************************}
 
 procedure spar_identi; {(var spar: sparseptr; rows: longint; arr_free: boolean)}
 
    var u: colm_ptr;
	     i, k: longint;
		  sp: sparseptr;
	 
	 begin
	 
	    free_sparse(spar, rows, arr_free); 
	    { spar is now nil in any event. }     
		 
		 for k := 0 to (rows - 1) div sparsesize do
			  begin
				  if k = 0
					  then begin
								 newsparse(spar);
								 sp := spar
							 end
					  else begin
								 newsparse(sp^.next);
								 sp := sp^.next
							 end;
				  sp^.next := nil;  { July 1998, new convention!! }
				  for i := 1 + k*sparsesize to (k+1)*sparsesize do
					  if i > rows 
						  then leave
					  else begin
								 newcolm(sp^.indx[i-k*sparsesize]);
								 u := sp^.indx[i-k*sparsesize];
								 u^.coord := i;
								 u^.next := nil;
								 u^.val := nil;
								 quoly_set(1, u^.val)
							 end
				{ BUG of June 1998; removed this ridiculous statement: sp := sp^.next}
			  end
		
	 end;
  
	{***************************************************************************}
		
	procedure flip_sparse; {(var spar, spar2: sparseptr; row, col: longint)}
	
	   { spar2 is nil or irrelevant. The quolies of spar will be pointed to by spar2, so
		  don't free them later! }
			 
		 var i, k: longint;
			  sp: sparseptr;
		 
		 procedure transfer(i, k: longint);  
		    var s, t: colm_ptr;
				  u: colm_ptrptr;
				  j: longint;
				  sp2: sparseptr;
			 begin
				 t := sp^.indx[i];
				 while t <> nil do
					 begin
						 sp2 := spar2;
						 for j := 1 to (t^.coord - 1) div sparsesize do
							 sp2 := sp2^.next;
						 u := @ sp2^.indx[1 + (t^.coord - 1) mod sparsesize];
						 s := u^;
						 newcolm(u^);
						 u^^.next := s;
						 u^^.coord := i + k*sparsesize;
						 u^^.val := t^.val;
						 t := t^.next
					 end				
			 end;		 
		 
		begin
		 
		   sparse_init(spar2, col);
					 
			{ Take the data from spar, from the last row toward the first. }  
			sp := spar;
			k := (row - 1) div sparsesize;
			for i := 1 to k do
			  sp := sp^.next;
			{ Take data from last block }
			for i := 1 + (row - 1) mod sparsesize downto 1 do
			  transfer(i, k);
			
			{ Now take it from each block in order. }
			for k := (row - 1) div sparsesize - 1 downto 0 do
			   begin
				   sp := spar;
				   for i := 1 to k do
			         sp := sp^.next;
				   for i := sparsesize downto 1 do
			         transfer(i, k)
				end
		 
		end;	
	
  {***************************************************************************}
	
	procedure trans_sparse; {(var spar: sparseptr; row, col: longint)}
	
	   { transpose spar in place. }
			 
		 var i, k: longint;
			  spar2, sp: sparseptr;
		 
		 procedure transfer(i, k: longint);  
		    var s, t: colm_ptr;
				  u: colm_ptrptr;
				  j: longint;
				  sp2: sparseptr;
			 begin
				   t := sp^.indx[i];
					while t <> nil do
						begin
							sp2 := spar2;
						   for j := 1 to (t^.coord - 1) div sparsesize do
							  sp2 := sp2^.next;
						   u := @ sp2^.indx[1 + (t^.coord - 1) mod sparsesize];
							s := u^;
							u^ := t;
							t^.coord := i + k*sparsesize;
							t := t^.next;
							u^^.next := s
						end				
			end;		 
		 
		begin
		 
		   sparse_init(spar2, col);
					 
			{ Take the data from spar, from the last row toward the first. }  
			sp := spar;
			k := (row - 1) div sparsesize;
			for i := 1 to k do
			   sp := sp^.next;
			{ Take data from last block }
			for i := 1 + (row - 1) mod sparsesize downto 1 do
			   transfer(i, k);
			
			sp^.next := spargarb;
			
			{ Now take it from each block in order. }
			for k := (row - 1) div sparsesize - 1 downto 0 do
			   begin
				    sp := spar;
				    for i := 1 to k do
			         sp := sp^.next;
				    for i := sparsesize downto 1 do
			         transfer(i, k)
				end;
				 				
			spargarb := spar;
			spar := spar2
		 
		 end;	
	
 {***************************************************************************}
 
 procedure switchrow_col; { (index, j, k, start, total_rows, target_rows, cols
                             : longint); }
							 
	{ k and j are normalized }
 
   var increm, i: longint;
	    temp: quoly;
	
	begin
	
	  if index = Switchrow_ 
	     then begin
	             j := j + start;
                k := k + start;
				    increm := total_rows;
				    start := cols
			    end
		  else begin { Switchcol }
			       j := j*total_rows + start;
				    k := k*total_rows + start;
				    increm := 1;
				    start := target_rows
			    end;
	  for i := 0 to start - 1 do
        begin
			  temp := arp[BSR(j,10)]^[BAND(j, tenmask)];
			  arp[BSR(j,10)]^[BAND(j, tenmask)] := arp[BSR(k,10)]^[BAND(k, tenmask)];
			  arp[BSR(k,10)]^[BAND(k, tenmask)] := temp;
			  j := j + increm;
			  k := k + increm
        end
		 
   end;

 {*****************************************************************************}
 
 procedure int_col_manip; {(j, k, start, rows: longint; var factor: number) July 1998 }
 
    { column j <- column j - factor * column k, from row k down to rows. 
      j and k are 0-based.  rows is a number, not an index. }
    
    var i: longint;
        n2: number;
    
    begin
    
       n2.size := 0;
       i := k;
       j := j*rows + k + start;
		 k := k*rows + k + start;
		 while i < rows do
          begin
			    fast_mult(factor, arp[BSR(k,10)]^[BAND(k, tenmask)]^.ncoef^, n2);
			    fastdiff(arp[BSR(j,10)]^[BAND(j, tenmask)]^.ncoef^, n2);
			    j := j + 1;
			    k := k + 1;
			    i := i + 1
          end;
       free_num(n2)
    
    end;
 
 {*****************************************************************************}
 
 procedure int_col_neg; {(j, k, start, rows: longint) 30 July 1998 }
 
    { column j <- -column j, from row k down to rows. 
      j and k are 0-based.  rows is a number, not an index. }
    
    var i: longint;
    
    begin
    
       j := j*rows + k + start;
		 for i := k to rows-1 do
          begin
			    in_place_neg(arp[BSR(j,10)]^[BAND(j, tenmask)]^.ncoef^);
			    j := j + 1
          end
    
    end;
 
 {*****************************************************************************}
 
 procedure int_row_neg; {(j, k, start, rows, cols: longint) 30 July 1998 }
 
    { row j <- -row j, from col k up to cols. 
      j and k are 0-based.  cols is a number, not an index. }
    
    var i: longint;
    
    begin
    
       j := k*rows + j + start;
		 for i := k to cols-1 do
          begin
			    in_place_neg(arp[BSR(j,10)]^[BAND(j, tenmask)]^.ncoef^);
			    j := j + rows
          end
    
    end;
 
 {*****************************************************************************}
 
 procedure sp_row_neg; {(j: longint; sp: sparseptr) Aug 1998 }
    { negate row j.  sp is authenic. }
    
    var i: longint;
        t: colm_ptr;
    
    begin
    
        for i := 1 to (j-1) div sparsesize do
			  sp := sp^.next;
		  t := sp^.indx[1 + (j-1) mod sparsesize];
		  while t <> nil do
		     begin
		        quoly_inplace(t^.val);
		        t := t^.next
		     end
		     
    end;
 
 {*****************************************************************************}
 
 procedure sp_col_neg; {(j, start, rows: longint; sp: sparseptr) Aug 1998 }
    { negate col j, from row 'start' on down. sp points to the block with row 'start'. }
    
    var i: longint;
        t: colm_ptr;
    
    begin
    
        t := sp^.indx[1 + (start-1) mod sparsesize];
		  for i := start to rows do
		     begin
		        { at start of each pass, t points to row i, first spot }
		        while t <> nil do
		           if t^.coord < j
		              then t := t^.next
		              else leave;
		        if t <> nil
		           then if t^.coord = j
		                   then quoly_inplace(t^.val);
		        if i mod sparsesize = 0
			        then begin
			                sp := sp^.next;
			                if sp <> nil
			                   then t := sp^.indx[1]
			             end
			        else t := sp^.indx[1 + i mod sparsesize] 
		     end
		     
    end;
 
 {*****************************************************************************}
 
 procedure int_arr_col_neg; {(var arr: workarray; j, rows: longint) 30 July 1998}
 
    { col j <- -col j, j is 0-based.  rows is a number, not an index. }
    
     var i: longint;
	 
	  begin
	 
	     j := j*rows;
		  for i := j to j + rows - 1 do
		     in_place_neg(arr[i]^.ncoef^)
	 
	  end;
 
 {*****************************************************************************}
 
 procedure int_arr_row_neg; {(var arr: workarray; j, rows, cols: longint) 30 July 1998}
 
    { row j <- -row j, j is 0-based.  rows and cols are numbers. }
    
     var i: longint;
	 
	  begin
	 
	     for i := 1 to cols do
	        begin
	           in_place_neg(arr[j]^.ncoef^);
		        j := j + rows
	        end
		   
     end;
 
 {*****************************************************************************}
 
 procedure poly_to_array; {(rows, start: longint; var p: poly)~~~~~}
 
    { Fill in rows X 2 array using the data in the poly p, which is not a genuine
	   poly but has been created by a factoring routine.  special case of rows = 0
		is handled separately.  At end, set p = nil (unless rows = 0).  }
 
	 var i: longint; 
	     q: quoly;
		  tp: polyptrr;
	
	 begin
	
	   if rows = 0
		   then begin
			        q := nil;
				     quoly_set(1, q);
				     arp[BSR(start, 10)]^[BAND(start, tenmask)] := q;
					  q := nil;
					  quoly_set(0, q);
				     arp[BSR(start+1, 10)]^[BAND(start+1, tenmask)] := q;
			        exit(poly_to_array)
			     end;
				  
	   tp := @ p;
		for i := 1 to rows do
	      begin
			   newquoly(q);
				q^.numb := false;
				q^.denom := nil;
				q^.rat := false;
				q^.numer := tp^^.pcoef;
				arp[BSR(start, 10)]^[BAND(start, tenmask)] := q;
				start := start + rows;
				q := nil;
				quoly_set(tp^^.exp, q);
				arp[BSR(start, 10)]^[BAND(start, tenmask)] := q;
			   start := start - rows + 1;
				tp := @ tp^^.next
		   end;
		 tp^ := polygarb;
		 polygarb := p;
		 p := nil
			 
    end;
 
 {*****************************************************************************}

 procedure fillup; { (rows, cols, start: longint; var arr: workarray); }
 
    { Fills up newly created array with stuff from arr, which is newly created. }
 
    var i, j: longint;  {~~~~~ optimized loop vars }
	
	begin
	
	   j := 0;
	   for i := 1 to rows*cols do
	      begin
			   arp[BSR(start, 10)]^[BAND(start, tenmask)] := arr[j];
			   Inc(j);
			   Inc(start)
		   end
			 
    end;
	
 {************************************************************************}
 
 procedure intfindbest; {(start, stop, rows, i: longint; var j, k, val: longint)} 
 
      { i, j and k are relative coordinates with (0,0) base, rows = total number
	     of rows in matrix.  start and stop are absolute coords in arp. 
		  all entries integers. val = flag to indicate array[j,k]. val = 0 means
		  all entries 0.  val = -1 means 1 found. else val = 1. }
 
     label 876;
	  
	  var spot, maybe_num, best, t: longint; 
	      p, q: quoly;
		   either: boolean; 
							    
      begin
	  
		spot := start + i + i*rows;  { an absolute address within the store }
		maybe_num := -1;
		best := -1;
      while spot <= stop do
		   begin
		      for t := spot to spot + rows - i - 1 do
			     begin
				    p := arp[BSR(t, 10)]^[BAND(t, tenmask)];
                if p^.ncoef^.head^.value = 0    
			           then { nothing }
                    else if equal_to_pm1(p^.ncoef^, either)
				            then begin
										  best := t;
										  val := -1;
										  goto 876
									  end
							else if maybe_num = -1
							        then maybe_num := t
									  else begin
									         q := arp[BSR(maybe_num, 10)]^[BAND(maybe_num, tenmask)];
											   if int_abs_bigger(q^.ncoef^, p^.ncoef^, false)
											      then maybe_num := t										
										    end
				 end;
			  spot := spot + rows
		   end;
		   
		876:;
		
		if best = -1 { never found 1 }
		   then if maybe_num > -1 { found something <> 0 }
		           then begin
				             best := maybe_num;
						       val := 1
						    end;
				   
	   if best = -1
		   then val := 0
		   else begin
		           best := best - start;
		           j := best mod rows;
				     k := best div rows
				  end
		   
      end;
			
 {************************************************************************}
 
 procedure sp_switchcol; {(sp: sparseptr; i, k, rows, start: longint)}
 
   { k > i.  August 1996 }
   
   { Massively buggy procedure.  May 1998 }
 
	var j: longint;
	    p: quoly;
		 t, u: colm_ptrptr; 
		 s: colm_ptr;
							    
   begin
	  		
		for j := 1 to (start-1) div sparsesize do
			sp := sp^.next;
		t := @ sp^.indx[1 + (start-1) mod sparsesize];
			   
      for j := start to rows do
		   begin
		      { at start of each pass, t points to row j, first spot }
		      while t^ <> nil do
		         if t^^.coord < i
		            then t := @ t^^.next
		            else leave;
		      
		      if t^ <> nil  { t^ = nil means neither i nor k is present }
		         then begin
		                 u := t;
                       while u^ <> nil do
					           if u^^.coord < k
					              then u := @ u^^.next
					              else leave;
							  if t^^.coord = i      { i is there }
			                 then if (u^ = nil) | (u^^.coord > k)
			                         then begin  { k not there }    
			                                 { BUG of May 1998. tricky! Assign t^.coord first }
			                                 t^^.coord := k;
			                                 s := u^;
			         					         u^ := t^;
			         					         { u^^.next might be u^!  This code is ok }
					                           t^ := u^^.next;
					                           u^^.next := s
			                              end
			                         else begin  { both are there }
			                                 p := t^^.val;
			                                 t^^.val := u^^.val;
			                                 u^^.val := p
			                              end
			                 else { i not there }
			                      if u^ <> nil  
								          then if u^^.coord = k
								                  then begin  { k is there }
								                          { BUG if t^ = u^. Fixed May 1998 }
								                          u^^.coord := i;
								                          if t <> u
								                             then begin
								                                     s := t^;
								                                     t^ := u^;
								                                     u^ := t^^.next;
								                                     t^^.next := s
								                                  end
								                       end
								                  { else k not there }
								         { else k not there }
		              end;

			   if j mod sparsesize = 0
			      then begin
			             sp := sp^.next;
			             if sp <> nil
			                then t := @ sp^.indx[1]
			           end
			      else t := @ sp^.indx[1 + j mod sparsesize]  { BUG of May 1998 }
		   end
		   		   
   end;

 {************************************************************************}
 
 procedure sp_switchrow; {(sp: sparseptr; i, j: longint);}
 
    var t, u: colm_ptrptr;
        s: colm_ptr;
        sp2: sparseptr;
        k: longint; 
    
    begin
    
       sp2 := sp;
       for k := 1 to (i-1) div sparsesize do
			 sp := sp^.next;
		 t := @ sp^.indx[1 + (i-1) mod sparsesize];
		 
		 for k := 1 to (j-1) div sparsesize do
			sp2 := sp2^.next;
		 u := @ sp2^.indx[1 + (j-1) mod sparsesize];
		 
		 s := t^;
		 t^ := u^;
		 u^ := s
		 
    end;
 
 {************************************************************************}
 
 procedure sparse_findbest; { (leave_early: boolean; sp: sparseptr; rows, i: longint; 
                               var j, k: longint);}
 
   { i, j and k are relative coordinates with (1,1) base, rows = total number
	  of rows in matrix. August 1996 
	     added leave_early Nov 2000 to fix a misunderstanding.  sparse_gauss-bareiss 
	  needs to quit and set j = -1 if there is a row of all 0.  }
 
   label 877;
	  
	 var r, numj, polj: longint;  { added numj, polj; BUG of July 1998 }
	     p: quoly;
		   either, all_zero_row: boolean;  { Nov 2000 }
		   t, best, maybe_pol, maybe_num: colm_ptr; 
							    
   begin
	  
		  maybe_pol := nil;
		  maybe_num := nil;
		  best := nil;
		
		  for r := 1 to (i-1) div sparsesize do
			   sp := sp^.next;
		  t := sp^.indx[1 + (i-1) mod sparsesize];
			   
      j := -1;  { default, failure }
      
      for r := i to rows do
		   begin
		      { at start of each pass, t points to row r, first spot }
		      while t <> nil do
		         if t^.coord < i
		            then t := t^.next
		            else leave;
		      all_zero_row := true;   { Nov 2000 }
		      while t <> nil do
			       begin
				        p := t^.val;
				        all_zero_row := false;
                if quoly_iszero(p)   { should be impossible }
			             then fermat_error('p = 0 in sparse_findbest') { Nov 2000 }
                else if p^.numb
				           then if equal_to_pm1(p^.ncoef^, either)
				                   then begin
							                     best := t;
							                     j := r;
									                 goto 877 
									              end
												   else if maybe_num = nil
																  then begin
																          maybe_num := t;
																          numj := r
																       end
													 else if abs_larger(maybe_num^.val^.ncoef^, p^.ncoef^)
																  then begin
																          maybe_num := t;
																          numj := r
																       end
											     else { nothing }
				        else if maybe_pol = nil  
					              then begin
						                    maybe_pol := t;
						                    polj := r
						                 end
							  else if quoly_mass(p) < quoly_mass(maybe_pol^.val)
								        then begin
										            maybe_pol := t;
										            polj := r
										        end;
				        t := t^.next
				     end;
				     
				  if all_zero_row and leave_early  { Nov 2000 }
				     then begin
				             j := -1;  { BUG Jun 2004, must reset it! }
				             exit(sparse_findbest)
				          end;
				     
			    if r mod sparsesize = 0
			       then begin
			               sp := sp^.next;
			               if sp <> nil
			                  then t := sp^.indx[1]
			            end
			       else t := sp^.indx[1 + r mod sparsesize]  { BUG of May 1998 }
		   end;
		          
		877:;
		
		if best = nil  { BUG of July 1998 }
		   then if maybe_num <> nil
		           then begin
		                   best := maybe_num;
		                   j := numj
		                end
		           else if maybe_pol <> nil
								 then begin
								         best := maybe_pol;
								         j := polj
								      end;
				   
	   if best <> nil
		    then k := best^.coord
		   
   end;
			
 {************************************************************************}
 
 procedure sparse_intfindbest; {(sp: sparseptr; rows, i: longint; var j, k, 
                                val: longint);   June 1998 }
 
      { i, j and k are coordinates with (1,1) base, rows = total number
	     of rows in matrix.  sp^ is the block containing i. all array entries 
		  are integers. 
		    Examine the part of the matrix down and to the right from (i,i). 
		  Pass back j, k, and val. val is a flag to indicate array[j,k]: 
		  val = 0 means all entries 0, val = -1 means 1 found, else val = 1. }
 
    label 877;
	  
	 var r: longint;
	     p: quoly;
		  either: boolean;
		  t, best, maybe_num: colm_ptr; 
							    
    begin
	  
		maybe_num := nil;
		best := nil;
		
		t := sp^.indx[1 + (i-1) mod sparsesize];
			   
      j := -1;  { default, failure }
      val := 0;
      
      for r := i to rows do
		   begin
		      { at start of each pass, t points to row r, first spot }
		      while t <> nil do
		         if t^.coord < i
		            then t := t^.next
		            else leave;
		      while t <> nil do
			      begin
			         p := t^.val;
                  if quoly_iszero(p)   { should be impossible }
			            then fermat_error('p = 0 in sparse_intfindbest')
                  else if equal_to_pm1(p^.ncoef^, either)
			                 then begin
						                best := t;
						                j := r;
						                val := -1;
								          goto 877 
								       end
							  else if maybe_num = nil
										 then begin
										         maybe_num := t;
										         j := r
										      end
							  else if int_abs_bigger(maybe_num^.val^.ncoef^, p^.ncoef^, false)
										 then begin
										         maybe_num := t;
										         j := r
										      end;
				      t := t^.next
				   end;
			   if r mod sparsesize = 0
			      then begin
			              sp := sp^.next;   { July 1998: Note, needs to know that tail sp's
			                                  have been nilled!!  }
			              if sp <> nil
			                 then t := sp^.indx[1]
			           end
			      else t := sp^.indx[1 + r mod sparsesize]  { BUG of May 1998 }
		   end;
		   
		877:;
		
		if best = nil
		   then if maybe_num <> nil
		           then begin
		                   val := 1;
		                   best := maybe_num
		                end;
				   
	   if best <> nil
		   then k := best^.coord
		   
    end;
			
 {************************************************************************}
 
 procedure sparse_best_diag; {(sp: sparseptr; rows, i: longint; var j,
                                val: longint);   July 1998 }
 
      { i, and j are coordinates with (1,1) base in a diagonal matrix. All 
        zeros are at the end. rows = number of nonzero rows in matrix.  sp^ is 
        the block containing i. all array entries are integers. 
		    Examine the part of the matrix down and to the right from (i,i). 
		  Pass back j and val. val is a flag to indicate array[j,j]: 
		  val = -1 means 1 found, else val = 1. }
 
	 var r: longint;
	     p: quoly;
	     either: boolean;
		  best, t: colm_ptr; 
							    
    begin
	  
		 val := 1;
		 best := sp^.indx[1 + (i-1) mod sparsesize];
		 j := i;
       for r := i to rows do
		    begin
		       t := sp^.indx[1 + (r-1) mod sparsesize];
		       p := t^.val;
             if equal_to_pm1(p^.ncoef^, either)
                then begin
		                  j := r;
		                  val := -1;
				            leave 
				         end
				    else if int_abs_bigger(best^.val^.ncoef^, p^.ncoef^, false)
							   then begin
							           best := t;
							           j := r
							        end;
			    if r mod sparsesize = 0
			       then sp := sp^.next
		    end
		   
    end;
			
 {************************************************************************}
 
 procedure mod_sparse_findbest; { (leave_early: boolean; sp: sparseptr; rows, i: longint; 
                                   var j, k: longint);}
 
   { i, j and k are relative coordinates with (1,1) base, rows = total number
	  of rows in matrix. modularmode with prime modulus. June 1998.  }
 
   label 877;
	  
	var r: longint;    {don't need numj, polj of sparse_findbest July 1998 }
	    p: quoly;
		  t, best, maybe_pol: colm_ptr; 
		  all_zero_row: boolean;  { Nov 2000 }
							    
   begin
	  
		  maybe_pol := nil;
		  best := nil;
		
		  for r := 1 to (i-1) div sparsesize do
			   sp := sp^.next;
		  t := sp^.indx[1 + (i-1) mod sparsesize];
			   
      j := -1;  { default, failure }
      
      for r := i to rows do
		    begin
		      { at start of each pass, t points to row r, first spot }
		      while t <> nil do
		         if t^.coord < i
		            then t := t^.next
		            else leave;
		      all_zero_row := true;   { Nov 2000 }
		      while t <> nil do
			       begin
					      p := t^.val;
					      all_zero_row := false;
	              if p^.numb
					        then begin
					                if p^.ncoef^.lint = 0
					                   then fermat_error('0 found in mod_sparse_findbest');
					                best := t;
					                j := r;
							            goto 877 
							         end
							    else if maybe_pol = nil  
								          then begin
									                maybe_pol := t;
									                j := r
									             end
								  else if quoly_mass(p) < quoly_mass(maybe_pol^.val)
									        then begin
											            maybe_pol := t;
											            j := r
											         end;
							    t := t^.next
				     end;
				   
				  if all_zero_row and leave_early  { Nov 2000 }
				     then begin
				             j := -1;  { BUG Jun 2004, must reset it! }
				             exit(mod_sparse_findbest)
				          end;
				     
			    if r mod sparsesize = 0
			       then begin
			               sp := sp^.next;
			               if sp <> nil
			                  then t := sp^.indx[1]
			            end
			       else t := sp^.indx[1 + r mod sparsesize]  { BUG of May 1998 }
		    end;
		   
		 877:;
		
		 if best = nil
		    then if maybe_pol <> nil
					     then best := maybe_pol;
				   
	   if best <> nil
		    then k := best^.coord
		   
   end;
			
 {************************************************************************}
 
 procedure special_mod_sparse_findbest; { (leave_early: boolean; sp: sparseptr; rows, i: longint; 
                                   var j, k: longint);}
 
   { i, j and k are relative coordinates with (1,1) base, rows = total number
	   of rows in matrix. modularmode with prime modulus. new Nov 2000.  compact storage of
	   data. all numbers.
	     Jul 2003: remove label
	     Mar 2004: remove p, best, all_zero_row  }
	  
	var r: longint;    
	    t: colm_ptr;
							    
   begin
		
		  for r := 1 to (i-1) div sparsesize do
			   sp := sp^.next;
		  t := sp^.indx[1 + (i-1) mod sparsesize];
			   
      j := -1;  { default, failure }
      
      for r := i to rows do
		    begin
		      { at start of each pass, t points to row r, first spot }
		      while t <> nil do
		         if t^.coord < i
		            then t := t^.next
		            else leave;  
		      if t <> nil   { Jul 2003, was a while loop, harmless but silly }
			       then begin
							       if Ord4(t^.val) = 0
							          then fermat_error('0 found in special_mod_sparse_findbest');
							       k := t^.coord;
							       j := r;
									   exit(special_mod_sparse_findbest)
				         end;
				   
				  if leave_early  
				     then exit(special_mod_sparse_findbest);
				     
			    if r mod sparsesize = 0
			       then begin
			               sp := sp^.next;
			               if sp <> nil
			                  then t := sp^.indx[1]
			            end
			       else t := sp^.indx[1 + r mod sparsesize]  { BUG of May 1998 }
		    end
		   
   end;
			
 {*************************************************************************}
 
 procedure findbest; { (start, stop, rows, i: longint; var j, k: longint; 
                        firstonly: boolean);   Apr 1999 }
 
      { i, j and k are relative coordinates with (0,0) base, rows = total number
	    of rows in matrix.  start and stop are absolute coords in arp. }
 
      label 876;
	  
	   var spot, maybe_pol, maybe_num, best, t: longint;
	      p, q: quoly;
		   either: boolean; 
							    
      begin
	  
		spot := start + i + i*rows;  { an absolute address within the store }
		maybe_pol := -1;
		maybe_num := -1;
		best := -1;
      while spot <= stop do
		   begin
		      for t := spot to spot + rows - i - 1 do
			      begin
					    p := arp[BSR(t, 10)]^[BAND(t, tenmask)];
	                if quoly_iszero(p)    
				          then { nothing }
	                else if p^.numb
					       then if equal_to_pm1(p^.ncoef^, either)
					               then begin
								              best := t;
										        goto 876 
										     end
										else if maybe_num = -1
												  then maybe_num := t
												  else begin
															 q := arp[BSR(maybe_num, 10)]^[BAND(maybe_num, tenmask)];
															 if abs_larger(q^.ncoef^, p^.ncoef^)
																 then maybe_num := t
														 end
					    else if maybe_pol = -1  
						        then maybe_pol := t
								  else begin
								          q := arp[BSR(maybe_pol, 10)]^[BAND(maybe_pol, tenmask)];
								          if quoly_mass(p) < quoly_mass(q)
										       then maybe_pol := t
									    end
				   end;
			   if firstonly  { Apr 1999 }
			      then leave
			      else spot := spot + rows
		   end;
		   
		876:;
		
		if best = -1
		   then if maybe_num > -1
		           then best := maybe_num
		           else if maybe_pol > -1
								 then best := maybe_pol;
				   
	   if best = -1
		   then j := -1
		   else begin
		           best := best - start;
		           j := best mod rows;
				     k := best div rows
				  end
		   
      end;
			
 {*************************************************************************}
 
 procedure colfindbest; { (start, rows, i, col: longint; var j: longint);  
                           Oct 2000 }
 
    { i, col, j are relative coordinates with (0,0) base, rows = total number
	    of rows in matrix.  start and stop are absolute coords in arp. 
	    Return j, the row number of the best spot in column col, from row i on down.  
	    We do not look in any other column but col. 
	      unused stop removed, Oct 2000 }
	  
	  var spot, maybe_pol, maybe_num, best, t: longint;
	      p, q: quoly;
		    either: boolean; 
							    
    begin
	  
		  spot := start + i + col*rows;  { an absolute address within the store }
		  maybe_pol := -1;
		  maybe_num := -1;
		  best := -1;
      for t := spot to spot + rows - i - 1 do
	       begin
			      p := arp[BSR(t, 10)]^[BAND(t, tenmask)];
            if quoly_iszero(p)    
		           then { nothing }
            else if p^.numb
			         then if equal_to_pm1(p^.ncoef^, either)
			                 then begin
						                   best := t;
								               leave 
								            end
								    else if maybe_num = -1
										   then maybe_num := t
										   else begin
													     q := arp[BSR(maybe_num, 10)]^[BAND(maybe_num, tenmask)];
													     if abs_larger(q^.ncoef^, p^.ncoef^)
														      then maybe_num := t
												    end
			      else if maybe_pol = -1  
				        then maybe_pol := t
						    else begin
						            q := arp[BSR(maybe_pol, 10)]^[BAND(maybe_pol, tenmask)];
						            if quoly_mass(p) < quoly_mass(q)
								           then maybe_pol := t
							       end
		    end;
		
		 if best = -1
		   then if maybe_num > -1
		           then best := maybe_num
		           else if maybe_pol > -1
								       then best := maybe_pol;
				   
	   if best = -1
		    then j := -1
		    else begin
		           best := best - start;
		           j := best mod rows
				     end
		   
   end;
			
 {************************************************************************}
 
 procedure sparse_colfindbest; { (sp: sparseptr; rows, i, col: longint; var j: longint) }
 
   { i, col, and j are relative coordinates with (1,1) base, rows = total number
	   of rows in matrix.  Search only the column col.  col may not be i!  Nove 2000 
	   allzeros means the entire submatrix is empty.  }
 
	 var r, numj, polj: longint;  { added numj, polj; BUG of July 1998 }
	     p: quoly;
		   either, allzeros: boolean;  { Nove 2000 }
		   t, best, maybe_pol, maybe_num: colm_ptr; 
							    
   begin
	  
		  maybe_pol := nil;
		  maybe_num := nil;
		  allzeros := true;
		
		  for r := 1 to (i-1) div sparsesize do
			   sp := sp^.next;
		  t := sp^.indx[1 + (i-1) mod sparsesize];
			   
      j := -1;  { default, this col is all 0 }
      
      for r := i to rows do
		    begin
		      { at start of each pass, t points to row r, first spot }
		      if allzeros 
		         then allzeros := (t = nil);
		      while t <> nil do
		         if t^.coord < col
		            then t := t^.next
		            else leave;
		      if (t <> nil) & (t^.coord = col) 
			       then begin
				        p := t^.val;
				        if quoly_iszero(p)   { should be impossible }
			             then fermat_error('p = 0 in sparse_colfindbest') 
                else if p^.numb
				           then if equal_to_pm1(p^.ncoef^, either)
				                   then begin
							                     j := r;
									                 exit(sparse_colfindbest)
									              end
												   else if maybe_num = nil
																  then begin
																          maybe_num := t;
																          numj := r
																       end
													 else if abs_larger(maybe_num^.val^.ncoef^, p^.ncoef^)
																  then begin
																          maybe_num := t;
																          numj := r
																       end
											     else { nothing }
				        else if maybe_pol = nil  
					              then begin
						                    maybe_pol := t;
						                    polj := r
						                 end
							  else if quoly_mass(p) < quoly_mass(maybe_pol^.val)
								        then begin
										            maybe_pol := t;
										            polj := r
										        end
				     end;
				     
			    if r mod sparsesize = 0
			       then begin
			               sp := sp^.next;
			               if sp <> nil
			                  then t := sp^.indx[1]
			            end
			       else t := sp^.indx[1 + r mod sparsesize]  { BUG of May 1998 }
		   end;
		          
		if allzeros
		   then j := -2;  { nothing left at all }
		   
		if maybe_num <> nil
       then begin
               best := maybe_num;
               j := numj
            end
       else if maybe_pol <> nil
				 then begin
				         best := maybe_pol;
				         j := polj
				      end
		   
   end;
			
 {************************************************************************}
 
 procedure sparse_mod_colfindbest; { (sp: sparseptr; rows, i, col: longint; var j: longint) }
 
   { i, col, and j are relative coordinates with (1,1) base, rows = total number
	   of rows in matrix.  Search only the column col.  col may not be i!  Nove 2000 
	   allzeros means the entire submatrix is empty. 
	     modular mode, prime, all integers.  }
 
	 var r, numj, maybe_num, p: longint; 
		   allzeros: boolean;  
		   t: colm_ptr; 
							    
   begin
	  
		  maybe_num := -1;
		  allzeros := true;
		
		  for r := 1 to (i-1) div sparsesize do
			   sp := sp^.next;
		  t := sp^.indx[1 + (i-1) mod sparsesize];
			   
      j := -1;  { default, this col is all 0 }
      
      for r := i to rows do
		    begin
		      { at start of each pass, t points to row r, first spot }
		      if allzeros 
		         then allzeros := (t = nil);
		      while t <> nil do
		         if t^.coord < col
		            then t := t^.next
		            else leave;
		      if (t <> nil) & (t^.coord = col) 
			       then begin
				        p := t^.val^.ncoef^.lint;
				        if p = 0   { should be impossible }
			             then fermat_error('p = 0 in sparse_mod_colfindbest') 
                else if p = 1
		                   then begin
					                     j := r;
							                 exit(sparse_mod_colfindbest) 
							              end
										   else if maybe_num = -1
														  then begin
														          maybe_num := p;
														          numj := r
														       end
											 else if maybe_num > p
														  then begin
														          maybe_num := p;
														          numj := r
														       end
				     end;
				     
			    if r mod sparsesize = 0
			       then begin
			               sp := sp^.next;
			               if sp <> nil
			                  then t := sp^.indx[1]
			            end
			       else t := sp^.indx[1 + r mod sparsesize]  { BUG of May 1998 }
		   end;
		          
		if allzeros
		   then j := -2;  { nothing left at all }
		   
		if maybe_num <> -1
       then j := numj
		   
   end;
			
  {*************************************************************************}
	
	function doing_polymod_field; { : boolean; } 
	
	    var q: polypt;
		 
		 begin
		  
			  q := polynames;
			  while q <> nil do
				  begin
					  if (q^.p <> nil) and q^.field
						  then leave;
					  q := q^.next
				  end;
			  doing_polymod_field := (q <> nil)
					 
		 end;

 {************************************************************************}
 
 function size_of; { (value, size: longint): longint;}
 
    { An approx to log base 2 of abs(value). value is the head node of some
	   number.  size gives number of nodes of that number. }
	 
	 var k, spot: longint;
    
	 begin
	    		 
		 if value >= 0
		    then begin
			         spot := -1;
						for k := logblock downto 0 do  { changed from 31 ~~~~}
							if BTST(value, k)
								then begin
										  spot := k;
										  leave
									  end
					end
		    else begin
			         spot := 0;
						for k := logblock downto 0 do  { changed from 31 ~~~~}
							if not BTST(value, k)
								then begin
										  spot := k;
										  leave
									  end
					end;
								  
		 size_of := logblock * (size - 1) + spot
							
	 end; 
						   
 {************************************************************************}
 
 function do_mod_method_now;{(u,v:poly; mod_deg:longint; tried_modular: 
                              boolean): boolean}
 
    { On input, neither is a number.  Pass back 'true' 
	   unless mod_deg is very close to degree of v (the smaller of the two) 
		and the mass heuristic used here is relatively small.  ~~~~ heuristics here
		questionable. 
		   mod_deg is an estimate of the true degree of gcd(u,v), but it might be
		too small, and could even be too big.  rational mode only. }
		
	 var delta, expo, vmass: longint;
	 
	 begin
	 
	    if (field_depth > 0) and not tried_modular
		    then begin
			         do_mod_method_now := false;
						exit(do_mod_method_now)
			      end;
		 
		 expo := v^.exp;
		 delta := expo - mod_deg;  
		 if (mod_method_diff < delta) | (6*delta > expo)
			 then do_mod_method_now := true
			 else begin
					   vmass := simple_poly_mass(v); 
					   if vmass > 280 
						   then do_mod_method_now := true
					   else if (expo = 1) and (vmass < 200)
						   then do_mod_method_now := false
					   else do_mod_method_now := (simple_poly_mass(u) > 350)
				   end
	 
	 end;
	 	 
 {************************************************************************}
 
 function mod_do_Chinese;{(u,v:poly; mod_deg:longint): boolean}
 
    { On input, neither is a number.  Pass back 'true' 
	   unless mod_deg is very close to degree of v (the smaller of the two) 
		and the mass heuristic used here is relatively small.  ~~~~ heuristics here
		questionable. 
		   mod_deg is an estimate of the true degree of gcd(u,v), but it might be
		too small, and could even be too big.  modular mode only. }
		
	 var delta, expo, vmass: longint;
	 
	 begin
	 
	    expo := v^.exp;
		  delta := expo - mod_deg;  
		  if (mod_method_diff < delta) | (6*delta > expo)
			   then mod_do_Chinese := true
			   else begin
							   vmass := very_simple_poly_mass(v); { Nov 2003 }
							   if vmass > 250 { was 280 }
								    then mod_do_Chinese := true
							   else if (expo = 1) and (vmass < 150)  { was 200 }
								    then mod_do_Chinese := false
							   else mod_do_Chinese := (very_simple_poly_mass(u) > 250) { Nov 2003. was 350 }
						  end
	 
	 end;   
	 	 
 {*************************************************************************}
 
  procedure best_on_diag; {(start, stop, rows, i: longint; var j, val: longint)} 
 
     { Search part of main diagonal for smallest. No zeroes here. }
 
			var maybe_num, best, t: longint;
					p, q: quoly;
					either: boolean; 
										
			begin
			
			t := start + i + i*rows;  { an absolute address within the store }
			maybe_num := -1;
			best := -1;
				while t <= stop do
				 begin
						p := arp[BSR(t, 10)]^[BAND(t, tenmask)];
							if equal_to_pm1(p^.ncoef^, either)
						 then begin
									 best := t;
									val := -1;
									 leave
								 end
					else if maybe_num = -1
								then maybe_num := t
								else begin
											q := arp[BSR(maybe_num, 10)]^[BAND(maybe_num, tenmask)];
											if int_abs_bigger(q^.ncoef^, p^.ncoef^, false)
												then maybe_num := t										
										end;
					t := t + rows + 1
				 end;
				 
			if best = -1 { never found 1 }
				 then begin
							best := maybe_num;
							val := 1
					end;
			
			best := best - start;
			j := best mod rows;
		   
     end;
			
  {************************************************************************}

  procedure spec_swap_rows; {Apr 1999; var dup: workarray;  i, j, rows: longint }
  
      var k, s: longint;
          temp: quoly;

      begin
         for k := 0 to i-1 do
            begin
	            s := rows * k;
	            temp := dup[i+s];
					dup[i+s] := dup[j+s];
					dup[j+s] := temp
            end
      end;
			
 {************************************************************************}

  procedure swap_rows; {(var n: quoly; var dup: workarray; 
	                    want_n, do_all: boolean; i, j, m: longint);~~~~ kill elem and
							  invert }
											
	  { m = rows; i and j reduced coordinates. Assume i <> j. 
	    revised July 1998 }

      var k, s, start: longint;
          temp: quoly;

      begin
         if do_all
            then start := 0
            else start := i;
         for k := start to m-1 do
            begin
	            s := m * k;
	            temp := dup[i+s];
					dup[i+s] := dup[j+s];
					dup[j+s] := temp
            end;
         if want_n
            then quoly_inplace(n)
      end;
			
  {***************************************************************************}
  
  procedure swap_cols; {(var arr: workarray; i, j, rows: longint);}
  
      var k, s, t: longint;
          temp: quoly;

      begin
	     s := j*rows;
		  t := i*rows;
        for k := 0 to rows-1 do
           begin
			     temp := arr[t+k];
			     arr[t+k] := arr[s+k];
			     arr[s+k] := temp;
           end	 
	  end;
	 			  
 {**************************************************************************}
 
 procedure identi; {(var arr: workarray; rows: longint; arr_free: boolean);}
 
    var i,j,k: longint;
		
	  begin
		
		 for i := 1 to rows do
		  for j := 1 to rows do
			 begin
				k := i + rows * (j - 1) - 1;
				if not arr_free  
				   then arr[k] := nil;
				if i = j
				   then quoly_set(1, arr[k])
				   else quoly_set(0, arr[k])
			 end
						 
	  end;
		
 {**************************************************************************}
 
 procedure uppertri; {(var arr: workarray; rows: longint);  Apr 1999 }
 
     var i,j,k: longint;
		
	  begin
		
		 for i := 1 to rows do
		    for j := i to rows do
				 begin
					k := i + rows * (j - 1) - 1;
					arr[k] := nil;
					if i = j
					   then quoly_set(1, arr[k])
					   else quoly_set(0, arr[k])
				 end
						 
	  end;
		
  {****************************************************************************}
  
  procedure row_red_arr(var arr: workarray; factor: number; rows, k, q: longint);
  
     { k and q are reduced coords. arr is rows X rows. }
  
     var i, j: longint;
	     n2: number;
	 
	 begin
	 
	    i := q;
		 n2.size := 0;
		 while i < rows*rows do
		    begin
		       j := i + k - q;
			    fast_mult(arr[i]^.ncoef^, factor, n2);
			    fastdiff(arr[j]^.ncoef^, n2);
			    i := i + rows
		    end;
	     free_num(n2)
		   
     end;
	 
   {****************************************************************************}
  
   procedure col_red_arr(var arr: workarray; factor: number; rows, k, q: longint);
  
     var i: longint;
	     n2: number;
	 
	 begin
	 
	    q := q*rows;
	    k := k*rows;
		 n2.size := 0;
		 for i := 0 to rows - 1 do
		    begin
			   fast_mult(arr[q+i]^.ncoef^, factor, n2);
			   fastdiff(arr[k+i]^.ncoef^, n2)
		    end;
		 free_num(n2)
	 
	 end;
			  
  {***************************************************************************}
  
  procedure reduce_it; {(var m, pseudodet, halfpseudo: number; wanthalf: boolean)}
     { 30 July 1998.  }
     var n2: number;
     begin
        n2.size := 0;
        if int_abs_bigger(m, pseudodet, true)
           then divide(m, pseudodet, n2, m);
        if wanthalf
           then if int_abs_bigger(m, halfpseudo, true)
                   then if m.head^.value > 0
                           then fastdiff(m, pseudodet)
                           else begin
                                   fastsum(m, pseudodet);
                                   if equal(m, halfpseudo)
                                      then fastdiff(m, pseudodet)
                                end;
        free_num(n2)
     end;
				               
  {***************************************************************************}
  
  procedure reduce_and_tell(var m, pseudodet, halfpseudo: number; var wanthalf, 
                            shrunkit: boolean);
     { 30 July 1998.  shrunkit is changed only if true. }
     var n2: number;
     begin
        n2.size := 0;
        if int_abs_bigger(m, pseudodet, true)
           then begin
                   divide(m, pseudodet, n2, m); 
                   shrunkit := true
                end;
        if wanthalf
           then if int_abs_bigger(m, halfpseudo, false)
                   then begin
                           if m.head^.value > 0
                              then fastdiff(m, pseudodet)
                              else fastsum(m, pseudodet);
                           shrunkit := true
                        end;
        free_num(n2)
     end;
				               
   {****************************************************************************}
  
   procedure sparse_mod_col_add; {(sp: sparseptr; factor, rows, k, q: longint)}
   
     { kth col <- kth col + factor*qth col.  k  q.  k and q are 1-based index coordinates.
       Presumably, factor is not 0, but that doesn't matter here (but wastes time). 
          modular mode, prime, all integers. Nove 2000  }
  
     var i, first, prod: longint;
	       qp: quoly;
	       t: colm_ptrptr;
	       s: colm_ptr;
	 
		 {------------------------------------------------------------------------}
		 
		 procedure deleteit(t: colm_ptrptr);
		    { t can't be nil, but make sure t^ <> nil. }
				begin
		       s := t^;
				   t^ := s^.next;
				   free_quoly(s^.val);
				   s^.next := colm_garb;
				   colm_garb := s
		    end;
		    
		 {-----------------------------------------------------------------------}

	   procedure continue_for_q;
	      begin
	         { leave t^ pointing to whatever it is, k or beyond k. }
	         s := t^;
	         while s <> nil do
							if s^.coord >= q  
								 then leave
								 else s := s^.next;
					 if s = nil
						  then qp := nil
						  else if s^.coord > q
							       then qp := nil
							       else qp := s^.val
	      end;
	   
	   {------------------------------------------------------------------------}
		 
		 procedure continue_for_k;
	      begin
	         while t^ <> nil do
				      if t^^.coord < k
						     then t := @ t^^.next
					       else leave
	      end;
	   
	   {------------------------------------------------------------------------}
	   
	   begin
	 
	     if q < k
	        then first := q
	        else first := k;
	     
	     for i := 1 to rows do
				  begin
				  
						 { Find both q and k in one pass. Efficient! }
						 t := @ sp^.indx[1 + (i - 1) mod sparsesize];
						 { First, get ready for next row. }
						 if i mod sparsesize = 0
						    then sp := sp^.next;
						    
						 while t^ <> nil do
				        if t^^.coord < first
						       then t := @ t^^.next
					         else leave;
						 if t^ = nil
						    then cycle;
						 if t^^.coord = first
						    then if first = q
						            then begin
						                    qp := t^^.val;
						                    continue_for_k
						                 end
						            else continue_for_q
						    else if first = q
						            then qp := nil { don't care whether k is there }
						            else continue_for_q;
						 if qp <> nil
						    then begin
						            prod := modmult(factor, qp^.ncoef^.lint);  { Aug 2001 }
										    if (t^ <> nil) & (t^^.coord = k) { not 0 }
						               then begin
						                       t^^.val^.ncoef^.lint := mod_add(t^^.val^.ncoef^.lint, prod, modulus);
						                       if t^^.val^.ncoef^.lint = 0
						                          then deleteit(t)
						                    end
						               else if prod <> 0
						                       then begin
																		       s := t^;
																		       newcolm(t^);
																				   t^^.next := s;
																				   t^^.val := nil;
																				   quoly_set(prod, t^^.val);
																				   t^^.coord := k
						                            end
						         end
						 
				  end
	 
	   end;
			  
   {****************************************************************************}
  
   procedure sparse_mod_row_add; {(sp: sparseptr; factor, k, q: longint);}
   
     { kth row <- kth row + factor*qth row.  k  q.  k and q are 1-based index coordinates.
       Presumably, factor is not 0, but it's ok here if it is (but wastes time).  
          modular mode, prime, all entries integer.  Nove 2000  }
  
     var i, prod: longint;
         sp2: sparseptr;
	       t, u: colm_ptrptr;
	       s: colm_ptr;
	 
		 {------------------------------------------------------------------------}
		 
		 procedure deleteit(t: colm_ptrptr);
		    { t can't be nil, but make sure t^ <> nil. }
				begin
		       s := t^;
				   t^ := s^.next;
				   free_quoly(s^.val);
				   s^.next := colm_garb;
				   colm_garb := s
		    end;
		    
		 {------------------------------------------------------------------------}

     begin
     
        sp2 := sp;
        for i := 1 to (q - 1) div sparsesize do
			     sp2 := sp2^.next;
			  t := @ sp2^.indx[1 + (q - 1) mod sparsesize];
			  if t^ = nil
			     then exit(sparse_mod_row_add);
			     
			  for i := 1 to (k - 1) div sparsesize do
			     sp := sp^.next;
        u := @ sp^.indx[1 + (k - 1) mod sparsesize];
        
        while u^ <> nil do
           if t^ = nil
			        then exit(sparse_mod_row_add)
			     else if u^^.coord < t^^.coord
			        then u := @ u^^.next
			     else if t^^.coord < u^^.coord
              then begin
                      s := u^;
							        newcolm(u^);
									    u^^.next := s;
									    s := u^;
									    s^.coord := t^^.coord;
									    s^.val := nil;
									    prod := modmult(factor, t^^.val^.ncoef^.lint);  { Aug 2001 }
									    if prod = 0
											   then deleteit(u)  { unlikely but possible }
                         else begin
                                 quoly_set(prod, s^.val);
                                 u := @ s^.next
                              end;
                      t := @ t^^.next
                   end
           else begin
                   prod := modmult(factor, t^^.val^.ncoef^.lint);   { Aug 2001 }
                   prod := mod_add(u^^.val^.ncoef^.lint, prod, modulus);
                   if prod = 0
										  then deleteit(u)  
                      else begin
                              u^^.val^.ncoef^.lint := prod;
                              u := @ u^^.next
                           end;
                   t := @ t^^.next
                end;
                
        while t^ <> nil do  { dump to u^ }
           begin
              prod := modmult(factor, t^^.val^.ncoef^.lint);   { Aug 2001 }
              if prod <> 0
								 then begin
                         newcolm(u^);
									       s := u^;
									       s^.coord := t^^.coord;
									       s^.val := nil;
									       quoly_set(prod, s^.val);
                         u := @ s^.next
                      end;
              t := @ t^^.next
           end;
           
        u^ := nil
     
     end;

   {****************************************************************************}
  
   procedure sparse_mod_divide_row; { (sp: sparseptr; factor, k: longint); }
   
     { kth row <- kth row / factor. factor <> 0. modular mode, prime. all integer.
       Nove 2000. }
  
     var i: longint;
	       u: colm_ptr;
	 
     begin
     
			  for i := 1 to (k - 1) div sparsesize do
			     sp := sp^.next;
        u := sp^.indx[1 + (k - 1) mod sparsesize];
        
        mod_inverse(factor, k);
        while u <> nil do
           begin
              { quoly_quot(u^.val, factor, u^.val) }
              u^.val^.ncoef^.lint := modmult(u^.val^.ncoef^.lint, k);  { Aug 2001 }
              u := u^.next
           end
     
     end;

   {****************************************************************************}
  
   procedure sparse_mod_mult_col; {(sp: sparseptr; factor: quoly; rows, k: longint)}
   
     { kth col <- kth col * factor. factor is not 0. modular mode, prime. all
       integer. Nove 2000 }
  
     var i: longint;
	       t: colm_ptrptr;
	 	   
	   begin
	 
	     for i := 1 to rows do
				  begin
						 t := @ sp^.indx[1 + (i - 1) mod sparsesize];
						 { First, get ready for next row. }
						 if i mod sparsesize = 0
						    then sp := sp^.next;
						 while t^ <> nil do
				        if t^^.coord < k
						       then t := @ t^^.next
					         else leave;
						 if t^ = nil
						    then cycle;
						 if t^^.coord > k
						    then cycle;
						 { quoly_mult(t^^.val, factor, t^^.val) }
						 t^^.val^.ncoef^.lint := modmult(t^^.val^.ncoef^.lint, factor)   { Aug 2001 }
				  end
	 
	   end;
			  
  {***************************************************************************}
  
  procedure sparse_int_rowred; {(t, u: colm_ptrptr; k,tg: longint; 
                         var j2,k2, val2: longint; wantsmallest: boolean; 
                         var factor: number; wantmod, wanthalf: boolean; var pseudodet,
                         halfpseudo: number)}
  
   { reduce one row. if wantsmallest, look for smallest abs. value non zero 
	   entry formed.
	   
	   In the rows and columns >= init (not given), the best spot to pivot on was found by
	   the caller to be (j,k).  sp^ is tg's block on entry.  tg <> j.  tg, j, and k are 
	   all >= init.  (tg means target.)  t points to j's row and u points to tg's row.
	   On this invocation we are to row-reduce row tg.
	   If in the process we find something better than the value at (j,k) we report
	   it in (j2,k2) and val2.  If val2 = 1, then j2 and k2 must both be set here.
	   All these coords are based on 1.  June 1998.  Compare procedure sp_row_add as 
	   well as the "ordinary" version, procedure int_rowreduce.
		
		 September 1992.  if wantmod, pseudodet must be a power of 2^logblock.
		 July 1998:  the above sentence is garbage!  revised pseudodet. It is now a
		 multiple of the gcd of all the minors of maximal rank it must be so!  One way to 
		 compute it is with Pseudet. 
		
		 Oct 2000:  removed params sp, rows, and j, since they are not actually referenced here. }
  
     var s: colm_ptr;
	       tcop, ucop: colm_ptrptr;
	       n2, key: number;
	       tgp: imptr;
	 
	  {------------------------------------------------------------------------}
	 
	  procedure delete_u;
		   begin
	        u^ := s^.next;
		      free_quoly(s^.val);
		      s^.next := colm_garb;
		      colm_garb := s
	     end;
	    
	  {------------------------------------------------------------------------}

     procedure check_wantmod_smallest(var m: number);
        begin
           if wantmod 
              then reduce_it(m, pseudodet, halfpseudo, wanthalf);
			     if wantsmallest and (m.head^.value <> 0)
			        then if int_abs_bigger(key, m, false)
						    then begin  { mark smallest in abs. value, not zero }
							         k2 := t^^.coord;
									     key := m { num_assign(m, key) Oct 2000 }
								     end
        end;
        
	  {------------------------------------------------------------------------}

     procedure careful_check(var m: number);
        { at start, we know m is too big to be better than (j,k).  So we
          try not to waste time checking m to key, etc. }
        var shrunkit: boolean;
        begin
           shrunkit := false;
           if wantmod 
              then reduce_and_tell(m, pseudodet, halfpseudo, wanthalf, shrunkit);
			     if wantsmallest and shrunkit and (m.head^.value <> 0)
			        then if int_abs_bigger(key, m, false)
						       then begin  { mark smallest in  abs. value, not zero }
							             k2 := t^^.coord;
									         key := m { num_assign(m, key) Oct 2000 }
								        end
        end;
        
     {-----------------------------------------------------------------------}
     
     procedure exitt;
        begin
           free_num(n2);
	         if k2 > -1  { not possible if don't wantsmallest }
			        then begin
			               j2 := tg;
					           if (key.size = 1) and (abs(key.head^.value) = 1) 
			                  then val2 := -1  { found 1 }
						            else val2 := 1   { found something better than original }
					    end;  
			     { if wantsmallest then free_num(key); Oct 2000 }
			     exit(sparse_int_rowred)
        end;
        
     {----------------------------------------------------------------------}
     
     begin
     
        k2 := -1;  
        val2 := 0; { defaults, mean no change of pivot. Don't change unless something better
                     than (j,k) is found. }
        tcop := t;
        ucop := u;
		     
        { Figure out the quotient of entry[tg,k] div entry[j,k]. }
        while u^ <> nil do
	        if u^^.coord < k
		         then u := @ u^^.next
	           else leave;
		  if (u^ = nil) | (u^^.coord > k) 
		     then begin
		             setvalue(0, factor);
		             exit(sparse_int_rowred)
		          end;
	     { t^^.val^.ncoef^ is the entry[j,k], the "key" value. }
		  while t^ <> nil do
	        if t^^.coord < k
		         then t := @ t^^.next
	           else leave;
		  if (t^ = nil) | (t^^.coord > k)
		     then begin
		             fermat_error('t is nil in sparse_int_rowred, 2.');
		             setvalue(0, factor);
		             exit(sparse_int_rowred)
		          end;
		          
		  n2.size := 0;
		  divide(u^^.val^.ncoef^, t^^.val^.ncoef^, factor, n2); { don't want n2 } 
		  if factor.head^.value = 0
		     then fermat_error('factor is 0 in sparse_int_rowred.');
		  in_place_neg(factor); { do this here. Note difference with ordinary array version}
		  if wantsmallest
			     then begin { mark (j,k) as best yet seen, but of course leave k2 as -1 }
			             key := t^^.val^.ncoef^  { key.size := 0;  Oct 2000
			             num_assign(t^^.val^.ncoef^, key)  }
					      end;
						    
        { Now do the row reduction. }
        t := tcop;
        u := ucop;
        while u^ <> nil do
           if t^ = nil
		        then exitt
		     else if u^^.coord < t^^.coord
		        then u := @ u^^.next
		     else if t^^.coord < u^^.coord
	           then begin
	                  s := u^;
						        newcolm(u^);
								    u^^.next := s;
								    s := u^;
								    s^.coord := t^^.coord;
								    s^.val := nil;
								    quoly_set(0, s^.val);
								    tgp := s^.val^.ncoef;
								    fast_mult(factor, t^^.val^.ncoef^, tgp^);
								    careful_check(tgp^);
								    if tgp^.head^.value = 0 
										   then delete_u  { unlikely but possible }
			                 else u := @ s^.next;
			              t := @ t^^.next
	                end
	        else begin
	                fast_mult(factor, t^^.val^.ncoef^, n2);
	                s := u^;
	                tgp := s^.val^.ncoef;
	                fastsum(tgp^, n2);
	                check_wantmod_smallest(tgp^);
	                if tgp^.head^.value = 0
							       then delete_u
	                   else u := @ s^.next;
	                t := @ t^^.next
	             end;
           
        while t^ <> nil do  { dump to u^ }
           begin
              fast_mult(factor, t^^.val^.ncoef^, n2);
              careful_check(n2);
              if n2.head^.value <> 0 { highly likely }
					       then begin
                         newcolm(u^);
						             s := u^;
									       s^.coord := t^^.coord;
									       newquoly(s^.val);
										     s^.val^.numb := true;
										     newimag(s^.val^.ncoef);
									       s^.val^.ncoef^ := n2;
									       n2.size := 0;
                         u := @ s^.next
                      end;
              t := @ t^^.next
           end;
        
        u^ := nil;
        
        exitt
     
     end;
	 
  {***************************************************************************}
  
  procedure sparse_int_colred; {(sp: sparseptr; init,j,k,tg,rows: longint; var j2,k2,
                             val2: longint; wantsmallest: boolean; var factor: number;
								     wantmod, wanthalf: boolean; var pseudodet, halfpseudo:
								     number)}
								     
    { All new,  June 1998.
      reduce one col. if wantsmallest, look for smallest abs. value non zero 
	   entry formed.
	   
	   In the rows and columns >= init, the best spot to pivot on was found by the
	   caller to be (j,k).  sp^ is init's block on entry.  tg <> k.  tg, j, and k are 
	   all >= init.  (tg means target.)  On this invocation we are to col-reduce col 
	   tg.  If in the process we find something better than the value at (j,k) we report
	   it in (j2,k2) and val2.  If val2 = 1, then j2 and k2 must both be set here. 
	   All these coords are based on 1.   Compare procedure sp_col_add as well as the 
	   "ordinary" version, procedure int_colreduce.
		
		 if wantmod, pseudodet must be a multiple of the gcd of all the maximal rank
		 minors.  wanthalf and halfpseudo are meaningless unless wantmod is true. }  
								     
  	  var i, first: longint;
			t, u: colm_ptrptr;
	      sp2: sparseptr;
	      s: colm_ptr;
	      tgp, key: imptr; 
	      mkey, n2: number;
	 
	 {------------------------------------------------------------------------}
	 
	 procedure deleete(t: colm_ptrptr);
	    { t can't be nil, but make sure t^ <> nil. }
		 begin
	       s := t^;
			 t^ := s^.next;
			 free_quoly(s^.val);
			 s^.next := colm_garb;
			 colm_garb := s
	    end;
	    
	 {-----------------------------------------------------------------------}

    procedure continue_for_k;
       begin
          { leave u^ pointing to whatever it is; right for tg. }
          s := u^;
          while s <> nil do
				 if s^.coord >= k  
					 then leave
					 else s := s^.next;
			 if s = nil
			    then key := nil
			    else if s^.coord > k
				         then key := nil
				         else key := s^.val^.ncoef
       end;
	   
	  {------------------------------------------------------------------------}
		 
	  procedure get_key;
        begin
           u := t;
           tgp := u^^.val^.ncoef;
           t := @ t^^.next;
           while t^ <> nil do
			     if t^^.coord < k
				     then t := @ t^^.next
				     else leave;
			  if (t^ = nil) | (t^^.coord > k)
			     then begin
			             fermat_error('t is nil in sparse_int_colred, 2.');
		                exit(sparse_int_colred)
			          end;
			  key := t^^.val^.ncoef
        end;
	           
	  {------------------------------------------------------------------------}
		 
	 procedure continue_for_tg;
       begin
          key := u^^.val^.ncoef;
          u := @ u^^.next;
          while u^ <> nil do
			    if u^^.coord < tg
				    then u := @ u^^.next
				    else leave;
			 if u^ = nil
			    then tgp := nil
			    else if u^^.coord > tg
			            then tgp := nil
			            else tgp := u^^.val^.ncoef
			 { leave u^ pointing to whatever it is; right for tg. }
       end;
	   
	  {------------------------------------------------------------------------}

     procedure check_wantmod_smallest(var m: number; spot: longint);
        begin
           if wantmod 
              then reduce_it(m, pseudodet, halfpseudo, wanthalf);
			  if wantsmallest and (m.head^.value <> 0)
			     then if int_abs_bigger(mkey, m, false)
						    then begin  { mark smallest in  abs. value, not zero }
							         j2 := spot;
									   num_assign(m, mkey)
								   end
        end;
        
	  {------------------------------------------------------------------------}

     procedure careful_check(var m: number);
        { at start, we know m is too big to be better than (j,k).  So we
          try not to waste time checking m to poskey, etc.  wantmod is true. }
        var shrunkit: boolean;
        begin
           shrunkit := false;
           if wantmod 
              then reduce_and_tell(m, pseudodet, halfpseudo, wanthalf, shrunkit);
			  if wantsmallest and shrunkit and (m.head^.value <> 0)
			     then if int_abs_bigger(mkey, m, false)
						    then begin  { mark smallest in  abs. value, not zero }
							         j2 := i;
									   num_assign(m, mkey)
								   end
        end;
        
     {----------------------------------------------------------------------}
     
     procedure exitt;
        begin
           setvalue(0, factor);
           exit(sparse_int_colred)
        end;
     
	 {-----------------------------------------------------------------------}
	 
	 begin
	 
	     { get first coord in init's block. Use it find the right sp2 
          for j.  t points to j.  Use k2 to save a variable. }
        k2 := ((init-1) div sparsesize) * sparsesize + 1;
        sp2 := sp;
        for i := 1 to (j - k2) div sparsesize do
			  sp2 := sp2^.next;
		  { t is always used to mark j's row. }
		  t := @ sp2^.indx[1 + (j - 1) mod sparsesize];
		  
		  j2 := -1;  
        val2 := 0; { defaults, mean no change of pivot }
        
		  while t^ <> nil do
		     if t^^.coord < init  { not possible for Smith form. }
			     then t := @ t^^.next
			     else leave;
		  if t^ = nil
		     then begin
		             fermat_error('t is nil in sparse_int_colred, 1.');
		             exitt
		          end;
		             
        { Get pointers to k and tq in one pass.  }
        { If called by Smith, t^^.coord must be k or tg(!) because of the way this proc 
          is called.  But if called by Intcolred, t^^.coord could be less than i, since 
          row reductions are not done. }
        if t^^.coord = k  
		     then begin
                   if tg < k
                      then exitt;  { entry (j,tg) = 0 }
                   key := t^^.val^.ncoef;
                   u := @ t^^.next;
                   { u^^.coord must be tg, unless tg's val = 0 to start with }
                   if u^ = nil
                      then begin
                              val2 := -2; { signal to caller; row is done and all 0}
                              exitt
                           end
                   else if u^^.coord = tg
                       then tgp := u^^.val^.ncoef
                   else exitt
                        { entry (j,tg) must be 0, because of how this proc is called --
                          we can't be looking at some nonzero entry at a col < tg. }
		          end
		  else if t^^.coord = tg
		       then get_key
		  else exitt; { entry (j,tg) must be 0, because of how this proc is called }
		       
		  if wantsmallest
           then begin  { mark (j,k) as best yet seen, but of couurse leave j2 as -1 }
			          mkey.size := 0;
				       num_assign(key^, mkey)
			       end; 
		       
	     divide(tgp^, key^, factor, tgp^);
	     in_place_neg(factor);  { the convention for these procedures }
	     { Note that now factor can't be 0: would contradict (j,k) as best value. }
		  if key^.head^.value < 0
		     then in_place_neg(tgp^);  { make up for bad handling of negatives }
		  if tgp^.head^.value = 0
		     then deleete(u)
		     else check_wantmod_smallest(tgp^, j);
				    
		  if tg < k
	        then first := tg
	        else first := k;
	     { t is always used to mark j's row. }
		  t := @ sp2^.indx[1 + (j - 1) mod sparsesize];
		  n2.size := 0;
		  for i := init to rows do
			   begin
				  { at start, sp points to i's row. u traverses i's row. }
				  u := @ sp^.indx[1 + (i - 1) mod sparsesize];
				  { get sp ready for next pass through loop }
				  if i mod sparsesize = 0
				     then sp := sp^.next;
				  if u = t
				     then cycle;
				  { Get pointers to (i,k) and (i,tq) in one pass.  }
		        while u^ <> nil do
		           if u^^.coord < first
				        then u := @ u^^.next
			           else leave;
				  if u^ = nil
				     then cycle;
				  if u^^.coord = first
				     then if first = tg
				             then begin
				                     tgp := u^^.val^.ncoef;
				                     continue_for_k
				                  end
				             else continue_for_tg
				     else if first = k
				             then key := nil { don't care whether tg is there }
				             else begin
				                     tgp := nil;
				                     continue_for_k
				                  end;
				  if key <> nil
					  then begin
			                fast_mult(factor, key^, n2);
			                { n2 can't be 0 }
						       if tgp <> nil { not 0 }
			                   then begin
			                           fastsum(tgp^, n2);
			                           check_wantmod_smallest(tgp^, i);
			                           if tgp^.head^.value = 0
			                              then deleete(u)
			                        end
			                   else begin
									         if wantmod
									            then careful_check(n2);
									         if n2.head^.value <> 0
									            then begin
									                    s := u^;
												           newcolm(u^);
														     u^^.next := s;
														     s := u^;
														     s^.coord := tg;
														     newquoly(s^.val);
				                                   s^.val^.numb := true;
				                                   newimag(s^.val^.ncoef);
				                                   s^.val^.ncoef^ := n2;
														     n2.size := 0
														  end
	                              end
			            end 
				       
				end;				
				 
			free_num(n2);
         if j2 > -1  { not possible if don't wantsmallest }
		      then begin
		              k2 := tg;
				        if (mkey.size = 1) and (abs(mkey.head^.value) = 1) 
		                 then val2 := -1  { found 1 }
					        else val2 := 1   { found something better than original }
				     end;  
		   if wantsmallest then free_num(mkey)
							   
	  end;
								     
  {***************************************************************************}
  
  procedure int_rowreduce; {(start, i,j,k,t,rows,stop: longint; var j2,k2,
                             val2: longint; wantsmallest: boolean; var factor: number;
								     wantmod,wanthalf: boolean; var pseudodet, halfpseudo: number)}
  
     { reduce one row. if wantsmallest, look for smallest abs. value non zero 
	   entry formed.
	   
	   In the rows and columns >= i, the best spot to pivot on was found by the
	   caller to be (j,k).  On this invocation we are to row-reduce row t. t <> j.
	   If in the process we find something better than the value at (j,k) we report
	   it in (j2,k2) and val2.  factor must be passed back in all cases. 
	   All these coords are based on 0.  June 1998.
	   wanthalf and halfpseudo are meaningless unless wantmod.
		
		September 1992.  if wantmod, pseudodet must be a power of 2^logblock.
		July 1998: above sentence is garbage!  changed.  also revised poskey, 
		negkey => mkey }
  
     var locat, spot, r: longint;
	      key: quoly;
	      p: imptr;   { June 1998; changed p }
		   n2, mkey: number;  { July 1998 }
	 
	 begin
	 
		k2 := -1; 
		val2 := 0;  { June 1998; move these defaults here. }
		r := start + k*rows + j;
		{ key is the known best element. }
		key := arp[BSR(r, 10)]^[BAND(r, tenmask)];
		r := start + k*rows + t;
		{ p is the corresponding element in row t and col k. }
		p := arp[BSR(r, 10)]^[BAND(r, tenmask)]^.ncoef;
		if p^.head^.value = 0
		   then begin
		           setvalue(0, factor);
		           exit(int_rowreduce)
		        end;  { June 1998; an obvious improvement! }
		n2.size := 0;
		divide(p^, key^.ncoef^, factor, n2); { throw away n2 }
	   if wantsmallest  { rearranged a lot of code, July 1998 }
		   then begin
		           mkey.size := 0;
		           num_assign(key^.ncoef^, mkey)
				  end;
		{ locat moves through row t, spot moves through row j. Start in column i. }
	   locat := start + i*rows + t - rows;  { July 1998 }
		spot := start + i*rows + j - rows;   { July 1998 }
		while true do
		   begin
		      spot := spot + rows;  { moved these, July 1998, to use cycle below }
			   locat := locat + rows;
			   if locat > stop
			      then leave;
			   p := arp[BSR(spot, 10)]^[BAND(spot, tenmask)]^.ncoef;
			   if p^.head^.value = 0
			      then cycle;  { improvement, July 1998 }
			   fast_mult(factor, p^, n2);
		      p := arp[BSR(locat, 10)]^[BAND(locat, tenmask)]^.ncoef;
			   fastdiff(p^, n2);
				if wantmod  { July 1998; and below }
               then reduce_it(p^, pseudodet, halfpseudo, wanthalf); 
			   if wantsmallest and (p^.head^.value <> 0)
			      then if int_abs_bigger(mkey, p^, false)
						     then begin  { mark smallest in  abs. value not zero }
							          k2 := locat;
									    num_assign(p^, mkey)
								    end
		   end;
		   
		free_num(n2);
		if k2 > -1
		   then begin
		           j2 := (k2 - start) mod rows;
				     k2 := (k2 - start) div rows;
				     if (mkey.size = 1) and (abs(mkey.head^.value) = 1) { June 1998 }
		              then val2 := -1  { found 1 }
					     else val2 := 1   { found something better than original }
				  end;  { no improvement found }
		if wantsmallest then free_num(mkey)
		
     end;
	 
  {***************************************************************************}
  
  procedure int_colreduce; {(start, i,j,k,t,rows: longint; var j2,k2,
                             val2: longint; wantsmallest: boolean; var factor: number;
								     wantmod, wanthalf: boolean; var pseudodet, halfpseudo: number)}
  
    { reduce one col. if wantsmallest, look for smallest abs. value non zero 
	   entry formed. k  t.  Best entry is in (j,k).  Change column t.
	   
	   See comment for int_rowreduce. 
	   
	   At the start of every invocation, the (j,k) entry IS the best in the i-submatrix 
	   (i.e., there is none better).
		
		September 1992:  if wantmod, pseudodet must be be power of 2^logblock.
		July 1998: above sentence is garbage!  changed.  also changed poskey,
		 negkey => mkey.  Other changes too. }
  
     var locat, spot, r: longint;
	      key: quoly;
	      p: imptr;   { 30 July 1998 }
		   n2, mkey: number;  { July 1998 }

	 begin
	 
		val2 := 0;  { move defaults to here, July 1998 }
		k2 := -1;
		r := start + k*rows + j;
		{ key is the known best element. }
		key := arp[BSR(r, 10)]^[BAND(r, tenmask)];
		r := start + t*rows + j;
		{ p is the corresponding element in row t and col k. }
		p := arp[BSR(r, 10)]^[BAND(r, tenmask)]^.ncoef;
		n2.size := 0;
		divide(p^, key^.ncoef^, factor, n2); 
		free_num(n2);
		if factor.head^.value = 0
		   then begin
		           if p^.head^.value <> 0  { 30 July 1998 }
		              then fermat_error('odd 0 value in int_colreduce');
		           exit(int_colreduce) { June 1998 }
		        end;
	   locat := start + t*rows + i;  { first guy in t's column }
		spot := start + k*rows + i;
		if wantsmallest
		   then begin
		           mkey.size := 0;
		           num_assign(key^.ncoef^, mkey)
				  end;
		n2.size := 0;  { yes! necessary! }
		while locat < start + t*rows + rows do
		   begin
		      fast_mult(factor, arp[BSR(spot, 10)]^[BAND(spot, tenmask)]^.ncoef^, n2);
		      p := arp[BSR(locat, 10)]^[BAND(locat, tenmask)]^.ncoef;
			   fastdiff(p^, n2);
				if wantmod  { July 1998; and below }
               then reduce_it(p^, pseudodet, halfpseudo, wanthalf);
			   if wantsmallest and (p^.head^.value <> 0)
			      then if int_abs_bigger(mkey, p^, false)
						     then begin  { mark smallest in  abs. value not zero }
							          k2 := locat;
									    num_assign(p^, mkey)
								    end;
			   Inc(spot);
			   Inc(locat)
		   end;
		   
		free_num(n2);
		if k2 > -1  { possible only if wantsmallest }
		   then begin
		           j2 := (k2 - start) mod rows;
				     k2 := (k2 - start) div rows;
				     if (mkey.size = 1) and (abs(mkey.head^.value) = 1) { June 1998 }
		              then val2 := -1  { found 1 }
					     else val2 := 1   { found something better than original }
				  end;		
		   
		if wantsmallest then free_num(mkey)
		
     end;
	 
  {***************************************************************************}
 
  procedure fast_sparse_colred; {(sp: sparseptr; init,j,k,tg: longint; var j2,k2,
                                 val2: longint; var factor: number)}
                                 
     { (j,k) is the best spot yet found, the "pivot", in the array beyond location
       (init, init).  sp^ points to the block of (init, init). We know that 
       everything in col k except (j,k) is zero.  Ideally, we want to use (j,k) to 
       reduce the rest of row j.  This invocation is just to reduce the entry at (j,tg),
       tg <> k.  It might be that the value at (j,tg) = 0. But the new value there 
       will be better than the original pivot unless 
       it is 0.  This fact is passed back via j2, k2, val2, and factor; then we switch
       to using the new spot for the pivot.  If val2 = 1, then both k2 and j2 must
       be set here.  All new, June 1998.
          removed unuses rows, Oct 2000 }
       
     var i: longint;
         t, u: colm_ptrptr;
	      key, tgp: imptr;
	      poskey: number;
	 
	  {------------------------------------------------------------------------}
	 
	  procedure delete_u;
	     var s: colm_ptr;
		  begin
	        s := u^;
		     u^ := s^.next;
		     free_quoly(s^.val);
		     s^.next := colm_garb;
		     colm_garb := s
	     end;
	    
	  {------------------------------------------------------------------------}
		 
	  procedure continue_for_k;
        begin
           u := t;
           tgp := u^^.val^.ncoef;
           t := @ t^^.next;
           while t^ <> nil do
			     if t^^.coord < k
				     then t := @ t^^.next
				     else leave;
			  if (t^ = nil) | (t^^.coord > k)
			     then begin
			             fermat_error('t is nil in fast_sparse_colred, 2.');
		                exit(fast_sparse_colred)
			          end;
			  key := t^^.val^.ncoef
        end;
	           
     {----------------------------------------------------------------------}
     
     procedure exitt;
        begin
           setvalue(0, factor);
           exit(fast_sparse_colred)
        end;
     
     {----------------------------------------------------------------------}
     
     begin
     
        k2 := -1;  
        val2 := 0; { defaults, no change in pivot. }
        { Get first coord in init's block. Use it find the right sp
          for (j,k) and (j,tg). }
        init := ((init-1) div sparsesize) * sparsesize + 1;
        for i := 1 to (j - init) div sparsesize do
			  sp := sp^.next;
		  t := @ sp^.indx[1 + (j - 1) mod sparsesize];
		  if t^ = nil
		     then begin
		             fermat_error('t is nil in fast_sparse_colred, 1.');
		             setvalue(0, factor);
		             exit(fast_sparse_colred)
		          end;
        
        { Get pointers to k and tq in one pass.  }
        if t^^.coord = k 
		     then begin
                   if tg < k
                      then exitt;  { entry (j,tg) = 0 }
                   key := t^^.val^.ncoef;
                   u := @ t^^.next;
                   { u^^.coord must be tg, unless tg's val = 0 to start with }
                   if u^ = nil
                      then begin
                              val2 := -2; { signal to caller }
                              exitt
                           end
                   else if u^^.coord = tg
                       then tgp := u^^.val^.ncoef
                   else exitt
                        { entry (j,tg) must be 0, because of how this proc is called }
                           
		          end
		  else if t^^.coord = tg
		       then continue_for_k
		  else exitt; { entry (j,tg) must be 0, because of how this proc is called }
		  
	     divide(tgp^, key^, factor, tgp^);
	     in_place_neg(factor);  { caller wants this. }
		  if key^.head^.value < 0
		     then in_place_neg(tgp^);  { make up for bad handling of negatives }
		  if tgp^.head^.value = 0
		     then delete_u  
		     else begin  { mark this spot }
				       poskey.size := 0;
				       abs_val_num(tgp^, poskey);
		             j2 := j;
				       k2 := tg;
				       if (poskey.size = 1) and (poskey.head^.value = 1) 
		                then val2 := -1  { found 1 }
					       else val2 := 1;  { found something better than original }
					    free_num(poskey)
				    end
				    
	  end;
                           
  {***************************************************************************}
  
  procedure fast_colreduce; {(start, j,k,t,rows: longint; var j2,k2,val2: longint;
                             var factor: number)}
  
     { (j,k) is the best spot yet found, the "pivot". We know that everything in col 
       k except (j,k) is zero. Ideally, we want to use (j,k) to 
       reduce the rest of row j.  This invocation is just to reduce the entry at (j,t).
       But the new value there will be better than the original pivot unless it is 0.  
       This fact is passed back via j2, k2, and val2, and then we switch to using the
       new spot for the pivot.   All coords are reduced, relative to (0,0).  
     
       massive rewrite June 1998. }
   
     var r: longint;
	      p, key: imptr;
		   poskey: number;
	 
	 begin
	 
		r := start + k*rows + j;
		key := arp[BSR(r, 10)]^[BAND(r, tenmask)]^.ncoef;
		r := start + t*rows + j;
		p := arp[BSR(r, 10)]^[BAND(r, tenmask)]^.ncoef;
		divide(p^, key^, factor, p^);
		if key^.head^.value < 0
		   then in_place_neg(p^);  { make up for bad handling of negatives }		
		{ abs_val_num(key^.ncoef^, poskey);  removed as unnecessary June 1998 }
		k2 := -1;
		if p^.head^.value <> 0
		   then begin  { mark this spot }
				     poskey.size := 0;
				     abs_val_num(p^, poskey);
		           j2 := (r - start) mod rows;
				     k2 := (r - start) div rows;
				     if (poskey.size = 1) and (poskey.head^.value = 1) { June 1998 }
		              then val2 := -1  { found 1 }
					     else val2 := 1;   { found something better than original }
					  free_num(poskey)
				  end		
		   else val2 := 0  { no improvement found }		
		
     end;
		 
	{****************************************************************************}
	
	procedure rat_number_mult; {(n: poly; im: imptr)}
	
	   {  im is not 0.  rational mode.  Multiply in place all the
		   coefs of n by im^. }
			 
		 begin
		 
		    if (im^.head^.value <> 1) | (im^.size > 1)
			    then while n <> nil do
							 begin
								 if n^.numb
									 then fast_mult(n^.ncoef^, im^, n^.ncoef^)
									 else rat_number_mult(n^.pcoef, im);
								 n := n^.next
							 end
		 
		 end;
	
  {*****************************************************************************}
	
  procedure best_other; {(start, stop, i, rows: longint; var j: longint)}
  
	  var t: longint;
	      p, q: quoly;
		   either: boolean;
		   dummy, modul, key: number;
							    
      begin
	  
			t := start + i + i*rows;
			q := arp[BSR(t, 10)]^[BAND(t, tenmask)];
			j := start;  
			t := t + rows + 1;  { t is definitely bigger than start }
			dummy.size := 0;
			key.size := 0;
			modul.size := 0;
			while t <= stop do
				begin
					p := arp[BSR(t, 10)]^[BAND(t, tenmask)];
					divide(p^.ncoef^, q^.ncoef^, dummy, modul);
					if modul.head^.value = 0
						then { nothing }
					else if equal_to_pm1(modul, either)
								  then begin
											 j := t;
											 leave
										 end
					else if j = start
							  then begin
										 j := t;
										 num_assign(modul, key)
									 end
					else if int_abs_bigger(key, modul, false)
							  then begin
										 j := t;
										 num_assign(modul, key)
									 end;
					t := t + rows + 1
				end;
			free_num(dummy);
			free_num(key);
			free_num(modul);
				
			j := (j  - start) mod rows { can't be 0 unless nothing ever happened }
		   
      end;
			
  {*****************************************************************************}
	
  procedure sparse_best_other; {sp: sparseptr; i, rows: longint; var j: longint}
  
     { July 1998, sp^ is i's block. return j.  }
  
	  var r: longint;
	      p, q: imptr;
	      either, first_time: boolean;
		   dummy, modul, key: number;
							    
    begin
	  
		 q := sp^.indx[1 + (i-1) mod sparsesize]^.val^.ncoef;
		 dummy.size := 0;
		 key.size := 0;
		 modul.size := 0;
		 first_time := true;
		 j := 0;
		 if i mod sparsesize = 0
			 then sp := sp^.next;
       for r := i+1 to rows do
		    begin
		       p := sp^.indx[1 + (r-1) mod sparsesize]^.val^.ncoef;
		       divide(p^, q^, dummy, modul);
				 if modul.head^.value = 0
					 then { nothing }
				 else if equal_to_pm1(modul, either)
							then begin
									  j := r;
									  leave
									end
				 else if first_time
						   then begin
									  j := r;
									  first_time := false;
									  num_assign(modul, key)
								  end
				 else if int_abs_bigger(key, modul, false)
						   then begin
									  j := r;
									  num_assign(modul, key)
								  end;
			    if r mod sparsesize = 0
			       then sp := sp^.next
		    end;
		   
		 free_num(dummy);
		 free_num(key);
	    free_num(modul)
			
    end;
    
	{***********************************************************************}
	
	function hash; {(x: nametype; prime: integer): integer;   moved Nov 2000 }
	
	  var i, val: integer;
		
		begin
		
		   val := 0;
		   for i := 1 to length(x) do
			    val := ( 123*val + ord(x[i]) ) mod prime;
				
			 hash := val
			 
		end;
	
 {**********************************************************************}
 
 function disper; {(n: longint): longint;}   { July 1998 }
 
    begin
        if n < 101
		     then disper := 1
		  else if n < 1001 
		     then disper := 5
		  else if n < 5001
		     then disper := 10
		  else disper := 50 
    end;
	
	{****************************************************************************}
	
	procedure eliminate_bads; {(var p, exps: poly; factor: longint)}
	
	  { Lowest 'bad' exponents in p (or former p) of each poly var are given by exps. 
		  Add through to clear all 'bad' exponents, or to return former 'bad' 
			exponents.  factor = -1 means clear bads; factor = 1 means return 
			previously cleared bads, or adjust this poly using bads constructed from another
			poly. 'bad' means either negative, or a least exponent not 0.
			  moved here Jan 2002, only this version. }
							
		 var t, q, s: poly;
				 needto: boolean;
				 copy: longint;
				 
		 {------------------------------------------------------------------}
		 
		 procedure pad_one(var p: poly; val: longint);			 
				begin					   
					 newpoly(p);
					 p^.numb := false;
					 p^.exp := val;
					 p^.next := s;
					 p^.pcoef := q;
					 q := p						 
				end;
				
		 {-------------------------------------------------------------------}
		 
		 procedure remove_q;
				begin  { q should now be a number }
					 if t = nil
							then p := q^.pcoef
							else t^.next := q^.pcoef;
					 q^.pcoef^.next := q^.next;
					 q^.next := polygarb;
					 polygarb := q;
					 q := q^.pcoef
				end;
				
		 {-------------------------------------------------------------------}
		 
		 begin 
	 
				q := p;
				needto := (exps^.exp <> 0);
				if needto
					 then copy := factor*exps^.exp;
				t := nil;  { trailer behind q }
				
				while q <> nil do
					 begin
							 if exps^.next <> nil  { take care of lower polys first }
							    then if q^.numb
									        then begin
													        s := q^.next;
																	q^.next := nil;
																	eliminate_bads(q, exps^.next, factor);
																	{ q can't be a number now. }
																	if t = nil  { means p = q }
																     then pad_one(p, 0)
																     else pad_one(t^.next, 0)
															 end
													else eliminate_bads(q^.pcoef, exps^.next, factor);
													
							 if needto  { do this level }
								  then if q^.numb
												  then begin
												          s := q^.next;
																  q^.next := nil;
																  if t = nil  { means p = q }
																     then pad_one(p, copy)
																     else pad_one(t^.next, copy)
															 end
												  else q^.exp := q^.exp + copy;
												 
								if (q^.exp = 0) & q^.pcoef^.numb & (q^.pcoef^.next = nil)
									 then remove_q;
															
							 t := q;
							 q := q^.next
						end
					 
		 end;
			 
 {*************************************************************************}
 
 procedure clear_bads; {(var p, exps, tail: poly; value: longint; depth: integer)}
 
    { Find lowest 'bad' exponents in p of each poly var above depth 'depth'. Check that
		  depth >= 2.  depth is either "infinity" or field_depth.  If depth < infinity
			then value is infinity.
			   [When called with value = 0 and depth = "infinity" (halfblock), this proc
			searches for the lowest negative exponents.  If there are no negative
			exponents, nothing will be done, and a bit of time is wasted.]
			   Then add through to clear all 'bad' exponents. Return list of exponents 
			found via exps and tail.  If no 'bad's were found, exps is nil, tail undefined. 
			   moved here Jan 2002, only this version. }
 
    var s, last: poly;
		    q: polypt;
				i: integer;  {~~~~ grab whole thing }
		
		{____________________________________________________________________}
	
	  procedure find_negs(p, exps: poly);
		
		   { Search for smallest negative exponents. If a variable is not present in
			   a node, can just move on. }
								
			 begin 
		 
				  repeat 
					   if not p^.numb
						    then if (not p^.pcoef^.numb) | (p^.pcoef^.next <> nil)
								        then find_negs(p^.pcoef, exps^.next);
						 if p^.next = nil
						    then leave
								else p := p^.next
					until false;
					
					if p^.exp < exps^.exp
					   then exps^.exp := p^.exp
						 
			 end;
			 
		{____________________________________________________________________}
	
	  procedure find_bads(p, exps: poly);
		
		   { Search EVERY node for lowest exponent of ALL variables at level of exps on 
			   down. If a variable is not present in a node, the implicit exp of 0 counts. }
								
			 var s: poly;
			 
			 begin 
		 
				  repeat 
					   if p^.numb
						    then begin
								        s := exps;
												while s <> nil do
													 begin
														  if s^.exp > 0
															   then s^.exp := 0;
														  s := s^.next
													 end
										 end
						    else if exps^.next <> nil   
								        then find_bads(p^.pcoef, exps^.next);
								
						 if p^.next = nil
						    then leave
								else p := p^.next
					until false;
					
					if p^.exp < exps^.exp
					   then exps^.exp := p^.exp
						 
			 end;
			 
		{_________________________________________________________________}
		
		begin { of clear_bads }
		
		   if depth = 0  { can only be in certain calls if field_depth = 0 }
			    then depth := halfblock;
					
			 { Create list of smallest exponents for each poly var, up to 'depth'.  Start by 
			   initializing list to 'value'. }
			 newpoly(exps);
			 tail := exps;
			 tail^.exp := value;
			 q := polynames^.next;
			 i := 2;
			 if i < depth
			    then while q <> nil do
									begin
										 newpoly(tail^.next);
										 tail := tail^.next;
										 tail^.exp := value;
										 q := q^.next;
										 Inc(i);
										 if i >= depth
										    then leave
									end;
			 tail^.next := nil;
			 			 
			 if value = 0
			    then find_negs(p, exps)
					else find_bads(p, exps);
			 
			 { identify deepest 'bad' with 'last'; then cut off list at that point. }
			 s := exps;
			 last := nil;
			 while s <> nil do
			    begin
					   if (s^.exp <> 0) & (s^.exp <> value)   
					      then last := s;
						 s := s^.next
					end;
			 if (last <> nil) & (last <> tail)
			    then begin
					        tail^.next := polygarb;
									polygarb := last^.next;
									last^.next := nil;
									tail := last
							 end;
			 
			 { If necessary, go through p making all exponents 'good'. }
			 if last = nil 
			    then begin
					        tail^.next := polygarb;
									polygarb := exps;
									exps := nil
							 end
					else eliminate_bads(p, exps, -1)
		   			 			 						
		end;
											 
 {**********************************************************************}
 
 procedure put_poly_disk; {(p: poly);   Jul 2001 }
 
    {    Virtual memory writer.
      ferstore is open.  We are correctly positioned and ready to write p. 
      2^31-1 is no longer a legal exponent for a poly.  Note use of flags
      negzero and two_to_31. 
         p^ is left unchanged.
         Is n^.lint always irrelevant if not lintmode? }
    
    procedure dump_numb(n: imptr);
       { Is n^.lint always irrelevant if not lintmode? }
       var h: numptr;
           i: integer;
       begin
          with n^ do
             if lintmode
	              then begin
	                      write(ferstore, longint(0));
	                      write(ferstore, lint)
	                   end
	              else begin
	                      write(ferstore, longint(size));
	                      h := head;
	                      for i := 1 to size do
	                         begin
	                            write(ferstore, h^.value);
	                            h := h^.next
	                         end
	                   end
       end;
       
    begin
    
       while p <> nil do
          begin
             if p^.numb
                then begin
                        write(ferstore, negzero);
                        dump_numb(p^.ncoef)
                     end
                else begin
                        write(ferstore, p^.exp);
                        put_poly_disk(p^.pcoef)
                     end;
             p := p^.next
          end;
       write(ferstore, two_to_31)    { stopping flag, actually 2^31 - 1 }
    
    end;
    
 {******************************************************************************}
 
 procedure get_poly_disk; {(var p: poly);   Jul 2001 }
 
    { inverse of above procedure.  Assume ferstore is ready for reading, and
      that there is a poly there to be read.  p is nil or irrelevant on input. 
      2^31-1 is no longer a legal exponent for a poly. }
    
    var value: longint;
        pp: polyptrr;
    
    procedure get_numb(n: imptr);
       { Is n^.lint always irrelevant if not lintmode? }
       var h: numptrptr;
           i: integer;
           val: longint;
       begin
          with n^ do
             begin
                read(ferstore, val);
                if val = 0  { lintmode }
		               then read(ferstore, lint)
		               else begin
		                       h := @ head;
		                       for i := 1 to size do
		                          begin
		                             newnode(h^);
		                             tail := h^;
		                             read(ferstore, tail^.value);
		                             h := @ tail^.next
		                          end;
		                       h^ := nil
		                    end;
		            size := val;
		            imag := nil
		         end
       end;
       
    begin
    
       pp := @ p;
       while true do
          begin
             read(ferstore, value);
             if value = two_to_31
                then leave;
             newpoly(pp^);
             if value = negzero
                then begin
                        pp^^.numb := true;
                        pp^^.exp := 0;
                        newimag(pp^^.ncoef);
                        get_numb(pp^^.ncoef)
                     end
                else begin
                        pp^^.numb := false;
                        pp^^.exp := value;
                        newpoly(pp^^.pcoef);
                        get_poly_disk(pp^^.pcoef)
                     end;
             pp := @ pp^^.next
          end;
       pp^ := nil
       
    end;
		
 {**********************************************************************************}
 
	procedure sort_vars; {(q: sort_ptr; size: integer)}
	
	   { Quicksort the 'size' stuff given by q. size <= sort_size. Used to sort vars,
	     arrays and funcs. }

     {____________________________________________________________________}
		 
		 procedure partition(var i,j,r: integer; var hit: boolean);
		 
		    var low, high, k: integer;
		        key: nametype;
				    temp, store: sortrec;
				
				begin
				
				   { find median of three }
					 k := (i+j) div 2;
					 if q^[i].name < q^[k].name
					    then if q^[j].name <= q^[i].name
							        then r := i
								      else if q^[j].name < q^[k].name
											        then r := j
															else r := k
							else if q^[j].name <= q^[k].name
							        then r := k
											else if q^[j].name >= q^[i].name
											        then r := i
															else r := j;
					 
					 key := q^[r].name;
					 store := q^[r];
					 low := i - 1;
					 high := j + 1;
					 hit := false;
					 while low < high do
					    begin
							   repeat
								    low := low + 1
								 until (q^[low].name > key) or (low = j);
								 repeat
								    high := high - 1
								 until (q^[high].name <= key) or (high = i);
								 if low < high
								    then begin
										        temp := q^[low];
														q^[low] := q^[high];
														q^[high] := temp
												 end;
							end;
					 if r <= high
							then begin
											q^[r] := q^[high];
											q^[high] := store;
											hit := true
									 end;
					 r := high
					 
				end;
				
		 {___________________________________________________________________}

     procedure quicksort(i,j: integer);
		 
		    var r, k: integer;
				    t: sortrec;
				    key: nametype;
						hit: boolean;
				
				begin

           if j >= i + 2
					    then begin
							        partition(i,j,r, hit);
											if hit
											   then begin
												         k := r;
																 key := q^[r].name;
																 while q^[k].name = key do
																    begin
																		   k := k - 1;
																			 if k < i
																			    then leave
																		end;
																 while q^[r].name = key do
																    begin
																		   r := r + 1;
																			 if r > j
																			    then leave
																		end;
																 quicksort(i, k);
																 quicksort(r, j)
															end
												 else begin  
																 quicksort(i,r);
											           quicksort(r+1,j)
															end
									 end
							else if j = i + 1
							        then if q^[i].name > q^[j].name
											        then begin
															        t := q^[i];
																			q^[i] := q^[j];
																			q^[j] := t
																	 end

        end;
				
		 {__________________________________________________________________}

     begin
		 
		    quicksort(1, size)
				
		 end;

 {******************************************************************************}
			
	procedure killdenoms; {(spar: sparseptr; spot, total_rows, target_rows, cols: longint);}
	
	   { new Jul 2002. Killden for arrays. }
	   
	   var i, k, diff: longint;
				 u: colm_ptr;
				 sp: sparseptr;
				 x: quolyptr;
		 
		 begin
	
				diff := total_rows - target_rows;
				if spar = nil
				   then for k := 1 to cols do
									 begin
											for i := 1 to target_rows do
												 begin
														x := @ arp[BSR(spot, 10)]^[BAND(spot, tenmask)];
											      if x^ = nil
												       then begin
													             quoly_set(0, x^);
													             Inc(uninit);  { Jul 2002 }
													             if uninit < 21
																          then writeln('Warning. Uninitialized array element has been set to 0.')
																          else if uninit = 21
																                  then writeln(' ....etc...')
														        end;
														if not x^^.numb
															 then begin
														           free_poly(x^^.denom);
																		   if x^^.numer^.numb and (x^^.numer^.next = nil)
																				  then polynum_to_quoly(x^)
														        end;
														Inc(spot)
												 end;
											spot := spot + diff
									 end
						else begin
						        sp := spar;  
									  for k := 0 to (total_rows - 1) div sparsesize do
											 begin
												  for i := 1 + k*sparsesize to (k+1)*sparsesize do
														 if i > total_rows 
															  then leave
														 else begin
																		 u := sp^.indx[i-k*sparsesize];
																		 while u <> nil do
																				begin
																					 if not u^.val^.numb
																							then begin
																					            free_poly(u^.val^.denom);
																									    if u^.val^.numer^.numb and (u^.val^.numer^.next = nil)
																											   then polynum_to_quoly(u^.val)
																					         end;
																					 u := u^.next;
																				end
																  end;
													sp := sp^.next
											end
								 end
											
	   end;
	   
{***************************************************************************}

function all_coefs_numb(u: poly; var  dpth: longint): boolean;  { Jul 2004 }
   { no laurents. u is not a number. }

  begin
     dpth := 0; { highest level poly }
     all_coefs_numb := false;
     while u^.exp = 0 do
       if not u^.numb
         then begin
                Inc(dpth);
                u := u^.pcoef
              end
         else
            fermat_error('bad number node in all_coefs_numb'); 

     while u <> nil do
	     if not u^.numb
	       then if u^.pcoef^.numb 
	               then u := u^.next
	               else exit(all_coefs_numb)
	       else u := u^.next;
	  all_coefs_numb := true
	  
  end;

{***************************************************************************}

function clean_degree; {(u: poly): longint;   Jul 2004 }
  { no laurents. }

  begin
  
	  if u^.numb
	     then begin
	             clean_degree := 0;
	             exit(clean_degree)
	          end;

	  while u^.exp = 0 do
	    if u^.numb
	       then fermat_error('bad number node in clean_degree')
	       else u := u^.pcoef;

	  clean_degree := u^.exp
  
  end;

{******************************************************************************}

function sparse_one_var_polys; { (sp:sparseptr; rows: longint): boolean; }
{  Jul 2004. no laurents. all entries must be one var polys at same depth. 
   Note: true is returned if all are numbs. }
 
  var i, k, depth, thisdpth: longint; 
      u: colm_ptr;
    
   begin
   
     depth := -1;
     sparse_one_var_polys := false;
  
	   for k := 0 to (rows - 1) div sparsesize do
	     begin
			    for i := 1 to sparsesize do
			      if i > rows
			        then leave
			      else begin
						        u := sp^.indx[i];
						        while u <> nil do
						          begin
							          if not u^.val^.numb 
							            then if u^.val^.denom = nil 
							              then if all_coefs_numb(u^.val^.numer, thisdpth)
							                then if depth = -1
							                    then depth := thisdpth
									                else begin
											                   if depth <> thisdpth
											                      then exit(sparse_one_var_polys)
									                     end
							                else exit(sparse_one_var_polys)           
							              else exit(sparse_one_var_polys);           
							          
							          u := u^.next;
						          end
			          end;
		      sp := sp^.next;
		      rows := rows - sparsesize
	     end;

	   sparse_one_var_polys := true
	  
  end;

  {**************************************************************************}
			
	procedure egcd_ints; {(var n, m, x, y: longint);}
	
	   {    n is both input and output.  At end n = gcd(n, m).  Jul 2004. 
	        find x and y such that n*x + m*y = gcd.  both inputs > 0. we assume no overflow
	        will occur.
	        Algorithm on p. 301 of Aho-Hopcroft-Ullman.  slight variation here in x0, xi, etc.}
	   
	   var x0, y0, pr, q, sw: longint;
	       flip: boolean;
	   
	   begin
	   
	      x0 := 0;
	      y := 0;
	      y0 := 1;
	      x := 1;
	      
	      if n > m
	         then begin
	                 sw := m;
	                 m := n;
	                 n := sw;
	                 flip := true
	              end
	         else flip := false;
        
	      { m >= n }
	      repeat
            q := m div n;
            m := m mod n;
            { m = remainder, q = quotient }
            if m = 0
               then leave;  { answer is n }
            pr := q * x;
            x0 := x0 - pr;
            sw := x0;
            x0 := x;
            x := sw;
            pr := q * y;
            y0 := y0 - pr;
            sw := y0;
            y0 := y;
            y := sw;
            sw := m;
            m := n;
            n := sw
	      until false;
	              	              
	      if flip
	         then begin
	                 sw := x;
	                 x := y;
	                 y := sw
	              end
	   
	   end;
	   
 {*************************************************************************}

 procedure parttion; {(var par: ptr_array; i, j: longint; var r: longint; var hit: boolean)}  { Jul 2004 }
  
  { j >= i+2. no ties among keys.
     hit means that key ends up being in the correct spot in the array }

  var low, high, k, key, temp: longint;

  begin
	  { find median of three }
	  k := (i + j) div 2;
	  if par[i] < par[k]
	    then if par[j] < par[i]
	            then r := i
	            else if par[j] < par[k]
	                   then r := j
	                   else r := k
	    else if par[j] < par[k]
	            then r := k
	            else if par[j] > par[i]
	                   then r := i
	                   else r := j;

	  key := par[r];

	  low := i - 1;
	  high := j + 1;
	  hit := false;
	  while low < high do
	    begin
	      repeat
	        Inc(low);
		    until par[low] > key;  { && low < j }
		    repeat
		      Dec(high);
		    until par[high] < key;
		    if low < high 
		      then begin
						      temp := par[low];
						      par[low] := par[high];
						      par[high] := temp
						   end
		  end;
	  if r <= high 
	    then begin
					    { the key belongs in spot high. high's current value is < key. }
					    par[r] := par[high];
					    par[high] := key;
					    hit := true
					 end;
	  r := high

 end;
  
{*************************************************************************}

procedure quiksort; {(var par: ptr_array; i, j: longint)  Jul 2004 }

  var r, k, key: longint;
      hit: boolean;

  begin
  
	  if j >= i + 2 
	    then begin
					    parttion(par, i, j, r, hit);
					    if hit 
					      then begin
									      k := r;
									      key := par[r];
									      while par[k] = key do
									        begin
									           Dec(k);
									           if k < i
									             then leave
									        end;
									      while par[r] = key do
									        begin
									           Inc(r);
									           if r > j
									             then leave
									        end;
									      quiksort(par, i, k);
									      quiksort(par, r, j)
									   end
							  else begin
									      quiksort(par, i, r);
									      quiksort(par, r+1, j)
									   end
	         end
	   else if j = i+1
				    then if par[i] > par[j]
							      then begin
											      key := par[i];
											      par[i] := par[j];
											      par[j] := key
											   end
    
  end;

{*************************************************************************}

procedure clean_up_colm;  { Jul 2004. makes a huge difference in execution time. }

  var sp, rest: colm_ptr;
      i, s: longint;

  begin
  
    sp := colm_garb;
	  s := 0;
	  while sp <> nil do
	    begin
	      if s = 200000
	        then leave;
	      colmar[s] := longint(sp);
	      sp := sp^.next;
	      Inc(s)
	    end;
	  
	  rest := sp;  { there may be more stuff on the garbage list }

	  quiksort(colmar, 0, s-1);

	  s := s-1;
	  if s >= 0 
	    then begin
					    sp := colm_ptr(colmar[0]);
					    for i := 1 to s do
					      begin
					        sp^.next := colm_ptr(colmar[i]);
					        sp := sp^.next
					      end;
					    sp^.next := rest;
					    colm_garb := colm_ptr(colmar[0])
					 end
					 
	end;

{****************************************************************************}

function its_a_square; {(n: longint): boolean;   Dec 2004 }
    { is n a square in Z/modulus?  modulus mod 4 = 3.  n <> 0. }

  var expont, i, last, m: longint;

  begin
	   
	  expont := (modulus-1) div 2;
	  m := n;
	  for i := 31 downto 0 do 
	    if BTST(expont, i)
	       then begin
	               last := i;
	               leave
	            end;
	  
	  for i := last - 1 downto 0 do
	     begin
	        m := modmult(m, m);
	        if BTST(expont, i)
	           then m := modmult(m, n)
	     end;
  
    its_a_square := (m = 1)
   
  end;
   
{****************************************************************************}

procedure mult_expons; { (p: poly, n: longint);   Feb 2005 }
   begin
      while (not p^.numb) and (p^.exp = 0) do
         p := p^.pcoef;
      while p <> nil do
         begin
            p^.exp := p^.exp * n;
            p := p^.next;
         end   
   end;

    
 end.